( function( $ ) {

	function fupi_add_link_to_notif (text) {

		let open_tag_pos = text.indexOf('{{'),
			close_tag_pos = text.indexOf('}}');

		if ( open_tag_pos != -1 && close_tag_pos != -1 ) {
			if ( window.fupi_temp_privacy_policy_page ) {
				text = text.replace( '{{', '<a href="javascript:void(0)">' );
				text = text.replace( '}}', '</a>' );
			} else {
				text = text.replace( '{{', '' );
				text = text.replace( '}}', '' );
			}
		}

		return text;
	}

	function fupi_fill_with_text (id, new_text, add_link = false) {
		var $el = $( id );
		if ( $el.length ){
			if ( new_text.length != 0 ) {
				if ( add_link ) {
					new_text = fupi_add_link_to_notif(new_text);
				};
				$el.html( new_text );
			} else {

				let cleanID = id.replace('#', ''),
					$default_text_wrapper = $( '#fupi_default_texts li[data-target=' + cleanID + ']' );

				if ( $default_text_wrapper.length ) {
					let default_text = $default_text_wrapper.text();

					if ( add_link ) {
						default_text = fupi_add_link_to_notif(default_text);
					};
					$el.html( default_text );
				}
			}
		}
	}

	function fupi_apply_style ( css_class, selector, el_style, style_val ) { // thx to: http://wpgothemes.com/add-customizer-color-pickers-for-hover-styles/

		let css 	= '<style class="'+ css_class +'">' + selector + '{ ' + el_style + ': ' + style_val + ' !important; }</style>';
			el 		=  $( '.' + css_class );

		if ( style_val ) {
			if ( el.length ) {
				el.replaceWith( css );
			} else {
				$( 'head' ).append( css );
			}
		} else {
			$( '.' + css_class ).remove();
		}
	}

	function fupi_border_style ( style ) {

		let css = '',
		 	css_open = '<style class="fupi_border_style">.fupi_panel{ ',
		 	css_close = ' !important; }</style>',
			css_el = $( '.fupi_border_style' );

		switch ( style ) {
			case 'none':
				css = css_open + 'box-shadow: none !important; border-width: 0 !important;' + css_close;
			break;
			case 'small_shadow':
				css = css_open + 'box-shadow: 2px 3px 7px rgba(0,0,0,.2) !important; border-width: 0 !important;' + css_close;
			break;
			case 'large_shadow':
				css = css_open + 'box-shadow: 5px 7px 17px rgba(0,0,0,.2) !important; border-width: 0 !important;' + css_close;
			break;
			case 'thin_border':
				css = css_open + 'box-shadow: none !important; border-width: 1px !important; border-style: solid;' + css_close;
			break;
			case 'wide_border':
				css = css_open + 'box-shadow: none !important; border-width: 4px !important; border-style: solid;' + css_close;
			break;
		}

		if ( css_el.length ) {
			css_el.replaceWith( css )
		} else {
			$( 'head' ).append( css );
		}
	}

	// SHOW / HIDE NOTICE WHEN THE SETTINGS SECTION IS OPENED / CLOSED

    wp.customize.bind( 'preview-ready', function() {
    	wp.customize.preview.bind( 'fupi_open_notice', function( expand ) {

			let $notice_els = $('#fupi_cookie_notice, #fupi_welcome_panel'),
				html_el = document.getElementsByTagName( 'html' )[0];

			if ( expand ) {

				// show notice
				$notice_els.removeClass( 'fupi_fadeOutDown fupi_hidden' );
				$notice_els.addClass( 'fupi_fadeInUp fupi_animated' );

				// add blur
				if ( html_el.classList.contains('fupi_blur_added') || ! html_el.classList.contains('fupi_blur_removed') && fp.notice.blur_page ) {
					html_el.classList.remove('fupi_blur_out');
					html_el.classList.add('fupi_blur');
				}

				

			} else {

				// hide notice
				$notice_els.removeClass( 'fupi_fadeInUp' );
				$notice_els.addClass( 'fupi_fadeOutDown' );

				// remove blur
				if ( html_el.classList.contains('fupi_blur') ){
					html_el.classList.remove('fupi_blur');
					html_el.classList.add('fupi_blur_out');
				}

				
			}
    	} );
    } );

	// POSITION

	wp.customize( 'fupi_cookie_notice[position]',
	function( value ) {
		value.bind( function( newval ) {
			$( '#fupi_cookie_notice' ).attr( 'data-position', newval);
		} );
	} );

	// OVERLAY
	// fupi_cookie_notice[btn_class]

	wp.customize( 'fupi_cookie_notice[overlay]',
	function( value ) {
		value.bind( function( newval ) {
			if ( newval ) {
				$( '#fupi_cookie_notice' ).addClass('fupi_notice_gradient_overlay');
			} else {
				$( '#fupi_cookie_notice' ).removeClass('fupi_notice_gradient_overlay');
			}
		} );
	} );

	

	// BLUR
	// fupi_cookie_notice[btn_class]

	wp.customize( 'fupi_cookie_notice[blur_page]',
	function( value ) {
		value.bind( function( newval ) {

			let html_el = document.getElementsByTagName( 'html' )[0];

			if ( newval ) {
				html_el.classList.remove('fupi_blur_removed');
				html_el.classList.remove('fupi_blur_out');
				html_el.classList.add('fupi_blur_added');
				html_el.classList.add('fupi_blur');
			} else {
				setTimeout( () => {
					html_el.classList.remove('fupi_blur_added');
					html_el.classList.remove('fupi_blur');
					html_el.classList.add('fupi_blur_removed');
					html_el.classList.add('fupi_blur_out');
				}, 300 );
			}
		} );
	} );

	// BUTTON CONFIGURATION

	wp.customize( 'fupi_cookie_notice[btn_config]',
	function( value ) {
		value.bind( function( newval ) {
			$( '#fupi_cookie_notice' ).attr( 'data-btn_config', newval);
		} );
	} );

	// HIDE STUFF
	// fupi_cookie_notice[hide]

	wp.customize( 'fupi_cookie_notice[hide]',
	function( value ) {
		value.bind( function( newval ) {

			var decline_btn_display 	= newval.indexOf('decline_btn') != -1 ? 'none' : 'block',
				settings_btn_display 	= newval.indexOf('settings_btn') != -1 ? 'none' : 'block',
				stats_sect_display 		= newval.indexOf('stats') != -1 ? 'none' : 'block',
				market_sect_display 	= newval.indexOf('market') != -1 ? 'none' : 'block',
				pers_sect_display 		= newval.indexOf('pers') != -1 ? 'none' : 'block',
				poweredby_display 		= newval.indexOf('powered_by') != -1 ? 'block' : 'none';

			$('#fupi_decline_cookies_btn').css('display', decline_btn_display);
			$('#fupi_cookie_settings_btn').css('display', settings_btn_display);
			$('#fupi_stats_section').css('display', stats_sect_display);
			$('#fupi_market_section').css('display', market_sect_display);
			$('#fupi_pers_section').css('display', pers_sect_display);
			$('.fupi_poweredBy').css('display', poweredby_display);

		} );
	} );

	// BUTTON CLASS
	// fupi_cookie_notice[btn_class]

	wp.customize( 'fupi_cookie_notice[btn_class]',
	function( value ) {
		value.bind( function( newval ) {
			$( '.fupi_button' ).each(function(){
				let btn = $(this);
				btn.attr('class', btn.attr('data-classes') + ' ' + newval );
			})
		} );
	} );

	// CTA CLASS
	// fupi_cookie_notice[cta_class]

	wp.customize( 'fupi_cookie_notice[cta_class]',
	function( value ) {
		value.bind( function( newval ) {
			$( '.fupi_cta' ).each(function(){
				let btn = $(this);
				btn.attr('class', btn.attr('data-classes') + ' ' + newval );
			})
		} );
	} );

	// COLORS

	wp.customize( 'fupi_notice_bg_color',
	function( value ) {
		value.bind( function( color ) {
			$( '.fupi_panel' ).css( 'background-color', color );
		} );
	} );

	wp.customize( 'fupi_notice_h_color',
	function( value ) {
		value.bind( function( color ) {
			$( '#fupi_cookie_notice h3' ).css( 'color', color );
		} );
	} );

	wp.customize( 'fupi_notice_text_color',
	function( value ) {
		value.bind( function( color ) {
			$( '#fupi_cookie_notice' ).css( 'color', color );
		} );
	} );

	wp.customize( 'fupi_notice_btn_color',
	function( value ) {
		value.bind( function( color ) {
			$( '.fupi_button' ).css( 'background-color', color );
		} );
	} );

	wp.customize( 'fupi_notice_btn_color_hover',
	function( value ) {
		value.bind( function( color ) {
			fupi_apply_style('fupi_notice_btn_color_hover', '.fupi_button:hover', 'background-color', color);
		} );
	} );

	wp.customize( 'fupi_notice_btn_txt_color',
	function( value ) {
		value.bind( function( color ) {
			$( '.fupi_button' ).css( 'color', color );
		} );
	} );

	wp.customize( 'fupi_notice_btn_txt_color_hover',
	function( value ) {
        value.bind( function( color ) {
			fupi_apply_style('fupi_notice_btn_txt_color_hover', '.fupi_button:hover', 'color', color);
        } );
    } );

	wp.customize( 'fupi_notice_cta_color',
	function( value ) {
		value.bind( function( color ) {
			$( '.fupi_buttons .fupi_cta' ).css( 'background-color', color );
		} );
	} );

	wp.customize( 'fupi_notice_cta_color_hover',
	function( value ) {
		value.bind( function( color ) {
			fupi_apply_style('fupi_notice_cta_color_hover', '.fupi_cta:hover', 'background-color', color);
		} );
	} );

	wp.customize( 'fupi_notice_cta_txt_color',
	function( value ) {
		value.bind( function( color ) {
			$( '.fupi_buttons .fupi_cta' ).css( 'color', color );
		} );
	} );

	wp.customize( 'fupi_notice_cta_txt_color_hover',
	function( value ) {
        value.bind( function( color ) {
			fupi_apply_style('fupi_notice_cta_txt_color_hover', '.fupi_cta:hover', 'color', color);
        } );
    } );

	wp.customize( 'fupi_notice_switch_color',
	function( value ) {
		value.bind( function( color ) {
			fupi_apply_style('fupi_notice_switch_color', 'input:checked+.fupi_slider', 'background-color', color);
		} );
	} );

	wp.customize( 'fupi_cookie_notice_border',
	function( value ) {
        value.bind( function( style ) {
			fupi_border_style( style );
        } );
    } );

	wp.customize( 'fupi_notice_border_color',
	function( value ) {
        value.bind( function( color ) {
			fupi_apply_style('fupi_notice_border_color', '.fupi_panel', 'border-color', color);
        } );
    } );

	// PRIVACY PAGE ID

	wp.customize( 'fupi_cookie_notice[privacy_page_id]',
	function( value ) {
		value.bind( function( page_id ) {
			// get current, unmodified text
			var current_text = window.fupi_temp_main_descr ? window.fupi_temp_main_descr : document.querySelector('#fupi_default_texts li[data-target="fupi_main_descr"]').innerText;

			// remember if privacy policy page was chosen
			window.fupi_temp_privacy_policy_page = page_id != 0 ? true : false;

			// fill text
			fupi_fill_with_text('#fupi_main_descr', current_text, true);
		} )
	} );

	// TEXTS

	wp.customize( 'fupi_cookie_notice[notif_text]',
	function( value ) {
		value.bind( function( new_text ) {
			// save unmodified text - with "{{"
			window.fupi_temp_main_descr = new_text;
			// add text to HTML
			fupi_fill_with_text('#fupi_main_descr', new_text, true);
		} );
	} );

	wp.customize( 'fupi_cookie_notice[agree_text]',
	function( value ) {
		value.bind( function( new_text ) {
			fupi_fill_with_text('#fupi_agree_to_all_cookies_btn', new_text);
		} );
	} );

	wp.customize( 'fupi_cookie_notice[agree_to_selected_text]',
	function( value ) {
		value.bind( function( new_text ) {
			fupi_fill_with_text('#fupi_agree_to_selected_cookies_btn', new_text);
		} );
	} );

	wp.customize( 'fupi_cookie_notice[return_text]',
	function( value ) {
		value.bind( function( new_text ) {
			fupi_fill_with_text('#fupi_return_btn', new_text);
		} );
	} );

	wp.customize( 'fupi_cookie_notice[decline_text]',
	function( value ) {
		value.bind( function( new_text ) {
			fupi_fill_with_text('#fupi_decline_cookies_btn', new_text);
		} );
	} );

	wp.customize( 'fupi_cookie_notice[cookie_settings_text]',
	function( value ) {
		value.bind( function( new_text ) {
			fupi_fill_with_text('#fupi_cookie_settings_btn', new_text);
		} );
	} );

	wp.customize( 'fupi_cookie_notice[stats_headline_text]',
	function( value ) {
		value.bind( function( new_text ) {
			fupi_fill_with_text('#fupi_stats_headline', new_text);
		} );
	} );

	wp.customize( 'fupi_cookie_notice[stats_text]',
	function( value ) {
		value.bind( function( new_text ) {
			fupi_fill_with_text('#fupi_stats_descr', new_text);
		} );
	} );

	wp.customize( 'fupi_cookie_notice[pers_headline_text]',
	function( value ) {
		value.bind( function( new_text ) {
			fupi_fill_with_text('#fupi_pers_headline', new_text);
		} );
	} );

	wp.customize( 'fupi_cookie_notice[pers_text]',
	function( value ) {
		value.bind( function( new_text ) {
			fupi_fill_with_text('#fupi_pers_descr', new_text);
		} );
	} );

	wp.customize( 'fupi_cookie_notice[marketing_headline_text]',
	function( value ) {
		value.bind( function( new_text ) {
			fupi_fill_with_text('#fupi_market_headline', new_text);
		} );
	} );

	wp.customize( 'fupi_cookie_notice[marketing_text]',
	function( value ) {
		value.bind( function( new_text ) {
			fupi_fill_with_text('#fupi_market_descr', new_text);
		} );
	} );

} )( jQuery );
