<?php

switch( $a['id'] ){

    // BASIC CONFIG

	case 'fupi_clar_basic':
		return '<p class="fupi_subtitle">' . esc_html__( 'Start using Microsoft Clarity on your site', 'fupi' ) . '</p>';
	break;

	// TAGS

	case 'fupi_clar_tags':
		return '<p class="fupi_subtitle">' . esc_html__( 'Tag your recordings with user actions. Tags are used to filter recordings in Clarity\'s dashboard', 'fupi' ) . '</p>';
	break;

	// E-COMMERCE

	case 'fupi_clar_ecomm':

		$output = '<p class="fupi_subtitle">' . esc_html__( 'Tag recordings with e-commerce events', 'fupi' ) . '</p>' . $help_start . '
		<h3>' . esc_html__( 'How does it work', 'fupi' ) . '</h3>
		<p>' . sprintf( esc_html__( 'Full Picture tags recordings according to e-commerce events that take place on your site (checkouts, purchases, add-to-cart\'s and more). %1$sSee the full list here%2$s.', 'fupi' ), '<a href="https://fullpictureplugin.com/?p=4734&utm_source=useradmin&utm_medium=settings&utm_campaign=settings_link" target="_blank">', '</a>' ). '</p>
		<h3>' . esc_html__( 'How to enable e-commerce tagging', 'fupi' ) . '</h3>' .
		'<ol class="fupi_list_steps">
			<li>' . sprintf(
				esc_html__( 'Enable the integration with your e-commerce plugin %1$son this page%2$s. If it is not on the list (or you are not using a plugin) use %3$sFull Picture\'s custom events%4$s;', 'fupi' ),
				'<a href="?page=full_picture_tools" target="_blank">',
				'</a>',
				'<a href="https://fullpictureplugin.com/?p=797&utm_source=useradmin&utm_medium=settings&utm_campaign=settings_link" target="_blank">',
				'</a>'
			) . '</li>
			<li>' . sprintf( esc_html__( 'Configure the %1$sglobal tracking settings%2$s for your plugin.', 'fupi' ), '<a href="?page=full_picture_main" target="_blank">', '</a>' ) . '</li>
		</ol>' . $help_end;

		// If woocommerce is enabled
		if ( ! $this->is_woo_enabled ) {
			$output .= '<p class="fupi_highlight">' .  sprintf( esc_html__( 'WooCommerce tracking is %1$sdisabled%2$s. Please make sure that you are using WooCommerce in version 3.7 or later and you enabled WooCommerce data source.', 'fupi' ), '<strong style="color: red;">', '</strong>' ) . '</p>';
		} else {
			$output .= '<p class="fupi_highlight"><span class="dashicons dashicons-yes"></span> ' . sprintf( esc_html__( 'WooCommerce tracking is %1$senabled%2$s. No other actions are necessary. Tags will be sent automaticaly.', 'fupi' ), '<strong style="color: green;">', '</strong>' ) . '</p>';
		};

		return $output;
	break;

	// DEPRECATED

	case 'fupi_clar_deprec':
		return '<p class="fupi_subtitle">' . esc_html__( 'These functions will be removed in the future update of Full Picture', 'fupi' ) . '</p>';
	break;

    default:
        return '';
    break;
};

?>
