<?php

switch( $a['id'] ){

	// BASIC CONFIG

	case 'fupi_fbp1_main':
		return '<p class="fupi_subtitle">' . esc_html__( 'Use Facebook Pixel on your site', 'fupi' ) . '</p>';
	break;

	// CLICK TRACKING

	case 'fupi_fbp1_clicks':
		return '<p class="fupi_subtitle">' . esc_html__( 'Track clicks on important links and page elements', 'fupi' ) . '</p>';
	break;

	// FORM TRACKING

	case 'fupi_fbp1_forms':
		return '<p class="fupi_subtitle">' . esc_html__( 'Track when your visitors submit forms on your site', 'fupi' ) . '</p>';
	break;

	// SCROLL TRACKING

	case 'fupi_fbp1_scroll':
		return '<p class="fupi_subtitle">' . esc_html__( 'Track what your visitors saw on your site', 'fupi' ) . '</p>';
	break;

	// WP DATA

	case 'fupi_fbp1_wpdata':
		return '<p class="fupi_subtitle">' . esc_html__( 'Track data from your WordPress site', 'fupi' ) . '</p>';
	break;

	// USER INFO

	case 'fupi_fbp1_user':
		return '<p class="fupi_subtitle">' . esc_html__( 'Track user information', 'fupi' ) . '</p>';
	break;

	// TRACK ENGAGEMENT TIME

	case 'fupi_fbp1_engage':
		return '<p class="fupi_subtitle">' . esc_html__( 'Track user engagement time', 'fupi' ) . '</p>';
	break;

	// E-COMMERCE

	case 'fupi_fbp1_ecomm':

		$output = '<p class="fupi_subtitle">' . esc_html__( 'Track e-commerce events', 'fupi' ) . '</p>' . $help_start . '
		<h3>' . esc_html__( 'What you can track', 'fupi' ) . '</h3>
		<p>' . sprintf( esc_html__( 'Full Picture can track a number of e-commerce events like checkouts, purchases, product views, additing products to cart and more. %1$sSee the full list here%2$s.', 'fupi' ), '<a href="https://fullpictureplugin.com/?p=4734&utm_source=useradmin&utm_medium=settings&utm_campaign=settings_link" target="_blank">', '</a>' ). '</p>
		<h3>' . esc_html__( 'How to enable e-commerce tracking for Facebook Pixel', 'fupi' ) . '</h3>
		<ol class="fupi_list_steps">
			<li>' . sprintf(
				esc_html__( 'Enable the integration with your e-commerce plugin %1$son this page%2$s. If it is not on the list (or you are not using a plugin) use %3$sFull Picture\'s custom events%4$s;', 'fupi' ),
				'<a href="?page=full_picture_tools" target="_blank">',
				'</a>',
				'<a href="https://fullpictureplugin.com/?p=797&utm_source=useradmin&utm_medium=settings&utm_campaign=settings_link" target="_blank">',
				'</a>'
			) . '</li>
			<li>' . sprintf( esc_html__( 'Configure the %1$sglobal tracking settings%2$s for your plugin.', 'fupi' ), '<a href="?page=full_picture_main" target="_blank">', '</a>' ) . '</li>
		</ol>' . $help_end;

		// If woocommerce is enabled
		if ( ! $this->is_woo_enabled ) {
			$output .= '<p class="fupi_highlight">' .  sprintf( esc_html__( 'WooCommerce integration is %1$sdisabled%2$s. Please make sure that you are using WooCommerce in version 3.7 or later and you enabled WooCommerce data source.', 'fupi' ), '<strong style="color: red;">', '</strong>' ) . '</p>';
		} else {
			$output .= '<p class="fupi_highlight"><span class="dashicons dashicons-yes"></span> ' . sprintf( esc_html__( 'WooCommerce integration is %1$senabled%2$s. No other actions are necessary. E-commerce events will be tracked automaticaly.', 'fupi' ), '<strong style="color: green;">', '</strong>' ) . '</p>';
		};

		return $output;

	break;

    default:
        return '';
    break;
};

?>
