<?php

switch( $a['id'] ){

	// BASIC CONFIG

	case 'fupi_ga1_basic':
		return '<p class="fupi_subtitle">' . esc_html__( 'Connect Google Analytics Universal Analytics to your site', 'fupi' ) . '</p>' .
		$help_start . '
			<p><strong>Attention!</strong> ' . sprintf( esc_html__( 'If you are using GA Universal Analytics alongside GA 4 please make sure that they are not connected in your Google Analytics dashboard. %1$sLearn more%2$s', 'fupi' ), '<a href="https://fullpictureplugin.com/?p=2268&utm_source=useradmin&utm_medium=settings&utm_campaign=settings_link" target="_blank">', '</a>' ) . '</p>' .
		$help_end;
	break;

	// ADVANCED CONFIG

	case 'fupi_ga1_advanced':
		return '<p class="fupi_subtitle">' . esc_html__( 'Advanced options', 'fupi' ) . '</p>';
	break;

	// CLICK TRACKING

	case 'fupi_ga1_clicks':
		return '<p class="fupi_subtitle">' . esc_html__( 'Track clicks on important links and page elements', 'fupi' ) . '</p>';
	break;

	// FORM TRACKING

	case 'fupi_ga1_forms':
		return '<p class="fupi_subtitle">' . esc_html__( 'Track when your visitors submit forms on your site', 'fupi' ) . '</p>';
	break;

	// SCROLL TRACKING

	case 'fupi_ga1_scrolls':
		return '<p class="fupi_subtitle">' . esc_html__( 'Track what your visitors saw on your site', 'fupi' ) . '</p>';
	break;

	// URL TRACKING

	case 'fupi_ga1_urls':
		return '<p class="fupi_subtitle">' . esc_html__( 'Track changes of page url', 'fupi' ) . '</p>';
	break;

	// WP DATA TRACKING

	case 'fupi_ga1_wpdata':
		return '<p class="fupi_subtitle">' . esc_html__( 'Track data from your WordPress site', 'fupi' ) . '</p>' .
		$help_start . '
			<p>' . esc_html__( 'To have this information available in GA you need to register custom dimensions in your Google Analytics admin panel.', 'fupi' ) . '</p>
			<p><a href="https://www.youtube.com/watch?v=M_zQr6pcNk4" class="fupi_vid_link fupi_vid" data-srcid="M_zQr6pcNk4"><i class="dashicons dashicons-youtube"></i> <span>How to register custom definitions in GA UA (3:07 min)</span></a></p>' .
		$help_end;
	break;

	// CUSTOM METRICS

	case 'fupi_ga1_custom_metrics':
		return '<p class="fupi_subtitle">' . esc_html__( 'Track user engagement time and on-site search', 'fupi' ) . '</p>' .
		$help_start . '
			<p>' . esc_html__( 'To have this information available in GA you need to register custom metric in your Google Analytics admin panel.', 'fupi' ) . '</p>
			<p><a href="https://www.youtube.com/watch?v=M_zQr6pcNk4" class="fupi_vid_link fupi_vid" data-srcid="M_zQr6pcNk4"><i class="dashicons dashicons-youtube"></i> <span>How to register custom definitions in GA UA (3:07 min)</span></a></p>' .
		$help_end;
	break;

	// CUSTOM CONTENT GROUPING

	case 'fupi_ga1_custom_grouping':
		return '<p class="fupi_subtitle">' . esc_html__( 'Analyze groups of similar pages', 'fupi' ) . '</p>' .
		$help_start . '
			<p>' . esc_html__( 'To have this information available in GA you need to register custom grouping in your Google Analytics admin panel.', 'fupi' ) . '</p>
			<p><a href="https://www.youtube.com/watch?v=M_zQr6pcNk4" class="fupi_vid_link fupi_vid" data-srcid="M_zQr6pcNk4"><i class="dashicons dashicons-youtube"></i> <span>How to register custom definitions in GA UA (3:07 min)</span></a></p>' .
		$help_end;
	break;

	// ERROR TRACKING

	case 'fupi_ga1_errors':
		return '<p class="fupi_subtitle">' . esc_html__( 'Track JavaScript errors', 'fupi' ) . '</p>' .
		 $help_start . '
		 	<p>' . esc_html__( 'Send to Google Analytics events when JavaScript errors occur on your site. Events are labeled with error descriptions. Use with caution! If your site has many errors, the number of events may exceed Google Analytics limit.', 'fupi' ) . '</p>
			<p>' . esc_html__( 'To have this information available in GA you need to register custom grouping in your Google Analytics admin panel.', 'fupi' ) . '</p>
			<p><a href="https://www.youtube.com/watch?v=M_zQr6pcNk4" class="fupi_vid_link fupi_vid" data-srcid="M_zQr6pcNk4"><i class="dashicons dashicons-youtube"></i> <span>How to register custom definitions in GA UA (3:07 min)</span></a></p>' .
		$help_end;
	break;

	// E-COMMERCE

	case 'fupi_ga1_ecomm':

		$output = '<p class="fupi_subtitle">' . esc_html__( 'Track e-commerce events', 'fupi' ) . '</p>' .
		$help_start . '
			<h3>' . esc_html__( 'What you can track', 'fupi' ) . '</h3>
			<p>' . sprintf( esc_html__( 'Full Picture can track a number of e-commerce events like checkouts, purchases, product views, list item views and more. %1$sSee the full list here%2$s.', 'fupi' ), '<a href="https://fullpictureplugin.com/?p=4734&utm_source=useradmin&utm_medium=settings&utm_campaign=settings_link" target="_blank">', '</a>' ). '</p>
			<h3>' . esc_html__( 'How to enable e-commerce tracking for Google Analytics', 'fupi' ) . '</h3>
			<ol class="fupi_list_steps">
				<li>' . sprintf(
					esc_html__( 'Enable the integration with your e-commerce plugin %1$son this page%2$s. If it is not on the list (or you are not using a plugin) use %3$sFull Picture\'s custom events%4$s;', 'fupi' ),
					'<a href="?page=full_picture_tools" target="_blank">',
					'</a>',
					'<a href="https://fullpictureplugin.com/?p=797&utm_source=useradmin&utm_medium=settings&utm_campaign=settings_link" target="_blank">',
					'</a>'
				) . '</li>
				<li>' . sprintf( esc_html__( 'Configure the %1$sglobal tracking settings%2$s for your plugin;', 'fupi' ), '<a href="?page=full_picture_main" target="_blank">', '</a>' ) . '</li>
				<li>' . sprintf( esc_html__( 'Enable Enchanced Ecommerce tracking in your Google Analytics dashboard (%1$sRead guide%2$s).', 'fupi' ), '<a href="https://support.google.com/analytics/answer/6032539?hl=en">', '</a>' ) . '</li>
			</ol>' .
		$help_end;

		// If woocommerce is enabled
		if ( ! $this->is_woo_enabled ) {
			$output .= '<p class="fupi_highlight">' .  sprintf( esc_html__( 'WooCommerce tracking status: %1$sdisabled%2$s. Please make sure that you are using WooCommerce in version 3.7 or later and you enabled WooCommerce data source in "data sources" tab above.', 'fupi' ), '<strong style="color: red;">', '</strong>' ) . '</p>';
		} else {
			$output .= '<p class="fupi_highlight">' . sprintf( esc_html__( 'WooCommerce tracking status: %1$senabled%2$s', 'fupi' ), '<strong style="color: green;">', '</strong>' ) . '</p>';
		};

		return $output;

	break;

	// DEPRECATED

	case 'fupi_ga1_deprecated':
		return '<p class="fupi_subtitle">' . esc_html__( 'These functions are scheduled for removal in future updates', 'fupi' ) . '</p>';
	break;

    default:
        return '';
    break;
};

?>
