<?php

$register_custom_data_in_ga_txt = '<p>' . sprintf ( esc_html__( 'To see this custom data in Google Analytics reports you need to register their names (highlighted below) in Google Analytics panel. %1$sLearn how to do it (1:42 min)%2$s', 'fupi' ), '<br><a href="https://www.youtube.com/watch?v=vUbSZTolS48" class="fupi_vid_link fupi_vid" data-srcid="vUbSZTolS48"><i class="dashicons dashicons-youtube"></i> <span>','</span></a>' ) . '</p>';

switch( $a['id'] ){

    // BASIC CONFIG

	case 'fupi_ga41_basic':
		return '<p class="fupi_subtitle">' . esc_html__( 'Connect Google Analytics 4 to your site', 'fupi' ) . '</p>' .
		$help_start . '
            <p><strong>Attention</strong> ' . sprintf( esc_html__( 'If you are using GA Universal Analytics alongside GA 4 please make sure that they are not connected in your Google Analytics dashboard. %1$sLearn more%2$s', 'fupi' ), '<a href="https://fullpictureplugin.com/?p=2268&utm_source=useradmin&utm_medium=settings&utm_campaign=settings_link" target="_blank">', '</a>' ) . '</p>' .
		$help_end;
	break;

	// CLICK TRACKING
	case 'fupi_ga41_clicks':
		return '<p class="fupi_subtitle">' . esc_html__( 'Track clicks on important links and page elements', 'fupi' ) . '</p>' .
		$help_start . $register_custom_data_in_ga_txt . $help_end;
	break;

	// FORM TRACKING

	case 'fupi_ga41_forms':
		return '<p class="fupi_subtitle">' . esc_html__( 'Track when your visitors submit forms on your site', 'fupi' ) . '</p>' .
		$help_start . $register_custom_data_in_ga_txt . $help_end;
	break;

	// SCROLL TRACKING

	case 'fupi_ga41_scrolls':
		return '<p class="fupi_subtitle">' . esc_html__( 'Track what your visitors saw on your site', 'fupi' ) . '</p>' .
		$help_start . $register_custom_data_in_ga_txt . $help_end;
	break;

	// WP DATA TRACKING

	case 'fupi_ga41_wpdata':
		return '<p class="fupi_subtitle">' . esc_html__( 'Track data from your WordPress site', 'fupi' ) . '</p>' .
		$help_start . $register_custom_data_in_ga_txt . $help_end;
	break;

	// CUSTOM METRICS

	case 'fupi_ga41_custom_metrics':
		return '<p class="fupi_subtitle">' . esc_html__( 'Track user engagement time and on-site search', 'fupi' ) . '</p>' .
		$help_start . $register_custom_data_in_ga_txt . $help_end;
	break;

	// ERROR TRACKING

	case 'fupi_ga41_errors':
		return '<p class="fupi_subtitle">' . esc_html__( 'Track JavaScript errors', 'fupi' ) . '</p>' .
		 $help_start . '
		 	<p>' . esc_html__( 'Send to Google Analytics descriptions of JavaScript errors that occur on your site. Use with caution! If your site has many errors, the number of events may exceed Google Analytics limit. Events descriptions are capped to 100 characters (Google\'s limit).', 'fupi' ) . '</p>' . $register_custom_data_in_ga_txt .
		$help_end;
	break;

	// OTHER

	case 'fupi_ga41_other':
		return '<p class="fupi_subtitle">' . esc_html__( 'Test your events in Google Analytics dashboard.', 'fupi' ) . '</p>';
	break;

	// E-COMMERCE

	case 'fupi_ga41_ecomm':

		$output = '<p class="fupi_subtitle">' . esc_html__( 'Track e-commerce events', 'fupi' ) . '</p>' . $help_start . '
		<h3>' . esc_html__( 'What you can track', 'fupi' ) . '</h3>
		<p>' . sprintf( esc_html__( 'Full Picture can track a number of e-commerce events like checkouts, purchases, product views, list item views and more. %1$sSee the full list here%2$s.', 'fupi' ), '<a href="https://fullpictureplugin.com/?p=4734&utm_source=useradmin&utm_medium=settings&utm_campaign=settings_link" target="_blank">', '</a>' ). '</p>
		<h3>' . esc_html__( 'How to enable e-commerce tracking for Google Analytics 4', 'fupi' ) . '</h3>
		<ol class="fupi_list_steps">
			<li>' . sprintf(
				esc_html__( 'Enable the integration with your e-commerce plugin %1$son this page%2$s. If it is not on the list (or you are not using a plugin) use %3$sFull Picture\'s custom events%4$s;', 'fupi' ),
				'<a href="?page=full_picture_tools" target="_blank">',
				'</a>',
				'<a href="https://fullpictureplugin.com/?p=797&utm_source=useradmin&utm_medium=settings&utm_campaign=settings_link" target="_blank">',
				'</a>'
			) . '</li>
			<li>' . sprintf( esc_html__( 'Configure the %1$sglobal tracking settings%2$s for your plugin.', 'fupi' ), '<a href="?page=full_picture_main" target="_blank">', '</a>' ) . '</li>
		</ol>' . $help_end;

		// If woocommerce is enabled
		if ( ! $this->is_woo_enabled ) {
			$output .= '<p class="fupi_highlight">' .  sprintf( esc_html__( 'WooCommerce tracking status: %1$sdisabled%2$s. Please make sure that you are using WooCommerce in version 3.7 or later and you enabled WooCommerce data source in "data sources" tab above.', 'fupi' ), '<strong style="color: red;">', '</strong>' ) . '</p>';
		} else {
			$output .= '<p class="fupi_highlight">' . sprintf( esc_html__( 'WooCommerce tracking status: %1$senabled%2$s No other actions are required. Tracking is automatic.', 'fupi' ), '<strong style="color: green;">', '</strong>' ) . '</p>';
		};

		return $output;

	break;

	// DEPRECATED

	case 'fupi_ga41_deprecated':
		return '<p class="fupi_subtitle">' . esc_html__( 'These functions are scheduled for removal in future updates', 'fupi' ) . '</p>';
	break;

    default:
        return '';
    break;
};

?>
