<?php

switch( $a['id'] ){

	// BASIC CONFIG

	case 'fupi_hotj_basic':
		return '<p class="fupi_subtitle">' . esc_html__( 'Connect Hotjar to your site', 'fupi' ) . '</p>';
	break;

	// TAGS

	case 'fupi_hotj_tags':
		return '<p class="fupi_subtitle">' . esc_html__( 'Tag your recordings for easy search and filtering in your hotjar\'s dashboard', 'fupi' ) . '</p>' .
		$help_start . '
			<h3>' . esc_html( 'What you need to know', 'fupi' ) . '</h3>
			<ul>
				<li>' . esc_html__( 'Tagging screen recordings is available in Hotjar paid plans.', 'fupi' ) . '</li>
				<li>' . esc_html__( 'One recording can have NO MORE than 50 tags associated with it. Tags over this limit will be ignored.', 'fupi' ) . '</li>
				<li>' . esc_html__( 'There can be a MAXIMUM of 1000 different tags and events per site.', 'fupi' ) . '</li>
			</ul>
			<p>' . esc_html__( 'Pay attention to the number of tags your site sends. Read descriptions of the settings below for more information regarding possible increase in the number of tags / events that is sent to Hotjar.', 'fupi' ) . '</p>' .
		$help_end;
	break;

	// E-COMMERCE

	case 'fupi_hotj_ecomm':

		$output = '<p class="fupi_subtitle">' . esc_html__( 'Tag your recordings in Hotjar\'s dashboard with e-commerce events', 'fupi' ) . '</p>' . $help_start . '
		<h3>' . esc_html__( 'How does it work', 'fupi' ) . '</h3>
		<p>' . sprintf( esc_html__( 'Full Picture tags recordings according to e-commerce events that take place on your site (checkouts, purchases, add-to-cart\'s and more). %1$sSee the full list here%2$s.', 'fupi' ), '<a href="https://fullpictureplugin.com/?p=4734&utm_source=useradmin&utm_medium=settings&utm_campaign=settings_link" target="_blank">', '</a>' ). '</p>
		<h3>' . esc_html__( 'How to enable e-commerce tagging', 'fupi' ) . '</h3>' .
		'<ol class="fupi_list_steps">
			<li>' . sprintf(
				esc_html__( 'Enable the integration with your e-commerce plugin %1$son this page%2$s. If it is not on the list (or you are not using a plugin) use %3$sFull Picture\'s custom events%4$s;', 'fupi' ),
				'<a href="?page=full_picture_tools" target="_blank">',
				'</a>',
				'<a href="https://fullpictureplugin.com/?p=797&utm_source=useradmin&utm_medium=settings&utm_campaign=settings_link" target="_blank">',
				'</a>'
			) . '</li>
			<li>' . sprintf( esc_html__( 'Configure the %1$sglobal tracking settings%2$s for your plugin.', 'fupi' ), '<a href="?page=full_picture_main" target="_blank">', '</a>' ) . '</li>
		</ol>
		<h3>' . esc_html( 'What you need to know', 'fupi' ) . '</h3>
		<ul>
			<li>' . esc_html__( 'Tagging screen recordings is available in Hotjar paid plans.', 'fupi' ) . '</li>
			<li>' . esc_html__( 'One recording can have NO MORE than 50 tags associated with it. Tags over this limit will be ignored.', 'fupi' ) . '</li>
			<li>' . esc_html__( 'There can be a MAXIMUM of 1000 different tags and events per site.', 'fupi' ) . '</li>
		</ul>
		<p>' . $help_end;

		// If woocommerce is enabled
		if ( ! $this->is_woo_enabled ) {
			$output .= '<p class="fupi_highlight"><span class="dashicons dashicons-no"></span> ' .  sprintf( esc_html__( 'WooCommerce integration is %1$sdisabled%2$s. %3$sEnable it in "data source" tab (above) and make sure that you are using WooCommerce in version 3.7 or newer.', 'fupi' ), '<strong style="color: red;">', '</strong>', '<br><br>' ) . '</p>';
		} else {
			$output .= '<p class="fupi_highlight"><span class="dashicons dashicons-yes"></span> ' . sprintf( esc_html__( 'WooCommerce integration is %1$senabled%2$s.', 'fupi' ), '<strong style="color: green;">', '</strong>' ) . '</p>';
		};

		return $output;
	break;

	// USER IDENTIFICATION

	case 'fupi_hotj_users':
		return '<p class="fupi_subtitle">' . esc_html__( 'Use user identification to target specific users with polls and widgets and to filter recordings by specific users and their attributes.', 'fupi' ) . '</p>' .
		$help_start . '
			<h3>' . esc_html( 'What you need to know', 'fupi' ) . '</h3>
			<p>' . esc_html__( 'To use these options you need a Hotjar Business plan.', 'fupi' ) . '</p>
			<p>' . sprintf( esc_html ( 'To be able to identify users you need to go to your Hotjar dashboard and follow %1sthese steps%2s.', 'fupi' ), '<a href="https://help.hotjar.com/hc/en-us/articles/360033640653-Identify-API-Reference#making-calls-to-identify" target="_blank">', '</a>' ) . '</p>' .
		$help_end;
	break;

    default:
        return '';
    break;
};

?>
