<?php

switch( $a['id'] ){

    // MAIN

	case 'fupi_linkd_main':
		return '<p class="fupi_subtitle">' . esc_html__( 'Enable LinkedIn Insight Tag on your site', 'fupi' ) . '</p>';
	break;

    // EVENT CONVERSIONS

	case 'fupi_linkd_events':
		return '<p class="fupi_subtitle">' . esc_html__( 'Track conversions that happen after certain events', 'fupi' ) . '</p>' .
		$help_start . '
			<h3>' . esc_html__( 'What you need to know', 'fupi' ) . '</h3>
            <p>' . esc_html__( 'To track conversions that happen after certain events you need to register a separate conversion for each event.', 'fupi' ) . '</p>
            <p>' . sprintf( esc_html__( 'Go to %1$sLinkedIn Campaign Manager%2$s > Account Assets > Conversions > Create a conversion > in the 3rd step of configuration choose "Insight tag" > grab the value of "conversion_id" from the script and paste it into a chosen field below.', 'fupi' ), '<a href="https://www.linkedin.com/campaignmanager/login" target="_blank">', '</a>' ) . '</p>
			<p>' . esc_html__( 'Remember, each field below needs to be filled with a different ID.', 'fupi' ) . '</p>' .
		$help_end;
	break;

	case 'fupi_linkd_ecomm':
		$output = '<p class="fupi_subtitle">' . esc_html__( 'Track conversions that happen after certain e-commerce events', 'fupi' ) . '</p>' . $help_start . '
		<h3>' . esc_html__( 'How to enable e-commerce tracking', 'fupi' ) . '</h3>' .
		'<ol class="fupi_list_steps">
			<li>' . sprintf(
				esc_html__( 'Enable the integration with your e-commerce plugin %1$son this page%2$s. If it is not on the list (or you are not using a plugin) use %3$sFull Picture\'s custom events%4$s;', 'fupi' ),
				'<a href="?page=full_picture_tools" target="_blank">',
				'</a>',
				'<a href="https://fullpictureplugin.com/?p=797&utm_source=useradmin&utm_medium=settings&utm_campaign=settings_link" target="_blank">',
				'</a>'
			) . '</li>
			<li>' . sprintf( esc_html__( 'Configure the %1$sglobal tracking settings%2$s for your plugin.', 'fupi' ), '<a href="?page=full_picture_main" target="_blank">', '</a>' ) . '</li>
			<li>' . sprintf( esc_html__( 'Go to %1$sLinkedIn Campaign Manager%2$s > Account Assets > Conversions > Create a conversion > in the 3rd step of configuration choose "Insight tag" > grab the value of "conversion_id" from the script and paste it into a chosen field below.', 'fupi' ), '<a href="https://www.linkedin.com/campaignmanager/login" target="_blank">', '</a>' ) . '</li>
			<li>' . esc_html__( 'Remember, each field below needs to be filled with a different ID.', 'fupi' ) . '</li>
		</ol>' . $help_end;

		// If woocommerce is enabled
		if ( ! $this->is_woo_enabled ) {
			$output .= '<p class="fupi_highlight">' .  sprintf( esc_html__( 'WooCommerce integration is %1$sdisabled%2$s. Please make sure that you are using WooCommerce in version 3.7 or later and you enabled WooCommerce data source.', 'fupi' ), '<strong style="color: red;">', '</strong>' ) . '</p>';
		} else {
			$output .= '<p class="fupi_highlight"><span class="dashicons dashicons-yes"></span> ' . sprintf( esc_html__( 'WooCommerce integration is %1$senabled%2$s.', 'fupi' ), '<strong style="color: green;">', '</strong>' ) . '</p>';
		};

		return $output;
	break;

    default:
        return '';
    break;
};

?>
