<?php

$main_opts = get_option('fupi_main');
$magic_keyword = ! empty ( $main_opts['magic_keyword'] ) ? $main_opts['magic_keyword'] : 'tracking';

switch( $a['id'] ){

	// DO NOT TRACK

	case 'fupi_main_no_track':

		return '<p class="fupi_subtitle">' . esc_html__( 'Make sure your site does not track you', 'fupi' ) . '</p>' .
			$help_start . '
				<p><a href="https://www.youtube.com/watch?v=bNYNX2vDrQo" class="fupi_vid_link fupi_vid" data-srcid="bNYNX2vDrQo"><i class="dashicons dashicons-youtube"></i> <span>How these settings work (1:14 min)</span></a></p>' .
			$help_end .
			'<p class="fupi_highlight">' . esc_html__( 'Everyone who clicks this link will not be tracked no matter whether they are logged in or not.', 'fupi' ) . '<br> <a href="' . get_bloginfo('url') . '/?' . $magic_keyword . '=off"><strong>' . get_bloginfo('url') . '/?' . $magic_keyword . '=off</strong></a><br><br>' . esc_html__( 'Attention! This will work only on the browser where the link was opened. "No track" status will be remembered until cookies are cleared.', 'fupi' ) . '</p>';
	break;

	// COOKIE NOTICE

	case 'fupi_main_cookie_notice':
		return '<p class="fupi_subtitle">' . esc_html__( 'Enable fully GDPR-compliant cookie notice', 'fupi' ) . '</p>' .
			$help_start . '
				<p><a href="https://www.youtube.com/watch?v=_XmXq6nDuEo" class="fupi_vid_link fupi_vid" data-srcid="_XmXq6nDuEo"><i class="dashicons dashicons-youtube"></i> <span>How to set-up a cookie notice (1:15 min)</span></a></p>' .
			$help_end;
	break;

	// PRIVACY POLICY

	case 'fupi_main_privacy_policy':
		return '<p class="fupi_subtitle">' . esc_html__( 'Extend your privacy policy', 'fupi' ) . '</p>' .
			$help_start . '
				<p><a href="https://www.youtube.com/watch?v=wYSqOQLXfFM" class="fupi_vid_link fupi_vid" data-srcid="wYSqOQLXfFM"><i class="dashicons dashicons-youtube"></i> <span>How these functions work (1:02 min)</span></a></p>' .
			$help_end . '
			<p class="fupi_highlight">' . sprintf( esc_html__( 'Use shortcode %1$s to add to your privacy policy a list of currently enabled tracking tools (Full Picture\'s tools only). ', 'fupi'), '<strong>[fp_info]</strong>', '' ). '</p>
			<p class="fupi_highlight">' . sprintf( esc_html__( 'Add class %1$s to a button or a link. When users click it, they will be shown a cookie settings panel.%2$s Please note that this will work only if you enabled cookie notice in Full Picture - not in aby other plugin. Also, the notice will NOT show to logged-in users whose roles are excluded from tracking.', 'fupi'), '<strong>fp_show_cookie_notice</strong>', '<br><br>');
	break;

	// GLOBAL SETTINGS

	case 'fupi_main_global':
		return '<p class="fupi_subtitle">' . esc_html__( 'Change how Full Picture collects and measures data.', 'fupi' ) . '</p>';
	break;

	// SECURITY & PRIVACY

	case 'fupi_main_security':
		return '<p class="fupi_subtitle">' . esc_html__( 'Change security and privacy settings', 'fupi' ) . '</p>';
	break;

	// USER ACCESS

	case 'fupi_main_roles':
		return '<p class="fupi_subtitle">' . esc_html__( 'Let other users view and save Full Picture\'s settings', 'fupi' ) . '</p>';
	break;

	// OTHER SETTINGS

	case 'fupi_main_other':
		return '<p class="fupi_subtitle">' . esc_html__( 'Other settings', 'fupi' ) . '</p>';
	break;

	// DEFAULT

	default:
		return '';
	break;
};

?>
