<?php

switch( $a['id'] ){

	// MAIN

	case 'fupi_pla_main':
		return '<p class="fupi_subtitle">' . esc_html__( 'Start tracking traffic with Plausible', 'fupi' ) . '</p>';
	break;

	// MAIN

	case 'fupi_pla_blindspot':
		return '<p class="fupi_subtitle">' . esc_html__( 'Track how much information is invisible to other tracking tools', 'fupi' ) . '</p>' .
		$help_start . '
			<h3>' . esc_html__( 'What you need to know', 'fupi' ) . '</h3>
			<ol>
				<li>' . esc_html__( 'To collect accurate data the source of your Plausible script needs to be proxied or self-hosted! See "basic settings" section.', 'fupi' ) . '</li>
				<li>' . esc_html__( 'Keep in mind that if you are NOT using a self-hosted Plausible installation tracking events listed below will count towards your plan\'s limits', 'fupi' ) . '</li>
			</ol>' .
		$help_end;
	break;

	// EVENT TRACKING

	case 'fupi_pla_events_2':
		return '<p class="fupi_subtitle">' . esc_html__( 'Track what people do on your site', 'fupi' ) . '</p>' .
		$help_start . '
			<h3>' . esc_html__( 'What you need to know', 'fupi' ) . '</h3>
			<p>' . esc_html__( 'Keep in mind that if you are NOT using a self-hosted Plausible installation tracking events listed below will count towards your plan\'s limits.', 'fupi' ) . '</p>' .
		$help_end;
	break;

	// E-COMMERCE TRACKING

	case 'fupi_pla_ecomm':

		$output = '<p class="fupi_subtitle">' . esc_html__( 'Track e-commerce events', 'fupi' ) . '</p>' . $help_start . '
		<h3>' . esc_html__( 'What you can track', 'fupi' ) . '</h3>
		<p>' . sprintf( esc_html__( 'Full Picture can track a number of e-commerce events like checkouts, purchases, additing products to cart and more. %1$sMore details here%2$s.', 'fupi' ), '<a href="https://fullpictureplugin.com/?p=4734&utm_source=useradmin&utm_medium=settings&utm_campaign=settings_link" target="_blank">', '</a>' ). '</p>
		<h3>' . esc_html__( 'How to enable e-commerce tracking', 'fupi' ) . '</h3>
		<ol class="fupi_list_steps">
			<li>' . sprintf(
				esc_html__( 'Enable the integration with your e-commerce plugin %1$son this page%2$s. If it is not on the list (or you are not using a plugin) use %3$sFull Picture\'s custom events%4$s;', 'fupi' ),
				'<a href="?page=full_picture_tools" target="_blank">',
				'</a>',
				'<a href="https://fullpictureplugin.com/?p=797&utm_source=useradmin&utm_medium=settings&utm_campaign=settings_link" target="_blank">',
				'</a>'
			) . '</li>
			<li>' . sprintf( esc_html__( 'Configure the %1$sglobal tracking settings%2$s for your plugin.', 'fupi' ), '<a href="?page=full_picture_main" target="_blank">', '</a>' ) . '</li>
		</ol>' . $help_end;

		// If woocommerce is enabled
		if ( ! $this->is_woo_enabled ) {
			$output .= '<p class="fupi_highlight">' .  sprintf( esc_html__( 'WooCommerce integration is %1$sdisabled%2$s. Please make sure that you are using WooCommerce in version 3.7 or later and you enabled WooCommerce data source.', 'fupi' ), '<strong style="color: red;">', '</strong>' ) . '</p>';
		} else {
			$output .= '<p class="fupi_highlight"><span class="dashicons dashicons-yes"></span> ' . sprintf( esc_html__( 'WooCommerce integration is %1$senabled%2$s. No other actions are necessary. E-commerce events will be tracked automaticaly.', 'fupi' ), '<strong style="color: green;">', '</strong>' ) . '</p>';
		};

		return $output;
	break;

	// DEPRECATED EVENT TRACKING

	case 'fupi_pla_events':
		return '<p class="fupi_subtitle">' . esc_html__( 'These functions will be removed from Full Picture with the next update. Please use new event tracking from the previous sections.', 'fupi' ) . '</p>';
	break;

    default:
        return '';
    break;
};

?>
