<?php

$user_info = get_user_by( 'id', get_current_user_id() );
$username = (( !empty($user_info->first_name) ? $user_info->first_name . ' ' : $user_info->display_name )) . ' ';
$active_page = sanitize_html_class( $_GET['page'] );
$active_page = str_replace( 'full_picture_', '', $active_page );
$active_tab = ( isset( $_GET['tab'] ) ? sanitize_html_class( $_GET['tab'] ) : false );
$fupi_tools = get_option( 'fupi_tools' );
$fupi_main = get_option( 'fupi_main' );
$side_nav_class = ( $active_page == 'tools' ? 'no_side_col' : 'has_side_col' );
$module_slug = '';
$is_pro_code = false;
// UPDATE OPTIONS TO LATEST VERSION
// if we are updating from ver. 1.7.0 and earlier ( they didn't use $fupi_tools )
if ( empty($fupi_tools) ) {
    
    if ( !empty($fupi_main) ) {
        // move cookie options to fupi_cook
        $fupi_cook = get_option( 'fupi_cook' );
        if ( empty($fupi_cook) && !empty($fupi_main['enable_scripts_after']) && !empty($fupi_main['geo']) ) {
            update_option( 'fupi_cook', array(
                'enable_scripts_after' => $fupi_main['enable_scripts_after'],
                'geo'                  => $fupi_main['geo'],
            ) );
        }
        // move tools list to fupi_tools
        $tools_a = array(
            'fupi_db_ver' => FUPI_VERSION,
        );
        if ( isset( $fupi_main['cookie_notice'] ) ) {
            $tools_a['cook'] = 1;
        }
        foreach ( FUPI_MODULES as $module ) {
            if ( isset( $fupi_main[$module[0]] ) ) {
                $tools_a[$module[0]] = 1;
            }
        }
        update_option( 'fupi_tools', $tools_a );
        // show success notice
        echo  '<div class="notice notice-success is-dismissible"><p>Full Picture\'s database has been updated to version 2.0.0. Enjoy using all its latest features :)</p></div>' ;
    }

}
// // If we are updating from ver. 2.0.0 and newer
// else {
// 	$ver = $fupi_tools['fupi_db_ver'];
// 	switch ( $ver ) {
// 		case '2.0.0':
// 		// do sth
// 	break;
// }
// }
?>

<div id="fupi_content" class="wrap <?php 
echo  $side_nav_class ;
?>">

    <h1></h1>
    <?php 
settings_errors();
// TABS
$show_tabs = false;
$nav_output = '<div class="nav-tab-wrapper">';
// Tabs on "cookie notice" page

if ( $active_page == 'cook' ) {
    $show_tabs = true;
    $nav_output .= '<a href="?page=full_picture_cook" id="nav-tab-cook" class="nav-tab nav-tab-active">' . esc_html( 'Display settings', 'fupi' ) . '</a>
		<a href="/wp-admin/customize.php?autofocus[section]=fupi_set_cookie_notice" id="nav-tab-cookie_notice" class="nav-tab">' . esc_html( 'Styling', 'fupi' ) . '</a>';
    // Tabs on "Global Settings" pages
} else {
    
    if ( $active_page == 'main' ) {
        $nav_output .= '<a href="?page=full_picture_main" id="nav-tab-main" class="nav-tab ' . (( $active_tab === false ? 'nav-tab-active' : '' )) . '">' . esc_html( 'Main settings', 'fupi' ) . '</a>';
        // go through modules
        foreach ( FUPI_MODULES as $module ) {
            $tab_slug = esc_attr( $module[0] );
            $tab_name = esc_attr( $module[1] );
            $included_in_plan = esc_attr( $module[2] );
            $tab_type = (int) $module[4];
            $include_current_tab = $tab_type == 2 && $included_in_plan && isset( $fupi_tools[$tab_slug] );
            
            if ( $include_current_tab ) {
                $show_tabs = true;
                $nav_output .= '<a href="?page=full_picture_main&tab=' . $tab_slug . '" id="nav-tab-' . $tab_slug . '" class="nav-tab ' . (( $active_tab == $tab_slug ? 'nav-tab-active' : '' )) . '">' . $tab_name . '</a>';
            }
        
        }
    }

}

$nav_output .= '</div>';
if ( $show_tabs ) {
    echo  $nav_output ;
}
?>

    <div id="fupi_main">
        <div id="fupi_page_nav" role="link" data-opttxt="<?php 
esc_attr_e( 'Optional', 'fupi' );
?>" data-deprtxt="<?php 
esc_attr_e( 'Deprecated', 'fupi' );
?>" data-basictxt="<?php 
esc_attr_e( 'Basic settings', 'fupi' );
?>" >
        </div>
        <div id="fupi_main_col">

            <div id="fupi_page_title_wrap" >
				<h2 id="fupi_page_title"><?php 
echo  esc_html( get_admin_page_title() ) ;
?></h2>
				<?php 

if ( !$is_pro_code ) {
    ?>
	                <div id="fupi_hide_pro">
	                    <span id="fupi_hide_pro_title"><?php 
    esc_html_e( 'Hide PRO settings', 'fupi' );
    ?></span>
	                    <label class="fupi_switch"><input type="checkbox" id="fupi_hide_pro_switch"/><span class="fupi_slider"></span></label>
	                    <div class="fupi_tooltip">?<span class="fupi_tooltiptext"><?php 
    esc_html_e( 'Hides settings available only in the PRO version', 'fupi' );
    ?></span></div>
	                </div>
				<?php 
}

?>
			</div>

			<?php 
$active_slug = ( empty($active_tab) ? $active_page : $active_tab );
?>

            <form id="fupi_settings_form" class="fupi_hidden" data-activetab="<?php 
echo  $active_slug ;
?>" action="options.php" method="post">
                <?php 
settings_fields( 'fupi_' . $active_slug );
do_settings_sections( 'fupi_' . $active_slug );
?>

                    <?php 
submit_button();
?>

                    <div id="fupi_feedback">
                        <p><?php 
echo  sprintf( esc_html( 'Need help? Post %1$ssupport question%2$s', 'fupi' ), '<a href="https://wordpress.org/support/plugin/full-picture-analytics-cookie-notice/" target="_blank">', '</a>' ) ;
?></p>
                    </div>

                    <?php 

if ( isset( $fupi_main['debug'] ) && $fupi_main['debug'] == 1 ) {
    echo  '<div id="fupi_option_debug_box"><p>Option name: fupi_' . $active_slug . '</p>' ;
    print "<pre>";
    print_r( get_option( 'fupi_' . $active_slug ) );
    print "</pre></div>";
}

?>
            </form>
        </div>
        <aside id="fupi_side_info">
			<div class="fupi_info_box">
		        <h3>Help</h3>
	            <p><a href="https://fullpictureplugin.com/?p=16&utm_source=useradmin&utm_medium=settings&utm_campaign=top_link" target="_blank"><?php 
esc_html_e( 'Documentation', 'fupi' );
?></a></p>
	            <?php 

if ( fupi_fs()->is_not_paying() ) {
    $share_url = 'https://wordpress.org/plugins/full-picture-analytics-cookie-notice/';
    ?>
	                <p><a href="https://wordpress.org/support/plugin/full-picture-analytics-cookie-notice/" target="_blank"><?php 
    esc_html_e( 'Free Support', 'fupi' );
    ?></a></p>
	            <?php 
} else {
    $share_url = 'https://fullpictureplugin.com';
    ?>
	                <p><a href="https://fullpictureplugin.com/contact/?utm_source=useradmin&utm_medium=settings&utm_campaign=top_link" target="_blank"><?php 
    esc_html_e( 'PRO Support', 'fupi' );
    ?></a></p>
	            <?php 
}

?>
			</div>
			<div class="fupi_info_box">
				<h3>Hi <?php 
echo  $username ;
?>:)</h3>
				<p><img id="fupi_author_img" src="<?php 
echo  FUPI_URL ;
?>admin/settings/img/fp-author-90.jpg" aria-hidden="true"> The plugin you are now using took 1700+ hours to make. Keep me motivated and help me make it better. Please...</p>
				<p><a href="mailto:hello@fullpictureplugin.com">Send your feedback</a></p>
				<p><a href="https://wordpress.org/support/plugin/full-picture-analytics-cookie-notice/reviews/#new-post">Rate the plugin</a></p>
				<p>Tell your friends on
					<a class="fupi_share_link" href="https://www.facebook.com/sharer.php?u=<?php 
echo  $share_url ;
?>" target="blank" rel="noopener noreferrer"><span class="dashicons dashicons-facebook"></span><span class="fupi_srt">Facebook</span></a>
					<a class="fupi_share_link" href="https://twitter.com/intent/tweet?url=<?php 
echo  $share_url ;
?>" target="blank" rel="noopener noreferrer"><span class="dashicons dashicons-twitter"></span><span class="fupi_srt">Twitter</span></a>
					<a class="fupi_share_link" href="https://www.linkedin.com/shareArticle?mini=true&url=<?php 
echo  $share_url ;
?>" target="blank" rel="noopener noreferrer"><span class="dashicons dashicons-linkedin"></span><span class="fupi_srt">Linked In</span></a>
				</p>
				<p>Have a great day<br>Krzysztof</p>
			</div>
			<?php 
if ( fupi_fs()->is_not_paying() ) {
    ?>
				<div class="fupi_info_box">
					<h3>Get 50% OFF Full Picture PRO!</h3>
	                <p>Full Picture PRO is almost ready. Subscribe to launch notification to get 50% off!</p>
	                <p><span class="dashicons dashicons-yes"></span> All tools<br>
	                <span class="dashicons dashicons-yes"></span> All features<br>
	                <span class="dashicons dashicons-yes"></span> Full WooCommerce support</br>
	                <span class="dashicons dashicons-yes"></span> Geolocation for the cookie notice</p>
	                <p><a style="display: block; margin-bottom: 10px;"href="https://fullpictureplugin.com/?p=2583&utm_source=useradmin&amp;utm_medium=settings&amp;utm_campaign=pro_invite_compare" target="_blank">Compare FREE & PRO</a>
	                <a class="button button-primary" href="https://fullpictureplugin.com/pricing/?utm_source=useradmin&amp;utm_medium=settings&amp;utm_campaign=pro_invite" target="_blank">Subscribe to launch notification</a></p>
	                <h3>Or start using PRO right now!</h3>
	                <p>Try out the pre-release version with all the bells and whistles.</p>
	                <p><a class="button" href="https://fullpictureplugin.com/full-picture-pro-beta/?utm_source=useradmin&amp;utm_medium=settings&amp;utm_campaign=pro_invite" target="_blank">Try Full Picture PRO Beta</a></p>
				</div>
			<?php 
}
?>
        </aside>
    </div>
</div>
