<?php

$clearStatus = false;

// some methods from https://hotexamples.com/examples/-/WpeCommon/purge_varnish_cache/php-wpecommon-purge_varnish_cache-method-examples.html

// ROCKET CACHE
if ( function_exists( 'rocket_clean_domain' ) ) {
	rocket_clean_domain();
	$clearStatus = 'WP Rocket';
}

// WP ENGINE
elseif ( class_exists( 'WpeCommon' ) ) {
	if (method_exists('WpeCommon', 'purge_memcached')) { WpeCommon::purge_memcached(); }
	if (method_exists('WpeCommon', 'clear_maxcdn_cache')) { WpeCommon::clear_maxcdn_cache(); }
	if (method_exists('WpeCommon', 'purge_varnish_cache')) { WpeCommon::purge_varnish_cache(); }
	$clearStatus = 'WP Engine ';
}

// W3 TOTAL CACHE
elseif ( function_exists( 'w3tc_pgcache_flush' ) ) {
	w3tc_pgcache_flush();
	$clearStatus = 'W3 Total Cache';
}

// SITEGROUND
// via SG OPTIMIZER @ https://wordpress.org/plugins/sg-cachepress/
elseif ( function_exists( 'sg_cachepress_purge_cache' ) ) {
	sg_cachepress_purge_cache();
	$clearStatus = 'Siteground';
}

// WP SUPER CACHE
elseif ( function_exists( 'wp_cache_clean_cache' ) ) {    // WP Super Cache
	global $file_prefix;
	wp_cache_clean_cache( $file_prefix );
	$clearStatus = 'WP Super Cache';
}
// or an alternative method ( https://github.com/Automattic/wp-super-cache/issues/628 )
// if ( function_exists( 'wp_cache_clear_cache' ) ) {
//     wp_cache_clear_cache();
// }

// WP FASTEST CACHE
// https://www.wpfastestcache.com/tutorial/delete-the-cache-by-calling-the-function/
elseif ( function_exists( 'wpfc_clear_all_cache;' ) ) {
	wpfc_clear_all_cache();
	$clearStatus = 'WP Fastest Cache';
}

// COMET CACHE
elseif ( class_exists("comet_cache") ) {
	comet_cache::clear();
	$clearStatus = 'Comet Cache';
}

if ( $clearStatus !== false ) {
	echo $clearStatus;
} else {
	echo 'cache not cleared';
}

die();

?>
