<?php

$output = array();
if ( ! $input) return $output;

foreach( $input as $key => $value ) {

	$clean_key = sanitize_key( $key );

	if( ! empty( $value ) ) {

		switch ($clean_key) {
			case 'show_to_countries':
			case 'custom_agree_cookies_class':
			case 'custom_decline_cookies_class':
			case 'custom_cookies_settings_class':
			case 'custom_menu_title':
				$clean_val = sanitize_text_field( $value );
				break;
			case 'disable_for_roles':
			case 'hidden_taxonomies':
				$clean_val = array_map( 'sanitize_key', $value );
				break;
			case 'enable_scripts_after':
			case 'geo':
				$clean_val = sanitize_key( $value );
				break;
			case 'redirect_404':
			case 'cf_worker_url':
				$clean_val = esc_url_raw( $value );
				break;
			case 'magic_keyword':
				$clean_val = sanitize_title_with_dashes( $value );
				break;
			case 'notrack_dblclck':
			case 'formsubm_trackdelay':
			case 'link_click_delay':
				$clean_val = (int) $value;
				break;
			case 'user_cap':

				if ( current_user_can('manage_options') ) {
					$clean_val = sanitize_key( $value );

				// if a non-admin user saves the setting...
				} else {
					// we disregard what is in the field and pass the value set by the admin
					$clean_val = $this->main['user_cap'];
				}
				break;
			default:
				$clean_val = strip_tags( stripslashes( $value ) );
				break;
		}

		// error_log('sanitized ' . $clean_key . ' value: ' . json_encode($clean_val) );

		if ( ! empty( $clean_val ) && ! empty ( $clean_key ) ) $output[$clean_key] = $clean_val;
	}
}

return $output;
?>
