<?php

$output = array();
if ( ! $input) return $output;

foreach( $input as $key => $value ) {

	$clean_key = sanitize_key( $key );

	if( ! empty( $value ) ) {

		switch ($clean_key) {
			case 'track_affiliate':
			case 'track_affiliate_2':
			case 'track_elems':
			case 'track_elems_2':
			case 'track_forms':
			case 'track_forms_2':
				$clean_val = sanitize_textarea_field( $value );
				break;
			case 'domain':
			case 'custom_domain':
			case 'track_affiliate_goalname':
			case 'track_elems_goalname':
			case 'track_forms_goalname':
			case 'track_contact_links':
			case 'track_mail_links':
			case 'track_tel_links':
			case 'track_cookie_agree_all':
			case 'track_cookie_agree_some':
			case 'track_cookie_decline':
			case 'track_cookie_decline_2':
			case 'detect_adblock':
			case 'detect_adblock_2':
			case 'track_purchases':
			case 'track_purchased_items':
			case 'track_checkouts':
			case 'track_checkout_items':
			case 'track_addtocart':
			case 'track_addtowishlist':
				$clean_val = sanitize_text_field( $value );
				break;
			case 'shared_link_url':
				$clean_val = esc_url_raw( $value );
				break;
			case 'stats_page_cap':
				$clean_val = sanitize_key( $value );
				break;
			default:
				$clean_val = strip_tags( stripslashes( $value ) );
				break;
		}

		// error_log('sanitized ' . $clean_key . ' value: ' . json_encode($clean_val) );

		if ( ! empty( $clean_val ) && ! empty ( $clean_key ) ) $output[$clean_key] = $clean_val;
	}
}

return $output;
?>
