<?php

$page = 'fupi_cook';


// COOKIE NOTICE

$section_id = 'fupi_cook_main';
add_settings_section( $section_id, esc_html__( 'Basic settings', 'fupi' ), array( $this, 'fupi_sections_descriptions'), $page );

$fields = array(
	array(
		'type'	 			=> 'radio',
		'label' 			=> esc_html__( 'Enable tools that require cookies after', 'fupi' ),
		'field_id' 			=> 'enable_scripts_after',
		'option_arr_id'		=> $option_arr_id,
		'options' 			=> array(
			'consent'			=> esc_html__( 'visitors agree to cookies - required in the EU', 'fupi' ),
			'pageload'			=> esc_html__( 'right after the page loads', 'fupi' ),
		),
		'default'			=> 'consent',
		'under field'		=> esc_html__( 'The tools that don\'t require cookies always start working right after the page loads. You can filter the list of tools to see which ones don\'t require cookies.', 'fupi' ),
	),
);

foreach( $fields as $field ){
	add_settings_field( $field['field_id'], $field['label'], array( $this, 'fupi_field_html' ), $page, $section_id, $field );
}

$section_id = 'fupi_cook_geo';
add_settings_section( $section_id, esc_html__( 'Geolocation*', 'fupi' ), array( $this, 'fupi_sections_descriptions'), $page );

$fields = array(
	array(
		'type'	 			=> 'radio',
		'label' 			=> esc_html__( 'Country geolocation method', 'fupi' ),
		'field_id' 			=> 'geo',
		'option_arr_id'		=> $option_arr_id,
		'class'				=> $disable_for_free_class,
		'options' 			=> array(
			'none'				=> esc_html__( 'None (cookie notice will show to all visitors!)', 'fupi' ),
			'cf_non_user'		=> esc_html__( 'Cloudflare tracker (use it if you are NOT a CF user)', 'fupi'),
			'cf_default'		=> esc_html__( 'Cloudflare tracker (use if you ARE a CF user)', 'fupi'),
			'cf_worker'			=> sprintf(esc_html__( 'Cloudflare Worker - Advanced (%1slearn more%2s)', 'fupi'), '<a href="https://fullpictureplugin.com/?p=281&utm_source=useradmin&utm_medium=settings&utm_campaign=settings_link" target="_blank">', '</a>'),
			'cloudways'			=> esc_html__( 'Cloudways Geo IP (site needs to be hosted on Cloudways). Enable Geo IP in Cloudways "Application Settings")', 'fupi'),
		),
		'default'			=> 'none',
	),
	array(
		'type'	 			=> 'text',
		'label' 			=> esc_html__( 'Show notice only in countries', 'fupi' ),
		'class'				=> $disable_for_free_class,
		'field_id' 			=> 'show_to_countries',
		'option_arr_id'		=> $option_arr_id,
		'label_for' 		=> $option_arr_id . '[show_to_countries]',
		'placeholder'		=> '',
		'under field' 		=> sprintf(esc_html__('Enter a list of 2-character %1s country codes%2s separated by comas. Countries that require opt-in cookie notice are: AT, BE, BG, CY, CZ, DE, DK, ES, EE, FI, FR, GB, GR, HR, HU, IE, IT, LT, LU, LV, MT, NL, PL, PT, RO, SK, SI, SE. Cookies for visitors from other locations will load automatically on page load', 'fupi'), '<a target="_blank" href="https://www.iban.com/country-codes">', '</a>'),
	),
	array(
		'type'	 			=> 'text',
		'label' 			=> esc_html__( 'Cloudflare Worker URL', 'fupi' ),
		'class'				=> $disable_for_free_class,
		'field_id' 			=> 'cf_worker_url',
		'option_arr_id'		=> $option_arr_id,
		'label_for' 		=> $option_arr_id . '[cf_worker_url]',
		'placeholder'		=> '',
		'under field' 		=> sprintf(esc_html__('Enter worker script URL if you chose "Cloudflare Worker" option above. %1s Learn how to find it%2s.', 'fupi'), '<a href="https://fullpictureplugin.com/?p=281&utm_source=useradmin&utm_medium=settings&utm_campaign=settings_link" target="_blank">', '</a>'),
	),
	array(
		'type'	 			=> 'toggle',
		'label' 			=> esc_html__( 'Show notice if geolocation fails', 'fupi' ),
		'field_id' 			=> 'show_on_geoloc_err',
		'option_arr_id'		=> $option_arr_id,
		'class'				=> $disable_for_free_class,
		'under field'		=> esc_html__( 'Geolocation fails mostly due to the use of VPNs.', 'fupi'),
	)
);

foreach( $fields as $field ){
	add_settings_field( $field['field_id'], $field['label'], array( $this, 'fupi_field_html' ), $page, $section_id, $field );
}

$section_id = 'fupi_cook_custom';
add_settings_section( $section_id, esc_html__( 'Custom notice', 'fupi' ), array( $this, 'fupi_sections_descriptions'), $page );

$fields = array(
	array(
		'type'	 			=> 'toggle',
		'label' 			=> esc_html__( 'Use a custom cookie notice', 'fupi' ),
		'field_id' 			=> 'use_custom_notice',
		'option_arr_id'		=> $option_arr_id,
		'class'				=> $disable_for_free_class,
		'under field'		=> esc_html__( 'Use this option to show your own cookie notice instead of Full Picture\'s. Attention! Provide classes to accept and decline buttons below.', 'fupi'),
	),
	array(
		'type'	 			=> 'text',
		'label' 			=> esc_html__( 'CSS selector to custom cookie notice\'s "agree" button', 'fupi' ),
		'class'				=> $disable_for_free_class,
		'field_id' 			=> 'custom_agree_cookies_class',
		'placeholder'		=> esc_html__( 'e.g.: .some-class a.btn' ),
		'option_arr_id'		=> $option_arr_id,
		'label_for' 		=> $option_arr_id . '[custom_agree_cookies_class]',
	),
	array(
		'type'	 			=> 'text',
		'label' 			=> esc_html__( 'CSS selector to custom cookie notice\'s "decline" button', 'fupi' ),
		'class'				=> $disable_for_free_class,
		'field_id' 			=> 'custom_decline_cookies_class',
		'placeholder'		=> esc_html__( 'e.g.: .some-class a.btn' ),
		'option_arr_id'		=> $option_arr_id,
		'label_for' 		=> $option_arr_id . '[custom_decline_cookies_class]',
	),
	array(
		'type'	 			=> 'text',
		'label' 			=> esc_html__( 'CSS selector to custom cookie notice\'s "Cookie settings" button', 'fupi' ),
		'class'				=> $disable_for_free_class,
		'field_id' 			=> 'custom_cookies_settings_class',
		'placeholder'		=> esc_html__( 'e.g.: .some-class a.btn' ),
		'option_arr_id'		=> $option_arr_id,
		'label_for' 		=> $option_arr_id . '[custom_cookies_settings_class]',
	),
);

foreach( $fields as $field ){
	add_settings_field( $field['field_id'], $field['label'], array( $this, 'fupi_field_html' ), $page, $section_id, $field );
}
