<?php

$page = 'fupi_fbp1';

// BASIC SETUP

$section_id 		= 'fupi_fbp1_main';
add_settings_section( $section_id, esc_html__( 'Basic settings', 'fupi' ), array( $this, 'fupi_sections_descriptions'), $page );

if ( $this->cook_enabled ){
	$cook_opt = array(
		'type'	 			=> 'toggle',
		'label' 			=> esc_html__( 'Load Facebook Pixel without waiting for cookie consent', 'fupi' ),
		'field_id' 			=> 'disreg_cookies',
		'option_arr_id'		=> $option_arr_id,
		'under field'		=> esc_html__( 'This option has an effect only if you chose to load tracking tools after user gives their consent to cookies. Sometimes you may need to enable it to validate your Facebook Pixel installation while connecting it to other tools and platforms. By leaving it enabled you make your website not compliant with Cookie Law', 'fupi'),
	);
} else {
	$cook_opt = array(
		'type'				=> 'hidden',
		'field_id' 			=> 'disreg_cookies', // database version
		'label'				=> '', // not used but required in foreach below
	);
}

$fields = array(
	array(
		'type'	 			=> 'text',
		'label' 			=> esc_html__( 'Pixel ID', 'fupi' ),
		'field_id' 			=> 'pixel_id',
		'class'				=> 'fupi_required',
		'option_arr_id'		=> $option_arr_id,
		'label_for' 		=> $option_arr_id . '[pixel_id]',
		'under field'		=> sprintf( esc_html__( 'Find your Pixel ID %1$shere%2$s. If you haven\'t created a pixel yet, click green "+" icon on the left > Connect data sources > Web > click "Connect" and follow instructions on screen.', 'fupi' ), '<a href="https://www.facebook.com/events_manager2/" target="_blank">', '</a>', '<br>'),
	),
	$cook_opt
);

foreach( $fields as $field ){
	add_settings_field( $field['field_id'], $field['label'], array( $this, 'fupi_field_html' ), $page, $section_id, $field );
}

// CLICK TRACKING

$section_id = 'fupi_fbp1_clicks';
add_settings_section( $section_id, esc_html__( 'Track clicks*', 'fupi' ), array( $this, 'fupi_sections_descriptions'), $page );

$fields = array(
	array(
		'type'	 			=> 'toggle',
		'label' 			=> esc_html__( 'Track clicks on outbound links', 'fupi' ),
		'field_id' 			=> 'track_outbound',
		'class'				=> 'fupi_standard',
		'option_arr_id'		=> $option_arr_id,
		'under field'		=> esc_html__( 'Tracks clicks on all links that lead to other domains. Attention! Affiliate links leading to other sites are also treated as outbound.', 'fupi'),
	),
	array(
		'type'	 			=> 'repeater',
		'label' 			=> esc_html__( 'Track clicks on affiliate links', 'fupi' ),
		'field_id' 			=> 'track_affiliate',
		'class'				=> 'fupi_repeater_section',
		'el_data_field1_txt' => esc_html__( 'url part, e.g. /go/', 'fupi' ),
		'el_data_field1_type' => 'url_part',
		'el_data_field1_req' => esc_html__( 'this field is required', 'fupi' ),
		'el_data_field1_err' => '',
		'el_data_field2_txt' => esc_html__( 'name (optional)', 'fupi' ),
		'el_data_field2_req' => '',
		'el_data_field2_err' => esc_html__( 'only alphanumeric characters, spaces, hyphens, underscores and [ ] symbols', 'fupi' ),
		'option_arr_id'		=> $option_arr_id,
		'label_for' 		=> $option_arr_id . '[track_affiliate]',
		'under field' 		=> esc_html__( 'If you don\'t provide a name, a full link address will be visible in custom audiences\' setup form.', 'fupi' ),
	),
	array(
		'type'	 			=> 'text',
		'label' 			=> esc_html__( 'Track clicks on file download links', 'fupi' ),
		'field_id' 			=> 'track_file_downl',
		'class'				=> 'fupi_standard',
		'placeholder'		=> 'pdf, doc, docx, xls, xlsx, txt',
		'option_arr_id'		=> $option_arr_id,
		'label_for' 		=> $option_arr_id . '[track_file_downl]',
		'under field'		=> esc_html__( 'Enter coma separated list of file formats (extensions) you want to track', 'fupi'),
	),
	array(
		'type'	 			=> 'toggle',
		'label' 			=> esc_html__( 'Track clicks on email and tel. links', 'fupi' ),
		'class'				=> 'fupi_standard',
		'field_id' 			=> 'track_email_tel',
		'option_arr_id'		=> $option_arr_id,
	),
	array(
		'type'	 			=> 'repeater',
		'label' 			=> esc_html__( 'Track clicks on page elements', 'fupi' ),
		'field_id' 			=> 'track_elems',
		'class'				=> 'fupi_repeater_section',
		'el_data_field1_txt' => esc_html__( 'CSS selector e.g. #sth img', 'fupi' ),
		'el_data_field1_req' => esc_html__( 'this field is required', 'fupi' ),
		'el_data_field1_err' => esc_html__( 'incorrect selector', 'fupi' ),
		'el_data_field2_txt' => esc_html__( 'element name (required)', 'fupi' ),
		'el_data_field2_req' => esc_html__( 'this field is required', 'fupi' ),
		'el_data_field2_err' => esc_html__( 'only alphanumeric characters, spaces, hyphens, underscores and [ ] symbols', 'fupi' ),
		'option_arr_id'		=> $option_arr_id,
		'label_for' 		=> $option_arr_id . '[track_elems]',
	),
);

foreach( $fields as $field ){
	add_settings_field( $field['field_id'], $field['label'], array( $this, 'fupi_field_html' ), $page, $section_id, $field );
}

// FORM TRACKING

$section_id = 'fupi_fbp1_forms';
add_settings_section( $section_id, esc_html__( 'Track forms', 'fupi' ), array( $this, 'fupi_sections_descriptions'), $page );

$fields = array(
	array(
		'type'	 			=> 'repeater',
		'label' 			=> esc_html__( 'Track form submissions', 'fupi' ),
		'field_id' 			=> 'track_forms',
		'class'				=> 'fupi_repeater_section',
		'el_data_field1_txt' => esc_html__( 'CSS selector e.g. #form_id', 'fupi' ),
		'el_data_field1_req' => esc_html__( 'this field is required', 'fupi' ),
		'el_data_field1_err' => esc_html__( 'incorrect selector', 'fupi' ),
		'el_data_field2_txt' => esc_html__( 'form name (required)', 'fupi' ),
		'el_data_field2_req' => esc_html__( 'this field is required', 'fupi' ),
		'el_data_field2_err' => esc_html__( 'only alphanumeric characters, spaces, hyphens, underscores and [ ] symbols', 'fupi' ),
		'option_arr_id'		=> $option_arr_id,
		'label_for' 		=> $option_arr_id . '[track_forms]',
		'under field'		=> esc_html__( 'Test this feature after enabling. There are many methods of submitting forms. If tracking fails on your form, set up tracking clicks on "submit" button instead.', 'fupi'),
	)
);

foreach( $fields as $field ){
	add_settings_field( $field['field_id'], $field['label'], array( $this, 'fupi_field_html' ), $page, $section_id, $field );
}

// SCROLL TRACKING

$section_id = 'fupi_fbp1_scroll';
add_settings_section( $section_id, esc_html__( 'Track scroll & visibility', 'fupi' ), array( $this, 'fupi_sections_descriptions'), $page );

$fields = array(
	array(
		'type'	 			=> 'repeater',
		'label' 			=> esc_html__( 'Track when these elements become visible', 'fupi' ),
		'field_id' 			=> 'track_views',
		'class'				=> 'fupi_repeater_section',
		'el_data_field1_txt' => esc_html__( 'CSS selector e.g. .side img', 'fupi' ),
		'el_data_field1_req' => esc_html__( 'this field is required', 'fupi' ),
		'el_data_field1_err' => esc_html__( 'incorrect selector', 'fupi' ),
		'el_data_field2_txt' => esc_html__( 'element name (required)', 'fupi' ),
		'el_data_field2_req' => esc_html__( 'this field is required', 'fupi' ),
		'el_data_field2_err' => esc_html__( 'only alphanumeric characters, spaces, hyphens, underscores and [ ] symbols', 'fupi' ),
		'option_arr_id'		=> $option_arr_id,
		'label_for' 		=> $option_arr_id . '[track_views]',
		'under field'		=> esc_html__( 'Use this function to track when elements are scrolled into the visible area of the page OR when they become visible (like popups). Elements are counted as "visible" when they are 200px inside the viewport. Each view is counted once per page view.', 'fupi'),
	),
	array(
		'type'	 			=> 'text',
		'label' 			=> esc_html__( 'Track when visitors scroll to:', 'fupi' ),
		'field_id' 			=> 'track_scroll',
		'class'				=> 'fupi_standard',
		'el_class'			=> 'fupi_condition',
		'el_data_target'	=> 'fupi_track_scroll_intr',
		'placeholder'		=> esc_html__( 'e.g. 25, 50, 75', 'fupi' ),
		'option_arr_id'		=> $option_arr_id,
		'label_for' 		=> $option_arr_id . '[track_scroll]',
		'after field'		=> esc_html__( '% of page height', 'fupi'),
		'under field'		=> esc_html__( 'Separate multiple values with comas. Do not use "%" symbol.', 'fupi'),
	),
	array(
		'type'	 			=> 'number',
		'label' 			=> esc_html__( 'Track scroll if visitor scrolled more than:', 'fupi' ),
		'field_id' 			=> 'track_scroll_min',
		'class'				=> 'fupi_sub fupi_track_scroll_intr fupi_disabled',
		'option_arr_id'		=> $option_arr_id,
		'label_for' 		=> $option_arr_id . '[track_scroll_min]',
		'default'			=> '200',
		'after field'		=> esc_html__( 'pixels.', 'fupi'),
		'under field'		=> esc_html__( 'Prevents firing events on short pages. Default is 200px.', 'fupi'),
	),
	array(
		'type'	 			=> 'number',
		'label' 			=> esc_html__( 'Do not track scroll if it happened in the first:', 'fupi' ),
		'field_id' 			=> 'track_scroll_time',
		'class'				=> 'fupi_sub fupi_track_scroll_intr fupi_disabled',
		'option_arr_id'		=> $option_arr_id,
		'label_for' 		=> $option_arr_id . '[track_scroll_time]',
		'default'			=> '5',
		'after field'		=> esc_html__( 'seconds', 'fupi' ),
		'under field'		=> esc_html__( 'Prevents tracking "exploratory" scrolls. Default is 5 seconds. The event will fire if the visitor is still below the specified scroll depth after the time has passed.', 'fupi'),
	),
);

foreach( $fields as $field ){
	add_settings_field( $field['field_id'], $field['label'], array( $this, 'fupi_field_html' ), $page, $section_id, $field );
}

// WP DATA TRACKING

$section_id = 'fupi_fbp1_wpdata';
add_settings_section( $section_id, esc_html__( 'Track WP data', 'fupi' ), array( $this, 'fupi_sections_descriptions'), $page );

$fields = array(
	array(
		'type'	 			=> 'toggle',
		'label' 			=> esc_html__( 'Track page type', 'fupi' ),
		'class'				=> 'fupi_standard',
		'field_id' 			=> 'track_pagetype',
		'option_arr_id'		=> $option_arr_id,
		'under field'		=> esc_html__( 'Page types are for example: category, post, page, product, etc.', 'fupi'),
	),
	array(
		'type'	 			=> 'toggle',
		'label' 			=> esc_html__( 'Track page title', 'fupi' ),
		'class'				=> 'fupi_standard',
		'field_id' 			=> 'track_pagetitle',
		'option_arr_id'		=> $option_arr_id,
	),
	array(
		'type'	 			=> 'toggle',
		'label' 			=> esc_html__( 'Track archive and page numbers', 'fupi' ),
		'class'				=> 'fupi_standard',
		'field_id' 			=> 'track_pagenum',
		'option_arr_id'		=> $option_arr_id,
	),
	array(
		'type'	 			=> 'toggle',
		'label' 			=> esc_html__( 'Track page language', 'fupi' ),
		'class'				=> 'fupi_standard',
		'field_id' 			=> 'page_lang',
		'option_arr_id'		=> $option_arr_id,
	),
	array(
		'type'	 			=> 'toggle',
		'label' 			=> esc_html__( 'Track post and page publish dates', 'fupi' ),
		'class'				=> 'fupi_standard',
		'field_id' 			=> 'track_pobdate',
		'option_arr_id'		=> $option_arr_id,
	),
	array(
		'type'	 			=> 'toggle',
		'label' 			=> esc_html__( 'Track page id', 'fupi' ),
		'class'				=> 'fupi_standard',
		'field_id' 			=> 'track_pageid',
		'option_arr_id'		=> $option_arr_id,
	),
	array(
		'type'	 			=> 'toggle',
		'label' 			=> esc_html__( 'Track post terms', 'fupi' ),
		'class'				=> 'fupi_standard',
		'field_id' 			=> 'track_terms',
		'option_arr_id'		=> $option_arr_id,
		'el_class'			=> 'fupi_condition',
		'el_data_target'	=> 'fupi_track_terms_opts',
		'under field'		=> esc_html__( 'Terms are e.g. tags and categories of posts and pages.', 'fupi'),
	),
	array(
		'type'	 			=> 'toggle',
		'label' 			=> esc_html__( 'Add taxonomy slug to term name', 'fupi' ),
		'field_id' 			=> 'add_tax_term_cat',
		'option_arr_id'		=> $option_arr_id,
		'class'				=> 'fupi_sub fupi_track_terms_opts fupi_disabled fupi_standard',
		'under field'		=> esc_html__( 'If you use on your site both tags, categories or other taxonomies use taxonomy slugs to distinguish one from the other e.g. "analytics (category)"', 'fupi'),
	),
	array(
		'type'	 			=> 'toggle',
		'label' 			=> esc_html__( 'Send term names instead of term slugs', 'fupi' ),
		'field_id' 			=> 'send_tax_terms_titles',
		'option_arr_id'		=> $option_arr_id,
		'class'				=> 'fupi_sub fupi_track_terms_opts fupi_disabled',
		'under field'		=> esc_html__( 'Enable this to track term titles (e.g. product category) instead of their slugs (e.g. product_category). Enabling this feature is not recommended since term names are changed more often then slugs.', 'fupi'),
	),
	array(
		'type'	 			=> 'toggle',
		'label' 			=> esc_html__( 'Track author\'s display names', 'fupi' ),
		'field_id' 			=> 'track_author',
		'class'				=> 'fupi_standard',
		'option_arr_id'		=> $option_arr_id,
		'under field'			=> esc_html__( 'Display names are names that are displayed to visitors.', 'fupi'),
	),
	array(
		'type'	 			=> 'toggle',
		'label' 			=> esc_html__( 'Track searched phrases', 'fupi' ),
		'class'				=> 'fupi_standard',
		'field_id' 			=> 'track_search',
		'option_arr_id'		=> $option_arr_id,
	),
);

foreach( $fields as $field ){
	add_settings_field( $field['field_id'], $field['label'], array( $this, 'fupi_field_html' ), $page, $section_id, $field );
}

// USER DETAILS

$section_id = 'fupi_fbp1_user';
add_settings_section( $section_id, esc_html__( 'Track user info', 'fupi' ), array( $this, 'fupi_sections_descriptions'), $page );

$fields = array(
	array(
		'type'	 			=> 'toggle',
		'label' 			=> esc_html__( 'Track login status and user role', 'fupi' ),
		'field_id' 			=> 'track_user_role',
		'class'				=> 'fupi_standard',
		'option_arr_id'		=> $option_arr_id,
	),
	array(
		'type'	 			=> 'toggle',
		'label' 			=> esc_html__( 'Track visitor\'s browser language', 'fupi' ),
		'field_id' 			=> 'track_lang',
		'class'				=> 'fupi_standard',
		'option_arr_id'		=> $option_arr_id,
	),
);

foreach( $fields as $field ){
	add_settings_field( $field['field_id'], $field['label'], array( $this, 'fupi_field_html' ), $page, $section_id, $field );
}

// TRACK ENGAGEMENT TIME

$section_id = 'fupi_fbp1_engage';
add_settings_section( $section_id, esc_html__( 'Track user engagement', 'fupi' ), array( $this, 'fupi_sections_descriptions'), $page );

$fields = array(
	array(
		'type'	 			=> 'toggle',
		'label' 			=> esc_html__( 'Track time of user engagement', 'fupi' ),
		'field_id' 			=> 'track_engagement',
		'class'				=> 'fupi_standard',
		'option_arr_id'		=> $option_arr_id,
		'under field'		=> sprintf(esc_html__( '* Not supported by Internet Explorer', 'fupi'), '<a href="https://fullpictureplugin.com/?p=888&utm_source=useradmin&utm_medium=settings&utm_campaign=settings_link">', '</a><br><br>' ),
	),
);

foreach( $fields as $field ){
	add_settings_field( $field['field_id'], $field['label'], array( $this, 'fupi_field_html' ), $page, $section_id, $field );
}

// E-COMMERCE

$section_id = 'fupi_fbp1_ecomm';
add_settings_section( $section_id, esc_html__( 'Track e-commerce (PRO)', 'fupi' ), array( $this, 'fupi_sections_descriptions'), $page );

?>
