<?php

$page = 'fupi_ga1';

// BASIC SETUP

$section_id 		= 'fupi_ga1_basic';
add_settings_section( $section_id, esc_html__( 'Basic settings', 'fupi' ), array( $this, 'fupi_sections_descriptions'), $page );

if ( $this->cook_enabled ){
	$cook_opt = array(
		'type'	 			=> 'toggle',
		'label' 			=> esc_html__( 'Load Google Analytics UA without waiting for cookie consent', 'fupi' ),
		'field_id' 			=> 'disreg_cookies',
		'option_arr_id'		=> $option_arr_id,
		'under field'		=> esc_html__( 'This option has an effect only if you chose to load tracking tools after user gives their consent to cookies. Enable it to validate your Google Analytics UA and Google Optimize (gtag installation) installations. By leaving it enabled you make your website not compliant with Cookie Law.', 'fupi'),
	);
} else {
	$cook_opt = array(
		'type'				=> 'hidden',
		'field_id' 			=> 'disreg_cookies', // database version
		'label'				=> '', // not used but required in foreach below
	);
}

$fields = array(
	array(
		'type'	 			=> 'text',
		'label' 			=> esc_html__( 'Google Analytics Tracking ID', 'fupi' ),
		'field_id' 			=> 'tracking_id',
		'class'				=> 'fupi_required fupi_easy',
		'option_arr_id'		=> $option_arr_id,
		'label_for' 		=> $option_arr_id . '[tracking_id]',
		'placeholder'		=> 'UA-00000000-0',
		'under field'			=> '<a href="https://www.youtube.com/watch?v=8IyawdwcMu4" class="fupi_vid_link fupi_vid" data-srcid="8IyawdwcMu4"><i class="dashicons dashicons-youtube"></i> <span>' . esc_html__('How to get tracking ID (2:14 min)','fupi'). '</span></a><br><br>' . sprintf(esc_html__( 'A quick tip: If you have more sites %1$sin this domain%2$s and your users move from one to another, e.g. from store.com to cart.store.com, you can use this tracking ID on all of them. It will give you full view on user sessions and movement between all these sites.', 'fupi'), '<strong>', '</strong>' ),
	),
	array(
		'type' 				=> 'toggle',
		'label' 			=> esc_html__( 'Anonymize IP', 'fupi' ),
		'field_id' 			=> 'anonimize',
		'class'				=> 'fupi_easy',
		'option_arr_id'		=> $option_arr_id,
		'under field'		=> esc_html__( 'Anonymize visitor IP to comply with privacy regulations in some countries (mostly in the EU). Enabling this option lowers the accuracy of city-level location tracking.', 'fupi')
	),
	array(
		'type' 				=> 'toggle',
		'label' 			=> esc_html__( 'Avoid issues while using multiple GA integrations', 'fupi' ),
		'class'				=> 'fupi_standard',
		'field_id' 			=> 'cookie_prefix',
		'option_arr_id'		=> $option_arr_id,
		'under field'		=> esc_html__( 'Attention! This setting changes GA cookie prefix. It is best to enable it on a website where the currently used tracking ID has never been used before. Otherwise your returning visitors will be counted as new visitors (thankfully just once).', 'fupi'),
	),
	$cook_opt,
);

foreach( $fields as $field ){
	add_settings_field( $field['field_id'], $field['label'], array( $this, 'fupi_field_html' ), $page, $section_id, $field );
}

// ADVANCED SETUP

$section_id 		= 'fupi_ga1_advanced';
add_settings_section( $section_id, esc_html__( 'Advanced settings*', 'fupi' ), array( $this, 'fupi_sections_descriptions'), $page );

$fields = array(
	array(
		'type'	 			=> 'toggle',
		'label' 			=> esc_html__( 'Track logged-in users across devices and browsers', 'fupi' ),
		'field_id' 			=> 'set_user_id',
		'option_arr_id'		=> $option_arr_id,
		'under field'		=> sprintf(esc_html__( 'Requires %1sadditional setup%2s.', 'fupi'), '<strong><a href="https://fullpictureplugin.com/?p=883&utm_source=useradmin&utm_medium=settings&utm_campaign=settings_link" target="_blank">', '</a></strong>' ),
	),
	array(
		'type'	 			=> 'text',
		'label' 			=> esc_html__( 'Track your users move between this domain and:', 'fupi' ),
		'field_id' 			=> 'cross_domain',
		'option_arr_id'		=> $option_arr_id,
		'label_for' 		=> $option_arr_id . '[cross_domain]',
		'class'				=> $disable_for_free_class,
		'placeholder'		=> 'different-domain.com',
		'tooltip' 			=> esc_html__( 'Separate multiple domains with comas', 'fupi' ),
		'under field'		=> sprintf(esc_html__( 'Requires %1sadditional setup%2s.', 'fupi'), '<strong><a href="https://support.google.com/analytics/answer/7476333?hl=en" target="_blank">', '</a></strong>' ) . '<br><br>' .sprintf(esc_html__( 'Use it to track your users move between multiple %1sdifferent%2s domains that belong to you (e.g. company.com and store.com). You need to use the currently used tracking ID on all of them.', 'fupi'), '<strong>', '</strong>' ),
	),
	array(
		'type' 				=> 'toggle',
		'label' 			=> esc_html__( 'Enable cross-domain form redirects', 'fupi' ),
		'field_id' 			=> 'cross_domain_forms',
		'class'				=> $disable_for_free_class,
		'option_arr_id'		=> $option_arr_id,
		'tooltip'			=> esc_html__( 'Enable this function if any form on your site redirects to a cross-tracked domain after form submission.', 'fupi'),
	),
);

foreach( $fields as $field ){
	add_settings_field( $field['field_id'], $field['label'], array( $this, 'fupi_field_html' ), $page, $section_id, $field );
}

// CLICK TRACKING

$section_id = 'fupi_ga1_clicks';
add_settings_section( $section_id, esc_html__( 'Track clicks', 'fupi' ), array( $this, 'fupi_sections_descriptions'), $page );

$fields = array(
	array(
		'type'	 			=> 'toggle',
		'label' 			=> esc_html__( 'Track clicks on outbound links', 'fupi' ),
		'field_id' 			=> 'track_outbound',
		'class'				=> 'fupi_standard',
		'option_arr_id'		=> $option_arr_id,
		'under field'		=> esc_html__( 'Tracks clicks on all links that lead to other domains. Attention! Affiliate links leading to other sites and links to cross-tracked sites are also treated as outbound.', 'fupi'),
	),
	array(
		'type'	 			=> 'repeater',
		'label' 			=> esc_html__( 'Track clicks on affiliate links', 'fupi' ),
		'field_id' 			=> 'track_affiliate',
		'class'				=> 'fupi_repeater_section',
		'el_class'			=> 'fupi_condition',
		'el_data_target'	=> 'fupi_track_affiliate_interact',
		'el_data_field1_txt' => esc_html__( 'url part, e.g. /go/', 'fupi' ),
		'el_data_field1_type' => 'url_part',
		'el_data_field1_req' => esc_html__( 'this field is required', 'fupi' ),
		'el_data_field1_err' => '',
		'el_data_field2_txt' => esc_html__( 'name (optional)', 'fupi' ),
		'el_data_field2_req' => '',
		'el_data_field2_err' => esc_html__( 'only alphanumeric characters, spaces, hyphens, underscores and [ ] symbols', 'fupi' ),
		'option_arr_id'		=> $option_arr_id,
		'label_for' 		=> $option_arr_id . '[track_affiliate]',
		'under field' 		=> esc_html__( 'If you don\'t provide a name, a full link address will be visible in GA\'s report.', 'fupi' ),
	),
	array(
		'type'	 			=> 'toggle',
		'label' 			=> esc_html__( 'Treat as important events (interactions)', 'fupi' ),
		'field_id' 			=> 'track_affil_intr',
		'class'				=> 'fupi_sub fupi_track_affiliate_interact fupi_disabled',
		'option_arr_id'		=> $option_arr_id,
	),
	array(
		'type'	 			=> 'toggle',
		'label' 			=> esc_html__( 'Track clicks on email and tel. links', 'fupi' ),
		'field_id' 			=> 'track_email_tel',
		'class'				=> 'fupi_standard',
		'el_class'			=> 'fupi_condition',
		'el_data_target'	=> 'fupi_track_email_tel_interact',
		'option_arr_id'		=> $option_arr_id,
	),
	array(
		'type'	 			=> 'toggle',
		'label' 			=> esc_html__( 'Treat as important events (interactions)', 'fupi' ),
		'field_id' 			=> 'track_email_tel_intr',
		'class'				=> 'fupi_sub fupi_track_email_tel_interact fupi_disabled fupi_standard',
		'option_arr_id'		=> $option_arr_id,
	),
	array(
		'type'	 			=> 'text',
		'label' 			=> esc_html__( 'Track clicks on file download links', 'fupi' ),
		'field_id' 			=> 'track_file_downl',
		'placeholder'		=> 'e.g. pdf, doc, docx, xls, xlsx, txt',
		'class'				=> 'fupi_standard',
		'el_class'			=> 'fupi_condition',
		'el_data_target'	=> 'fupi_track_file_downl_intr',
		'option_arr_id'		=> $option_arr_id,
		'label_for' 		=> $option_arr_id . '[track_file_downl]',
		'under field'		=> esc_html__( 'Enter coma separated list of file formats (extensions) you want to track', 'fupi'),
	),
	array(
		'type'	 			=> 'toggle',
		'label' 			=> esc_html__( 'Treat as important events (interactions)', 'fupi' ),
		'field_id' 			=> 'track_downl_intr',
		'class'				=> 'fupi_sub fupi_track_file_downl_intr fupi_disabled fupi_standard',
		'option_arr_id'		=> $option_arr_id,
	),
	array(
		'type'	 			=> 'repeater',
		'label' 			=> esc_html__( 'Track clicks on page elements', 'fupi' ),
		'field_id' 			=> 'track_elems',
		'class'				=> 'fupi_repeater_section',
		'el_class'			=> 'fupi_condition',
		'el_data_target'	=> 'fupi_track_elems_intr',
		'el_data_field1_txt' => esc_html__( 'CSS selector e.g. #sth img', 'fupi' ),
		'el_data_field1_req' => esc_html__( 'this field is required', 'fupi' ),
		'el_data_field1_err' => esc_html__( 'incorrect selector', 'fupi' ),
		'el_data_field2_txt' => esc_html__( 'element name (required)', 'fupi' ),
		'el_data_field2_req' => esc_html__( 'this field is required', 'fupi' ),
		'el_data_field2_err' => esc_html__( 'only alphanumeric characters, spaces, hyphens, underscores and [ ] symbols', 'fupi' ),
		'option_arr_id'		=> $option_arr_id,
		'label_for' 		=> $option_arr_id . '[track_elems]',
	),
	array(
		'type'	 			=> 'toggle',
		'label' 			=> esc_html__( 'Treat as important events (interactions)', 'fupi' ),
		'field_id' 			=> 'track_elems_intr',
		'class'				=> 'fupi_sub fupi_track_elems_intr fupi_disabled',
		'option_arr_id'		=> $option_arr_id,
	),
);

foreach( $fields as $field ){
	add_settings_field( $field['field_id'], $field['label'], array( $this, 'fupi_field_html' ), $page, $section_id, $field );
}

// FORM TRACKING

$section_id = 'fupi_ga1_forms';
add_settings_section( $section_id, esc_html__( 'Track forms', 'fupi' ), array( $this, 'fupi_sections_descriptions'), $page );

$fields = array(
	array(
		'type'	 			=> 'repeater',
		'label' 			=> esc_html__( 'Track form submissions', 'fupi' ),
		'field_id' 			=> 'track_forms',
		'class'				=> 'fupi_repeater_section',
		'el_class'			=> 'fupi_condition',
		'el_data_target'	=> 'fupi_track_forms',
		'el_data_field1_txt' => esc_html__( 'CSS selector e.g. #form_id', 'fupi' ),
		'el_data_field1_req' => esc_html__( 'this field is required', 'fupi' ),
		'el_data_field1_err' => esc_html__( 'incorrect selector', 'fupi' ),
		'el_data_field2_txt' => esc_html__( 'form name (required)', 'fupi' ),
		'el_data_field2_req' => esc_html__( 'this field is required', 'fupi' ),
		'el_data_field2_err' => esc_html__( 'only alphanumeric characters, spaces, hyphens, underscores and [ ] symbols', 'fupi' ),
		'option_arr_id'		=> $option_arr_id,
		'label_for' 		=> $option_arr_id . '[track_forms]',
		'under field'		=> esc_html__( 'Test this feature after enabling. There are many methods of submitting forms. If this method of tracking fails on your form, set up tracking clicks on "submit" button instead.', 'fupi'),
	),
	array(
		'type'	 			=> 'toggle',
		'label' 			=> esc_html__( 'Treat as important events (interactions)', 'fupi' ),
		'field_id' 			=> 'track_formsubm_intr',
		'class'				=> 'fupi_sub fupi_track_forms fupi_disabled',
		'option_arr_id'		=> $option_arr_id,
	),
);

foreach( $fields as $field ){
	add_settings_field( $field['field_id'], $field['label'], array( $this, 'fupi_field_html' ), $page, $section_id, $field );
}

// VIEWS & SCROLLS TRACKING

$section_id = 'fupi_ga1_scrolls';
add_settings_section( $section_id, esc_html__( 'Track scrolls & visibility', 'fupi' ), array( $this, 'fupi_sections_descriptions'), $page );

$fields = array(
	array(
		'type'	 			=> 'repeater',
		'label' 			=> esc_html__( 'Track when these elements become visible', 'fupi' ),
		'field_id' 			=> 'track_views',
		'el_class'			=> 'fupi_condition',
		'el_data_target'	=> 'fupi_track_views_intr',
		'class'				=> 'fupi_repeater_section',
		'el_data_field1_txt' => esc_html__( 'CSS selector e.g. .side img', 'fupi' ),
		'el_data_field1_req' => esc_html__( 'this field is required', 'fupi' ),
		'el_data_field1_err' => esc_html__( 'incorrect selector', 'fupi' ),
		'el_data_field2_txt' => esc_html__( 'element name (required)', 'fupi' ),
		'el_data_field2_req' => esc_html__( 'this field is required', 'fupi' ),
		'el_data_field2_err' => esc_html__( 'only alphanumeric characters, spaces, hyphens, underscores and [ ] symbols', 'fupi' ),
		'option_arr_id'		=> $option_arr_id,
		'label_for' 		=> $option_arr_id . '[track_views]',
		'under field'		=> esc_html__( 'Use this function to track when elements are scrolled into the visible area of the page OR when they become visible (like popups). Elements are counted as "visible" when they are 200px inside the viewport. Each view is counted once per page view.', 'fupi'),
	),
	array(
		'type'	 			=> 'toggle',
		'label' 			=> esc_html__( 'Treat as important events (interactions)', 'fupi' ),
		'field_id' 			=> 'track_views_intr',
		'class'				=> 'fupi_sub fupi_track_views_intr fupi_disabled',
		'option_arr_id'		=> $option_arr_id,
		'under field' 		=> esc_html__( 'Not recommended in most cases.', 'fupi' ),
	),
	array(
		'type'	 			=> 'text',
		'label' 			=> esc_html__( 'Track when visitors scroll to:', 'fupi' ),
		'placeholder'		=> esc_html__( 'e.g. 25, 50, 75', 'fupi' ),
		'after field'		=> esc_html__( '% of page height', 'fupi'),
		'field_id' 			=> 'track_scroll',
		'class'				=> 'fupi_standard',
		'el_class'			=> 'fupi_condition',
		'el_data_target'	=> 'fupi_track_scroll_intr',
		'option_arr_id'		=> $option_arr_id,
		'label_for' 		=> $option_arr_id . '[track_scroll]',
		'under field'		=> esc_html__( 'Separate multiple values with comas. Do not use "%" symbol.', 'fupi'),
	),
	array(
		'type'	 			=> 'number',
		'label' 			=> esc_html__( 'Track scroll if visitor scrolled more than:', 'fupi' ),
		'default'			=> '200',
		'after field'		=> esc_html__( 'pixels.', 'fupi'),
		'field_id' 			=> 'track_scroll_min',
		'class'				=> 'fupi_sub fupi_track_scroll_intr fupi_disabled',
		'option_arr_id'		=> $option_arr_id,
		'label_for' 		=> $option_arr_id . '[track_scroll_min]',
		'under field'		=> esc_html__( 'Prevents firing events on short pages. Default is 200px.', 'fupi'),
	),
	array(
		'type'	 			=> 'number',
		'label' 			=> esc_html__( 'Do not track scroll if it happened in the first:', 'fupi' ),
		'default'			=> '5',
		'after field'		=> esc_html__( 'seconds', 'fupi' ),
		'field_id' 			=> 'track_scroll_time',
		'class'				=> 'fupi_sub fupi_track_scroll_intr fupi_disabled',
		'option_arr_id'		=> $option_arr_id,
		'label_for' 		=> $option_arr_id . '[track_scroll_time]',
		'under field'		=> esc_html__( 'Prevents tracking "exploratory" scrolls. The event will fire if the visitor is still below the specified scroll depth after the time has passed. Default is 5 seconds. Enter 0 or leave empty to disable.', 'fupi'),
	),
	array(
		'type'	 			=> 'toggle',
		'label' 			=> esc_html__( 'Treat as important events (interactions)', 'fupi' ),
		'field_id' 			=> 'track_scroll_intr',
		'class'				=> 'fupi_sub fupi_track_scroll_intr fupi_disabled fupi_standard',
		'option_arr_id'		=> $option_arr_id,
		'under field' 		=> esc_html__( 'Not recommended in most cases.', 'fupi' ),
	),
);

foreach( $fields as $field ){
	add_settings_field( $field['field_id'], $field['label'], array( $this, 'fupi_field_html' ), $page, $section_id, $field );
}

// URL TRACKING

$section_id = 'fupi_ga1_urls';
add_settings_section( $section_id, esc_html__( 'Track URLs', 'fupi' ), array( $this, 'fupi_sections_descriptions'), $page );

$fields = array(
	array(
		'type'	 			=> 'radio',
		'label' 			=> esc_html__( 'What to do if a page URL is changed with AJAX (without refreshing)', 'fupi' ),
		'field_id' 			=> 'track_dynamic_urls',
		'option_arr_id'		=> $option_arr_id,
		'options' 			=> array(
			'0'					=> esc_html__( 'Do nothing', 'fupi' ),
			'nonint_evt'		=> esc_html__( 'Track as a not important event (non-interaction)', 'fupi' ),
			'int_evt'			=> esc_html__( 'Track as an important event (interaction)', 'fupi' ),
			'pageview'			=> esc_html__( 'Track as a new page view', 'fupi' ),
		),
		'default'			=> '0',
	),
	array(
		'type'	 			=> 'radio',
		'label' 			=> esc_html__( 'Track clicks on links that lead to elements on the same page?', 'fupi' ),
		'field_id' 			=> 'track_anchor_clicks',
		'option_arr_id'		=> $option_arr_id,
		'options' 			=> array(
			'0'					=> esc_html__( 'Don\'t track', 'fupi' ),
			'nonint_evt'		=> esc_html__( 'Track as not important events (non-interactions)', 'fupi' ),
			'int_evt'			=> esc_html__( 'Track as important events (interactions)', 'fupi' ),
			'pageview'			=> esc_html__( 'Track as new page views (recommended only for single-page websites)', 'fupi' ),
		),
		'default'			=> '0',
		'under field'		=> esc_html__( 'If you want to treat clicks as pageviews you might consider enabling the option to "reset engagement timer after clicks in anchors" in the "Main settings" tab > "Global settings".', 'fupi'),
	),
	array(
		'type'	 			=> 'toggle',
		'label' 			=> esc_html__( 'Treat pages with different anchors in the URL as different pages', 'fupi' ),
		'field_id' 			=> 'track_anchor_pageviews',
		'option_arr_id'		=> $option_arr_id,
		'under field'		=> esc_html__( 'By default Google Analytics does not distinguish between example.com/page and example.com/page#contact. Enable this option to treat them as separate pages. This can be very useful for single-page websites and online documentations.', 'fupi'),
	),
);

foreach( $fields as $field ){
	add_settings_field( $field['field_id'], $field['label'], array( $this, 'fupi_field_html' ), $page, $section_id, $field );
}

// WP DATA TRACKING

$section_id = 'fupi_ga1_wpdata';
add_settings_section( $section_id, esc_html__( 'Track WP data', 'fupi' ), array( $this, 'fupi_sections_descriptions'), $page );

$fields = array(
	array(
		'type'	 			=> 'number',
		'label' 			=> esc_html__( 'Track page IDs', 'fupi' ),
		'field_id' 			=> 'page_id_dimens',
		'option_arr_id'		=> $option_arr_id,
		'label_for' 		=> $option_arr_id . '[page_id_dimens]',
		'under field'		=> esc_html__( 'Enter the index number of the custom dimension (with "Hit" scope). 0 or empty to disable.', 'fupi'),
	),
	array(
		'type'	 			=> 'number',
		'label' 			=> esc_html__( 'Track page numbers', 'fupi' ),
		'field_id' 			=> 'page_number_dimens',
		'option_arr_id'		=> $option_arr_id,
		'label_for' 		=> $option_arr_id . '[page_number_dimens]',
		'under field'		=> sprintf( esc_html__( 'Enter the index number of the custom dimension (with "Hit" scope). 0 or empty to disable.%1$sTrack the page number of posts broken into multiple pages, categories, posts, etc.', 'fupi'), '<br>' ),
	),
	array(
		'type'	 			=> 'number',
		'label' 			=> esc_html__( 'Track author\'s display names', 'fupi' ),
		'field_id' 			=> 'author_dimens',
		'option_arr_id'		=> $option_arr_id,
		'label_for' 		=> $option_arr_id . '[author_dimens]',
		'under field'		=> sprintf( esc_html__( 'Tracking personally identifiable information is against Google\'s policy. Enable this option only if authors\' names are their pseudonyms. %1sEnter the index number of the custom dimension (with "Hit" scope). 0 or empty to disable.', 'fupi'), '<br><br>' ),
	),
	array(
		'type'	 			=> 'number',
		'label' 			=> esc_html__( 'Track authors IDs', 'fupi' ),
		'field_id' 			=> 'author_id_dimens',
		'option_arr_id'		=> $option_arr_id,
		'label_for' 		=> $option_arr_id . '[author_id_dimens]',
		'under field'		=> esc_html__( 'Enter the index number of the custom dimension (with "Hit" scope). 0 or empty to disable.', 'fupi'),
	),
	array(
		'type'	 			=> 'number',
		'label' 			=> esc_html__( 'Track post and page publish dates', 'fupi' ),
		'field_id' 			=> 'post_date_dimens',
		'option_arr_id'		=> $option_arr_id,
		'label_for' 		=> $option_arr_id . '[post_date_dimens]',
		'under field'		=> esc_html__( 'Enter the index number of the custom dimension (with "Hit" scope). 0 or empty to disable.', 'fupi'),
	),
	array(
		'type'	 			=> 'number',
		'label' 			=> esc_html__( 'Track visitor\'s login status and role', 'fupi' ),
		'field_id' 			=> 'user_role_dimens',
		'option_arr_id'		=> $option_arr_id,
		'label_for' 		=> $option_arr_id . '[user_role_dimens]',
		'under field'		=> esc_html__( 'Enter the index number of the custom dimension (with "Hit" scope). 0 or empty to disable.', 'fupi'),
	),
	array(
		'type'	 			=> 'number',
		'label' 			=> esc_html__( 'Track page language', 'fupi' ),
		'field_id' 			=> 'page_lang_dimens',
		'option_arr_id'		=> $option_arr_id,
		'label_for' 		=> $option_arr_id . '[page_lang_dimens]',
		'under field'		=> esc_html__( 'Enter the index number of the custom dimension (with "Hit" scope). 0 or empty to disable.', 'fupi'),
	),
	array(
		'type'	 			=> 'number',
		'label' 			=> esc_html__( 'Track terms', 'fupi' ),
		'field_id' 			=> 'tax_terms_dimens',
		'option_arr_id'		=> $option_arr_id,
		'label_for' 		=> $option_arr_id . '[tax_terms_dimens]',
		'el_class'			=> 'fupi_condition',
		'el_data_target'	=> 'fupi_tax_terms_opts',
		'under field'		=> sprintf( esc_html__( 'Terms are e.g. tags and categories of posts and pages.%1sEnter the index number of the custom dimension (with "Hit" scope). 0 or empty to disable.', 'fupi'), '<br><br>' ),
	),
	array(
		'type'	 			=> 'toggle',
		'label' 			=> esc_html__( 'Add taxonomy slug to term name', 'fupi' ),
		'field_id' 			=> 'add_tax_term_cat',
		'option_arr_id'		=> $option_arr_id,
		'class'				=> 'fupi_sub fupi_tax_terms_opts fupi_disabled',
		'under field'		=> esc_html__( 'If you use on your site both tags, categories or other taxonomies use taxonomy slugs to distinguish in GA reports one from the other e.g. "analytics (category)"', 'fupi'),
	),
	array(
		'type'	 			=> 'toggle',
		'label' 			=> esc_html__( 'Send term names instead of term slugs', 'fupi' ),
		'field_id' 			=> 'send_tax_terms_titles',
		'option_arr_id'		=> $option_arr_id,
		'class'				=> 'fupi_sub fupi_tax_terms_opts fupi_disabled',
		'under field'		=> esc_html__( 'Enable this to send term titles (e.g. product category) instead of their slugs (e.g. product_category). Enabling this feature is not recommended since term names are changed more often then slugs.', 'fupi'),
	),
	array(
		'type'	 			=> 'toggle',
		'label' 			=> esc_html__( 'Show clean page titles in GA reports', 'fupi' ),
		'field_id' 			=> 'clean_page_title',
		'el_class'			=> 'fupi_condition',
		'el_data_target'	=> 'fupi_seo_title',
		'option_arr_id'		=> $option_arr_id,
		'under field'		=> esc_html__( 'Show clean page titles in GA reports instead of the text from "title" meta tag (a.k.a. SEO title). This is useful to prevent seeing multiple entries of the same page in your GA reports but with diffferent SEO titles.', 'fupi'),
	),
	array(
		'type'	 			=> 'number',
		'label' 			=> esc_html__( 'Track SEO titles', 'fupi' ),
		'field_id' 			=> 'seo_title_dimens',
		'option_arr_id'		=> $option_arr_id,
		'label_for' 		=> $option_arr_id . '[seo_title_dimens]',
		'class'				=> 'fupi_sub fupi_seo_title fupi_disabled',
		'under field'		=> esc_html__( 'By enabling this function you can track SEO titles in a separate dimension - makes analysis of SEO texts simpler. Enter the index number of the custom dimension (with "Hit" scope). 0 or empty to disable.', 'fupi'),
	),
);

foreach( $fields as $field ){
	add_settings_field( $field['field_id'], $field['label'], array( $this, 'fupi_field_html' ), $page, $section_id, $field );
}

// CUSTOM METRICS

$section_id = 'fupi_ga1_custom_metrics';
add_settings_section( $section_id, esc_html__( 'Custom metrics', 'fupi' ), array( $this, 'fupi_sections_descriptions'), $page );

$fields = array(
	array(
		'type'	 			=> 'number',
		'label' 			=> esc_html__( 'Track how long the user was actively engaged with the content', 'fupi' ),
		'field_id' 			=> 'track_engagement',
		'option_arr_id'		=> $option_arr_id,
		'label_for' 		=> $option_arr_id . '[track_engagement]',
		'under field'		=> sprintf( esc_html__( 'Enter the index number of the custom metric (scope "Hit", formatting "Time") and follow %1$sadditional steps%2$s. Enter 0 or leave empty to disable.', 'fupi'), '<a href="https://www.youtube.com/watch?v=PT2_VMl_egY" class="fupi_vid_link fupi_vid" data-srcid="PT2_VMl_egY" target="_blank"><i class="dashicons dashicons-youtube"></i> <span>', '</span></a>' ),
	),
	array(
		'type'	 			=> 'number',
		'label' 			=> esc_html__( 'Track the number of search results', 'fupi' ),
		'field_id' 			=> 'search_results_metr',
		'option_arr_id'		=> $option_arr_id,
		'label_for' 		=> $option_arr_id . '[search_results_metr]',
		'under field'		=> esc_html__( 'Enter the index number of the custom metric (scope "Hit", formatting "Integer"). 0 or empty to disable.', 'fupi'),
	),
);

foreach( $fields as $field ){
	add_settings_field( $field['field_id'], $field['label'], array( $this, 'fupi_field_html' ), $page, $section_id, $field );
}

// CUSTOM GROUPING

$section_id = 'fupi_ga1_custom_grouping';
add_settings_section( $section_id, esc_html__( 'Custom content grouping', 'fupi' ), array( $this, 'fupi_sections_descriptions'), $page );

$fields = array(
	array(
		'type'	 			=> 'number',
		'label' 			=> esc_html__( 'Enable "Page Type" content grouping"', 'fupi' ),
		'field_id' 			=> 'page_type_grouping',
		'option_arr_id'		=> $option_arr_id,
		'label_for' 		=> $option_arr_id . '[page_type_grouping]',
		'under field'		=> esc_html__( 'Enter the index number of the custom content grouping. Empty or 0 to disable.', 'fupi'),
	),
);

foreach( $fields as $field ){
	add_settings_field( $field['field_id'], $field['label'], array( $this, 'fupi_field_html' ), $page, $section_id, $field );
}

// ERROR TRACKING

$section_id = 'fupi_ga1_errors';
add_settings_section( $section_id, esc_html__( 'Track errors', 'fupi' ), array( $this, 'fupi_sections_descriptions'), $page );

$fields = array(
	array(
		'type'	 			=> 'number',
		'label' 			=> esc_html__( 'Track JavaScript errors', 'fupi' ),
		'field_id' 			=> 'js_err_dimens',
		'class'				=> $disable_for_free_class,
		'option_arr_id'		=> $option_arr_id,
		'label_for' 		=> $option_arr_id . '[js_err_dimens]',
		'under field'		=> sprintf( esc_html__( 'When enabled, Full Picture will send to Google Analytics events when JavaScript errors occur on your site. Attention! If your site has many errors, the number of events may exceed Google Analytics limit. Use with caution over a short period of time.%1$sEnter the index number of the custom dimension (with "Hit" scope). 0 or empty to disable.', 'fupi'), '<br><br>' ),
	),
);

foreach( $fields as $field ){
	add_settings_field( $field['field_id'], $field['label'], array( $this, 'fupi_field_html' ), $page, $section_id, $field );
}

// E-COMMERCE

$section_id = 'fupi_ga1_ecomm';
add_settings_section( $section_id, esc_html__( 'E-Commerce tracking (PRO)', 'fupi' ), array( $this, 'fupi_sections_descriptions'), $page );

$fields = array(
	array(
		'type'	 			=> 'number',
		'label' 			=> esc_html__( 'Wait before sending impressions', 'fupi' ),
		'field_id' 			=> 'send_impress_wait',
		'option_arr_id'		=> $option_arr_id,
		'label_for' 		=> $option_arr_id . '[send_impress_wait]',
		'default'			=> 2,
		'class'				=> $disable_for_free_class,
		'after field' 		=> esc_html__('second(s)', 'fupi'),
		'under field' 		=> esc_html__('Default is 2 seconds. We recommended not to send event with product impressions right after the page loads. Make sure the products are actually seen by waiting at least 2 seconds.', 'fupi'),
	),
	array(
		'type'	 			=> 'number',
		'label' 			=> esc_html__( 'Send product impressions in batches of', 'fupi' ),
		'field_id' 			=> 'impress_sent_limit',
		'option_arr_id'		=> $option_arr_id,
		'label_for' 		=> $option_arr_id . '[impress_sent_limit]',
		'default'			=> 10,
		'class'				=> $disable_for_free_class,
		'after field' 		=> esc_html__('products per event.', 'fupi'),
		'under field' 		=> esc_html__('This function prevents sending too much data to tracking tools with a single event. By default FP sends information on up to 10 product impressions in a single event. Best keep it between 10 and 20.', 'fupi'),
	),
	array(
		'type'	 			=> 'number',
		'label' 			=> esc_html__( 'Send events with product impressions every:', 'fupi' ),
		'field_id' 			=> 'send_impress_every',
		'option_arr_id'		=> $option_arr_id,
		'label_for' 		=> $option_arr_id . '[send_impress_every]',
		'default'			=> 1000,
		'class'				=> $disable_for_free_class,
		'after field' 		=> esc_html__('miliseconds', 'fupi'),
		'under field' 		=> esc_html__('Default is 1000 milisecond (1 second). Example. If you have 15 product teasers on page, Full Picture will send to GA 10 impressions in the first event and the rest in the next one, 1 second later.', 'fupi'),
	),
);

foreach( $fields as $field ){
	add_settings_field( $field['field_id'], $field['label'], array( $this, 'fupi_field_html' ), $page, $section_id, $field );
}

// DEPRECATED

$section_id = 'fupi_ga1_deprecated';
add_settings_section( $section_id, esc_html__( 'Deprecated**', 'fupi' ), array( $this, 'fupi_sections_descriptions'), $page );

$fields = array(
	array(
		'type'	 			=> 'number',
		'label' 			=> esc_html__( 'Track the use of ad blockers', 'fupi' ),
		'field_id' 			=> 'detect_adblock',
		'el_class'			=> 'fupi_condition',
		'el_data_target'	=> 'fupi_adblock_session',
		'option_arr_id'		=> $option_arr_id,
		'label_for' 		=> $option_arr_id . '[detect_adblock]',
		'under field'		=> esc_html__( 'Enter the index number of the custom dimension (with "Hit" scope). 0 or empty to disable.', 'fupi'),
	),
	array(
		'type'	 			=> 'toggle',
		'label' 			=> esc_html__( 'Track the use of ad blockers once per session instead of on every page', 'fupi' ),
		'field_id' 			=> 'adblock_session',
		'option_arr_id'		=> $option_arr_id,
		'class'				=> 'fupi_sub fupi_adblock_session fupi_disabled',
		'under field'		=> esc_html__( 'Use this to limit the number of events FP sends to GA. If you enable it go to Google Analytics panel and change the scope of the custom dimension for adblock events to "Session".', 'fupi'),
	),
);

foreach( $fields as $field ){
	add_settings_field( $field['field_id'], $field['label'], array( $this, 'fupi_field_html' ), $page, $section_id, $field );
}

?>
