<?php

$page = 'fupi_ga41';

// BASIC SETUP

$section_id 		= 'fupi_ga41_basic';
add_settings_section( $section_id, esc_html__( 'Basic settings', 'fupi' ), array( $this, 'fupi_sections_descriptions'), $page );

if ( $this->cook_enabled ){
	$cook_opt = array(
		'type'	 			=> 'toggle',
		'label' 			=> esc_html__( 'Load Google Analytics 4 without waiting for cookie consent', 'fupi' ),
		'field_id' 			=> 'disreg_cookies',
		'option_arr_id'		=> $option_arr_id,
		'under field'		=> esc_html__( 'This option has an effect only if you chose to load tracking tools after user gives their consent to cookies. Sometimes you may need to enable it to validate your Google Analytics 4 installation. By leaving it enabled you make your website not compliant with Cookie Law.', 'fupi'),
	);
} else {
	$cook_opt = array(
		'type'				=> 'hidden',
		'field_id' 			=> 'disreg_cookies', // database version
		'label'				=> '', // not used but required in foreach below
	);
}

$fields = array(
	array(
		'type'	 			=> 'text',
		'label' 			=> esc_html__( 'Measurement ID', 'fupi' ),
		'field_id' 			=> 'id',
		'class'				=> 'fupi_required',
		'option_arr_id'		=> $option_arr_id,
		'label_for' 		=> $option_arr_id . '[id]',
		'placeholder'		=> 'G-0000000000',
		'under field'		=> sprintf( esc_html__( 'Enter measurement ID from your Google Analytics dashboard. %1$sWhere to find it%2$s', 'fupi'), '<br><a href="https://www.youtube.com/watch?v=vzycbsD81Y4" class="fupi_vid_link fupi_vid" data-srcid="vzycbsD81Y4"><i class="dashicons dashicons-youtube"></i> <span>', '</span></a>'),
	),
	array(
		'type'	 			=> 'toggle',
		'label' 			=> esc_html__( 'Track logged-in users across devices and browsers', 'fupi' ),
		'field_id' 			=> 'set_user_id',
		'option_arr_id'		=> $option_arr_id,
	),
	array(
		'type' 				=> 'toggle',
		'label' 			=> esc_html__( 'Avoid issues while using multiple GA integrations', 'fupi' ),
		'field_id' 			=> 'cookie_prefix',
		'option_arr_id'		=> $option_arr_id,
		'under field'		=> esc_html__( 'Attention! This setting changes GA cookie prefix. It is best to enable it on a website where the currently used measurement ID (above) has never been used before. Otherwise your returning visitors will be counted as new visitors (thankfully just once).', 'fupi'),
	),
	$cook_opt
);

foreach( $fields as $field ){
	add_settings_field( $field['field_id'], $field['label'], array( $this, 'fupi_field_html' ), $page, $section_id, $field );
}

// CLICK TRACKING

$section_id = 'fupi_ga41_clicks';
add_settings_section( $section_id, esc_html__( 'Track clicks*', 'fupi' ), array( $this, 'fupi_sections_descriptions'), $page );

$fields = array(
	array(
		'type'	 			=> 'repeater',
		'label' 			=> esc_html__( 'Track clicks on affiliate links', 'fupi' ),
		'field_id' 			=> 'track_affiliate',
		'class'				=> 'fupi_repeater_section',
		'el_data_field1_txt' => esc_html__( 'url part, e.g. /go/', 'fupi' ),
		'el_data_field1_type' => 'url_part',
		'el_data_field1_req' => esc_html__( 'this field is required', 'fupi' ),
		'el_data_field1_err' => '',
		'el_data_field2_txt' => esc_html__( 'name (optional)', 'fupi' ),
		'el_data_field2_req' => '',
		'el_data_field2_err' => esc_html__( 'only alphanumeric characters, spaces, hyphens, underscores and [ ] symbols', 'fupi' ),
		'option_arr_id'		=> $option_arr_id,
		'label_for' 		=> $option_arr_id . '[track_affiliate]',
		'under field'		=> esc_html__( 'If you don\'t provide a name, a full link address will be visible in GA\'s report.', 'fupi') . '<br>' . esc_html__( 'Custom dimension name:', 'fupi') . ' <span style="background: #fdf3ce;">affiliate_link_click</span>',
	),
	array(
		'type'	 			=> 'toggle',
		'label' 			=> esc_html__( 'Track clicks on email and tel. links', 'fupi' ),
		'field_id' 			=> 'track_email_tel',
		'option_arr_id'		=> $option_arr_id,
		'under field'		=> esc_html__( 'Custom dimension name:', 'fupi') . ' <span style="background: #fdf3ce;">contact_click</span>',
	),
	array(
		'type'	 			=> 'repeater',
		'label' 			=> esc_html__( 'Track clicks on page elements', 'fupi' ),
		'field_id' 			=> 'track_elems',
		'class'				=> 'fupi_repeater_section',
		'el_data_field1_txt' => esc_html__( 'CSS selector e.g. #sth img', 'fupi' ),
		'el_data_field1_req' => esc_html__( 'this field is required', 'fupi' ),
		'el_data_field1_err' => esc_html__( 'incorrect selector', 'fupi' ),
		'el_data_field2_txt' => esc_html__( 'element name (required)', 'fupi' ),
		'el_data_field2_req' => esc_html__( 'this field is required', 'fupi' ),
		'el_data_field2_err' => esc_html__( 'only alphanumeric characters, spaces, hyphens, underscores and [ ] symbols', 'fupi' ),
		'option_arr_id'		=> $option_arr_id,
		'label_for' 		=> $option_arr_id . '[track_elems]',
		'under field'		=> esc_html__( 'Custom dimension name:', 'fupi') . ' <span style="background: #fdf3ce;">element_click</span>',
	),
);

foreach( $fields as $field ){
	add_settings_field( $field['field_id'], $field['label'], array( $this, 'fupi_field_html' ), $page, $section_id, $field );
}

// FORM TRACKING

$section_id = 'fupi_ga41_forms';
add_settings_section( $section_id, esc_html__( 'Track forms', 'fupi' ), array( $this, 'fupi_sections_descriptions'), $page );

$fields = array(
	array(
		'type'	 			=> 'repeater',
		'label' 			=> esc_html__( 'Track form submissions', 'fupi' ),
		'field_id' 			=> 'track_forms',
		'class'				=> 'fupi_repeater_section',
		'el_data_field1_txt' => esc_html__( 'CSS selector e.g. #form_id', 'fupi' ),
		'el_data_field1_req' => esc_html__( 'this field is required', 'fupi' ),
		'el_data_field1_err' => esc_html__( 'incorrect selector', 'fupi' ),
		'el_data_field2_txt' => esc_html__( 'form name (required)', 'fupi' ),
		'el_data_field2_req' => esc_html__( 'this field is required', 'fupi' ),
		'el_data_field2_err' => esc_html__( 'only alphanumeric characters, spaces, hyphens, underscores and [ ] symbols', 'fupi' ),
		'option_arr_id'		=> $option_arr_id,
		'label_for' 		=> $option_arr_id . '[track_forms]',
		'under field'		=> esc_html__( 'Custom dimension name:', 'fupi') . ' <span style="background: #fdf3ce;">submitted_form</span><br><br>' . esc_html__( 'Test this feature after enabling. There are many methods of submitting forms. If tracking fails on your form, set up tracking clicks on "submit" button instead.', 'fupi'),
	),
);

foreach( $fields as $field ){
	add_settings_field( $field['field_id'], $field['label'], array( $this, 'fupi_field_html' ), $page, $section_id, $field );
}

// VIEWS & SCROLLS TRACKING

$section_id = 'fupi_ga41_scrolls';
add_settings_section( $section_id, esc_html__( 'Track scrolls & visibility', 'fupi' ), array( $this, 'fupi_sections_descriptions'), $page );

$fields = array(
	array(
		'type'	 			=> 'repeater',
		'label' 			=> esc_html__( 'Track when these elements become visible', 'fupi' ),
		'field_id' 			=> 'track_views',
		'class'				=> 'fupi_repeater_section',
		'el_data_field1_txt' => esc_html__( 'CSS selector e.g. .side img', 'fupi' ),
		'el_data_field1_req' => esc_html__( 'this field is required', 'fupi' ),
		'el_data_field1_err' => esc_html__( 'incorrect selector', 'fupi' ),
		'el_data_field2_txt' => esc_html__( 'element name (required)', 'fupi' ),
		'el_data_field2_req' => esc_html__( 'this field is required', 'fupi' ),
		'el_data_field2_err' => esc_html__( 'only alphanumeric characters, spaces, hyphens, underscores and [ ] symbols', 'fupi' ),
		'option_arr_id'		=> $option_arr_id,
		'label_for' 		=> $option_arr_id . '[track_views]',
		'under field'		=> esc_html__( 'Custom dimension name:', 'fupi') . ' <span style="background: #fdf3ce;">viewed_element</span><br><br>'. esc_html__('Use this function to track when elements are scrolled into the visible area of the page OR when they become visible (like popups). Elements come into view when they are 200px inside the screen. Each view is counted once per page view.', 'fupi'),
	),
	array(
		'type'	 			=> 'text',
		'label' 			=> esc_html__( 'Track when visitors scroll to:', 'fupi' ),
		'placeholder'		=> esc_html__( 'e.g. 25, 50, 75', 'fupi' ),
		'field_id' 			=> 'track_scroll',
		'el_class'			=> 'fupi_condition',
		'el_data_target'	=> 'fupi_track_scroll_intr',
		'option_arr_id'		=> $option_arr_id,
		'label_for' 		=> $option_arr_id . '[track_scroll]',
		'after field'		=> esc_html__( '% of page height', 'fupi'),
		'under field'		=> sprintf(
			esc_html__( 'Separate multiple values with comas. Do not use "%" symbol. To use this function you need to %1$sdisable automatic "scroll" tracking %2$s in GA admin panel. Only the first scroll to a specified page height triggers the event.', 'fupi'),
			'<a href="https://fullpictureplugin.com/?p=2134&utm_source=useradmin&utm_medium=settings&utm_campaign=settings_link" target="_blank">',
			'</a>'
		),
	),
	array(
		'type'	 			=> 'number',
		'label' 			=> esc_html__( 'Track scroll if visitor scrolled more than:', 'fupi' ),
		'field_id' 			=> 'track_scroll_min',
		'class'				=> 'fupi_sub fupi_track_scroll_intr fupi_disabled',
		'option_arr_id'		=> $option_arr_id,
		'label_for' 		=> $option_arr_id . '[track_scroll_min]',
		'default'			=> '200',
		'after field'		=> esc_html__( 'pixels.', 'fupi'),
		'under field'		=> esc_html__( 'Prevents firing events on short pages. Default is 200px.', 'fupi'),
	),
	array(
		'type'	 			=> 'number',
		'label' 			=> esc_html__( 'Do not track scroll if it happened in the first:', 'fupi' ),
		'field_id' 			=> 'track_scroll_time',
		'class'				=> 'fupi_sub fupi_track_scroll_intr fupi_disabled',
		'option_arr_id'		=> $option_arr_id,
		'label_for' 		=> $option_arr_id . '[track_scroll_time]',
		'default'			=> '5',
		'after field'		=> esc_html__( 'seconds', 'fupi' ),
		'under field'		=> esc_html__( 'Prevents tracking "exploratory" scrolls. Default is 5 seconds. The event will fire if the visitor is still below the specified scroll depth after the time has passed.', 'fupi'),
	),
);

foreach( $fields as $field ){
	add_settings_field( $field['field_id'], $field['label'], array( $this, 'fupi_field_html' ), $page, $section_id, $field );
}

// WP DATA TRACKING

$section_id = 'fupi_ga41_wpdata';
add_settings_section( $section_id, esc_html__( 'Track WP data', 'fupi' ), array( $this, 'fupi_sections_descriptions'), $page );

$fields = array(
	array(
		'type'	 			=> 'toggle',
		'label' 			=> esc_html__( 'Track page type', 'fupi' ),
		'field_id' 			=> 'page_type',
		'option_arr_id'		=> $option_arr_id,
		'label_for' 		=> $option_arr_id . '[page_type]',
		'under field'		=> esc_html__( 'Custom dimension name:', 'fupi') . ' <span style="background: #fdf3ce;">page_type</span>',
	),
	array(
		'type'	 			=> 'toggle',
		'label' 			=> esc_html__( 'Track page IDs', 'fupi' ),
		'field_id' 			=> 'page_id',
		'option_arr_id'		=> $option_arr_id,
		'label_for' 		=> $option_arr_id . '[page_id]',
		'under field'		=> esc_html__( 'Custom dimension name:', 'fupi') . ' <span style="background: #fdf3ce;">page_id</span>',
	),
	array(
		'type'	 			=> 'toggle',
		'label' 			=> esc_html__( 'Track page numbers', 'fupi' ),
		'field_id' 			=> 'page_number',
		'option_arr_id'		=> $option_arr_id,
		'label_for' 		=> $option_arr_id . '[page_number]',
		'under field'		=> esc_html__( 'Custom dimension name:', 'fupi') . ' <span style="background: #fdf3ce;">page_number</span><br><br>' . esc_html__( 'Track the page number of posts broken into multiple pages, categories, posts, etc.', 'fupi'),
	),
	array(
		'type'	 			=> 'toggle',
		'label' 			=> esc_html__( 'Track author\'s display names', 'fupi' ),
		'field_id' 			=> 'post_author',
		'option_arr_id'		=> $option_arr_id,
		'label_for' 		=> $option_arr_id . '[post_author]',
		'under field'		=> esc_html__( 'Custom dimension name:', 'fupi') . ' <span style="background: #fdf3ce;">post_author</span><br><br>' . esc_html__( 'Attention! Make sure that display names are pseudonyms. Tracking personally identifiable information is against Google\'s policy.', 'fupi'),
	),
	array(
		'type'	 			=> 'toggle',
		'label' 			=> esc_html__( 'Track authors IDs', 'fupi' ),
		'field_id' 			=> 'author_id',
		'option_arr_id'		=> $option_arr_id,
		'label_for' 		=> $option_arr_id . '[author_id]',
		'under field'		=> esc_html__( 'Custom dimension name:', 'fupi') . ' <span style="background: #fdf3ce;">author_id</span>',
	),
	array(
		'type'	 			=> 'toggle',
		'label' 			=> esc_html__( 'Track post and page publish dates', 'fupi' ),
		'field_id' 			=> 'post_date',
		'option_arr_id'		=> $option_arr_id,
		'label_for' 		=> $option_arr_id . '[post_date]',
		'under field'		=> esc_html__( 'Custom dimension name:', 'fupi') . ' <span style="background: #fdf3ce;">post_date</span>',
	),
	array(
		'type'	 			=> 'toggle',
		'label' 			=> esc_html__( 'Track visitor\'s login status and role', 'fupi' ),
		'field_id' 			=> 'user_role',
		'option_arr_id'		=> $option_arr_id,
		'label_for' 		=> $option_arr_id . '[user_role]',
		'under field'		=> esc_html__( 'Custom dimension name:', 'fupi') . ' <span style="background: #fdf3ce;">user_role</span>',
	),
	array(
		'type'	 			=> 'toggle',
		'label' 			=> esc_html__( 'Track page language', 'fupi' ),
		'field_id' 			=> 'page_lang',
		'option_arr_id'		=> $option_arr_id,
		'label_for' 		=> $option_arr_id . '[page_lang]',
		'under field'		=> esc_html__( 'Custom dimension name:', 'fupi') . ' <span style="background: #fdf3ce;">page_lang</span>',
	),
	array(
		'type'	 			=> 'toggle',
		'label' 			=> esc_html__( 'Track terms', 'fupi' ),
		'field_id' 			=> 'tax_terms',
		'option_arr_id'		=> $option_arr_id,
		'label_for' 		=> $option_arr_id . '[tax_terms]',
		'el_class'			=> 'fupi_condition',
		'el_data_target'	=> 'fupi_tax_terms_opts',
		'under field'		=> esc_html__( 'Custom dimension name:', 'fupi') . ' <span style="background: #fdf3ce;">taxonomy_terms</span>',
	),
		array(
			'type'	 			=> 'toggle',
			'label' 			=> esc_html__( 'Add taxonomy slug to term name', 'fupi' ),
			'field_id' 			=> 'add_tax_term_cat',
			'option_arr_id'		=> $option_arr_id,
			'class'				=> 'fupi_sub fupi_tax_terms_opts fupi_disabled',
			'under field'		=> esc_html__( 'If you use on your site both tags, categories or other taxonomies use taxonomy slugs to distinguish in GA reports one from the other e.g. "analytics (category)"', 'fupi'),
		),
		array(
			'type'	 			=> 'toggle',
			'label' 			=> esc_html__( 'Send term names instead of term slugs', 'fupi' ),
			'field_id' 			=> 'send_tax_terms_titles',
			'option_arr_id'		=> $option_arr_id,
			'class'				=> 'fupi_sub fupi_tax_terms_opts fupi_disabled',
			'under field'		=> esc_html__( 'Enable this to send term titles (e.g. product category) instead of their slugs (e.g. product_category). Enabling this feature is not recommended since term names are changed more often then slugs.', 'fupi'),
		),
	array(
		'type'	 			=> 'toggle',
		'label' 			=> esc_html__( 'Show clean page titles in GA reports', 'fupi' ),
		'field_id' 			=> 'clean_page_title',
		'option_arr_id'		=> $option_arr_id,
		'el_class'			=> 'fupi_condition',
		'el_data_target'	=> 'fupi_seo_title',
		'under field'		=> esc_html__( 'Show clean page titles in GA reports instead of the text from "title" meta tag (a.k.a. SEO title). This is useful to prevent seeing multiple entries of the same page in your GA reports but with diffferent SEO titles.', 'fupi'),
	),
		array(
			'type'	 			=> 'toggle',
			'label' 			=> esc_html__( 'Track SEO titles', 'fupi' ),
			'field_id' 			=> 'seo_title',
			'option_arr_id'		=> $option_arr_id,
			'label_for' 		=> $option_arr_id . '[seo_title]',
			'class'				=> 'fupi_sub fupi_seo_title fupi_disabled',
			'under field'		=> esc_html__( 'Custom dimension name:', 'fupi') . ' <span style="background: #fdf3ce;">seo_title</span><br><br>' . esc_html__( 'By enabling this function you can track SEO titles in a separate dimension - makes analysis of SEO texts simpler.', 'fupi' ),
		),
);

foreach( $fields as $field ){
	add_settings_field( $field['field_id'], $field['label'], array( $this, 'fupi_field_html' ), $page, $section_id, $field );
}

// CUSTOM METRICS

$section_id = 'fupi_ga41_custom_metrics';
add_settings_section( $section_id, esc_html__( 'Custom metrics', 'fupi' ), array( $this, 'fupi_sections_descriptions'), $page );

$fields = array(
	array(
		'type'	 			=> 'toggle',
		'label' 			=> esc_html__( 'Track how long the user was actively engaged with the content', 'fupi' ),
		'field_id' 			=> 'track_engagement',
		'option_arr_id'		=> $option_arr_id,
		'label_for' 		=> $option_arr_id . '[track_engagement]',
		'under field'		=> esc_html__( 'Custom metric name:', 'fupi') . ' <span style="background: #fdf3ce;">user_engagement_time</span><br>' . esc_html__ ( 'The event is sent just before the user closes the page. The measurement method is not supported by Internet Explorer', 'fupi'),
	),
	array(
		'type'	 			=> 'toggle',
		'label' 			=> esc_html__( 'Track the number of search results', 'fupi' ),
		'field_id' 			=> 'search_results_nr',
		'option_arr_id'		=> $option_arr_id,
		'label_for' 		=> $option_arr_id . '[search_results_nr]',
		'under field'		=> esc_html__( 'Custom metric name:', 'fupi') . ' <span style="background: #fdf3ce;">search_results_nr</span>',
	),
);

foreach( $fields as $field ){
	add_settings_field( $field['field_id'], $field['label'], array( $this, 'fupi_field_html' ), $page, $section_id, $field );
}

// ERROR TRACKING

$section_id = 'fupi_ga41_errors';
add_settings_section( $section_id, esc_html__( 'Track errors', 'fupi' ), array( $this, 'fupi_sections_descriptions'), $page );

$fields = array(
	array(
		'type'	 			=> 'toggle',
		'label' 			=> esc_html__( 'Track JavaScript errors', 'fupi' ),
		'field_id' 			=> 'js_err_dimens',
		'class'				=> $disable_for_free_class,
		'option_arr_id'		=> $option_arr_id,
		'under field'		=> esc_html__( 'Custom dimension name:', 'fupi') . ' <span style="background: #fdf3ce;">js_error_details</span>',
	),
);

foreach( $fields as $field ){
	add_settings_field( $field['field_id'], $field['label'], array( $this, 'fupi_field_html' ), $page, $section_id, $field );
}

// OTHER SETTINGS

$section_id 		= 'fupi_ga41_other';
add_settings_section( $section_id, esc_html__( 'Other settings', 'fupi' ), array( $this, 'fupi_sections_descriptions'), $page );

$fields = array(
	array(
		'type'	 			=> 'toggle',
		'label' 			=> esc_html__( 'Enable DebugView', 'fupi' ),
		'field_id' 			=> 'debug_ga',
		'option_arr_id'		=> $option_arr_id,
		'under field'		=> sprintf(esc_html__( 'DebugView is specific to Google Analytics 4 and should not be mistaken with Full Picture\'s debug mode. %1sLearn more on DebugView%2s.', 'fupi'), '<a href="https://ken-williams.com/guide/installation/validating-google-analytics-4-with-debug-mode/" target="_blank">', '</a>' ),
	),
);

foreach( $fields as $field ){
	add_settings_field( $field['field_id'], $field['label'], array( $this, 'fupi_field_html' ), $page, $section_id, $field );
}

// E-COMMERCE

$section_id = 'fupi_ga41_ecomm';
add_settings_section( $section_id, esc_html__( 'E-Commerce tracking (PRO)', 'fupi' ), array( $this, 'fupi_sections_descriptions'), $page );

// DEPRECATEED

$section_id = 'fupi_ga41_deprecated';
add_settings_section( $section_id, esc_html__( 'Deprecated**', 'fupi' ), array( $this, 'fupi_sections_descriptions'), $page );

$fields = array(
	array(
		'type'	 			=> 'toggle',
		'label' 			=> esc_html__( 'Track the use of ad blockers', 'fupi' ),
		'field_id' 			=> 'detect_adblock',
		'option_arr_id'		=> $option_arr_id,
		'label_for' 		=> $option_arr_id . '[detect_adblock]',
		'under field'		=> esc_html__( 'Reason for removal: almost all ad blockers also block Google Analytics. Please enable Plausible analytics integration to count the use of adblocks.', 'fupi'),
	),
);

foreach( $fields as $field ){
	add_settings_field( $field['field_id'], $field['label'], array( $this, 'fupi_field_html' ), $page, $section_id, $field );
}

?>
