<?php

$page = 'fupi_gopt';

// BASIC SETTINGS

$section_id = 'fupi_gopt_basic';
add_settings_section( $section_id, esc_html__( 'Basic settings', 'fupi' ), array( $this, 'fupi_sections_descriptions'), $page );

$fields = array(
	array(
		'type'	 			=> 'text',
		'label' 			=> __( 'Google Optimize Container ID', 'fupi' ),
		'field_id' 			=> 'container_id',
		'class'				=> 'fupi_required fupi_easy',
		'option_arr_id'		=> $option_arr_id,
		'label_for' 		=> $option_arr_id . '[container_id]',
		'placeholder'		=> 'OPT-0000000',
		'under field'		=> __('Container IDs are provided in Google Optimize panel when you create new containers. ', 'fupi'),
	),
);

foreach( $fields as $field ){
	add_settings_field( $field['field_id'], $field['label'], array( $this, 'fupi_field_html' ), $page, $section_id, $field );
}

// ADVANCED SETTINGS

$section_id = 'fupi_gopt_advanced';
add_settings_section( $section_id, esc_html__( 'Advanced setup*', 'fupi' ), array( $this, 'fupi_sections_descriptions'), $page );

$fields = array(
	array(
		'type'	 			=> 'select',
		'label' 			=> esc_html__( 'Load the script using:', 'fupi' ),
		'field_id' 			=> 'main_load_method',
		'option_arr_id'		=> $option_arr_id,
		'options' 			=> array(
			'gtag'				=> esc_html__( 'gtag (default & recommended)', 'fupi'),
			'opt_js'			=> esc_html__( 'optimize.js', 'fupi' ),
		),
		'default'			=> 'gtag',
		'el_class'			=> 'fupi_condition',
		'el_data_target'	=> 'fupi_cond_load_method',
		'under field'		=> sprintf( esc_html__( 'Choose "optimize.js" if you integrate Google Analytics UA using a different plugin (not Full Picture)."', 'fupi'), '<br>', '<br>' ),
	),
	array(
		'type'	 			=> 'radio',
		'label' 			=> esc_html__( 'Google Optimize script loading method', 'fupi' ),
		'field_id' 			=> 'load_method',
		'class'				=> 'fupi_sub fupi_cond_load_method fupi_cond_val_opt_js fupi_disabled',
		'options' 			=> array(
			'sync'				=> esc_html__( 'Synchronous (recommended)', 'fupi' ),
			'async_full'		=> esc_html__( 'Asynchronous with page hiding snippet', 'fupi' ),
			'async_lite'		=> esc_html__( 'Asynchronous without page hiding snippet (not recommended)', 'fupi' ),
		),
		'default'			=> 'sync',
		'option_arr_id'		=> $option_arr_id,
	),
	array(
		'type'	 			=> 'number',
		'label' 			=> __( 'Show original page content if the test doesn\'t load in:', 'fupi' ),
		'field_id' 			=> 'hide_snippet_wait',
		'class'				=> 'fupi_sub fupi_cond_load_method fupi_cond_val_opt_js fupi_disabled',
		'option_arr_id'		=> $option_arr_id,
		'label_for' 		=> $option_arr_id . '[hide_snippet_wait]',
		'after field'		=> esc_html__( 'seconds', 'fupi'),
		'under field'		=> esc_html__( 'Works only with asynchronous script with page hiding snippet', 'fupi'),
	),
	array(
		'type'	 			=> 'toggle',
		'class'				=> 'fupi_sub fupi_cond_load_method fupi_cond_val_opt_js fupi_disabled',
		'label' 			=> esc_html__( 'Load Google Optimize without waiting for cookie consent', 'fupi' ),
		'field_id' 			=> 'disreg_cookies',
		'option_arr_id'		=> $option_arr_id,
		'under field'		=> esc_html__( 'This option has an effect only if you chose to load tracking tools after user gives their consent to cookies. By leaving it enabled you make your website not compliant with Cookie Law.', 'fupi'),
	),
);

foreach( $fields as $field ){
	add_settings_field( $field['field_id'], $field['label'], array( $this, 'fupi_field_html' ), $page, $section_id, $field );
}

?>
