<?php

$page = 'fupi_insp';

// BASIC

$section_id = 'fupi_insp_basic';
add_settings_section( $section_id, esc_html__( 'Basic settings', 'fupi' ), array( $this, 'fupi_sections_descriptions'), $page );

if ( $this->cook_enabled ){
	$cook_opt = array(
		'type'	 			=> 'toggle',
		'label' 			=> esc_html__( 'Load Inspectlet without waiting for cookie consent', 'fupi' ),
		'field_id' 			=> 'disreg_cookies',
		'option_arr_id'		=> $option_arr_id,
		'under field'		=> esc_html__( 'This option has an effect only if you chose to load tracking tools after user gives their consent to cookies. Enable it to verify inspectlet and/or allow for complete session recordings, heatmaps and uninterrupted A/B tests. By leaving it enabled you make your website not compliant with Cookie Law.', 'fupi'),
	);
} else {
	$cook_opt = array(
		'type'				=> 'hidden',
		'field_id' 			=> 'disreg_cookies', // database version
		'label'				=> '', // not used but required in foreach below
	);
}

$fields = array(
	array(
		'type'	 			=> 'text',
		'label' 			=> esc_html__( 'Inspectlet ID', 'fupi' ),
		'field_id' 			=> 'id',
		'class'				=> 'fupi_required fupi_easy',
		'placeholder'		=> '000000000',
		'option_arr_id'		=> $option_arr_id,
		'label_for' 		=> $option_arr_id . '[id]',
		'under field'		=> sprintf( esc_html__( 'Go to %1$sInspectlet\'s dashboard%2$s, choose your website and then click "Settings".  Site ID will be in the page\'s URL, e.g.', 'fupi' ), '<a href="https://www.inspectlet.com/dashboard" target="_blank">', '</a>' ) . ' https://www.inspectlet.com/dashboard/site_settings/</strong>SITE_ID</strong>',
	),
	array(
		'type'	 			=> 'toggle',
		'label' 			=> esc_html__( 'Enable A/B tests', 'fupi' ),
		'class'				=> 'fupi_easy',
		'field_id' 			=> 'ab_test_script',
		'option_arr_id'		=> $option_arr_id,
		'tooltip'			=> esc_html__( 'This will replace standard integration script with A/B-optimized loader script.', 'fupi' ),
		'under field'		=> esc_html__( 'Attention! When the test script loads the page will flash to allow for test variantion load. This is normal and cannot be prevented.', 'fupi' ),
	),
	$cook_opt,
);

foreach( $fields as $field ){
	add_settings_field( $field['field_id'], $field['label'], array( $this, 'fupi_field_html' ), $page, $section_id, $field );
}

// SESSION TAGGING

$section_id = 'fupi_insp_tags';
add_settings_section( $section_id, esc_html__( 'Tagging*', 'fupi' ), array( $this, 'fupi_sections_descriptions'), $page );

$fields = array(
	array(
		'type'	 			=> 'toggle',
		'label' 			=> esc_html__( 'Track clicks on outbound links', 'fupi' ),
		'field_id' 			=> 'tag_outbound',
		'class'				=> 'fupi_standard',
		'option_arr_id'		=> $option_arr_id,
		'tooltip'			=> esc_html__( 'Tags clicks on all links that lead to other domains. Attention! Affiliate links leading to other sites are also treated as outbound.', 'fupi'),
	),
	array(
		'type'	 			=> 'repeater',
		'label' 			=> esc_html__( 'Track clicks on affiliate links', 'fupi' ),
		'field_id' 			=> 'tag_affiliate',
		'class'				=> 'fupi_repeater_section',
		'el_data_field1_txt' => esc_html__( 'url part, e.g. /go/', 'fupi' ),
		'el_data_field1_type' => 'url_part',
		'el_data_field1_req' => esc_html__( 'this field is required', 'fupi' ),
		'el_data_field1_err' => '',
		'el_data_field2_txt' => esc_html__( 'name (optional)', 'fupi' ),
		'el_data_field2_req' => '',
		'el_data_field2_err' => esc_html__( 'only alphanumeric characters, spaces, hyphens, underscores and [ ] symbols', 'fupi' ),
		'option_arr_id'		=> $option_arr_id,
		'label_for' 		=> $option_arr_id . '[tag_affiliate]',
		'under field'		=> sprintf(esc_html__( 'Enter parts of the affiliate links\' you want to track (e.g. /out/ or ref=123abc). One per line. Optionally follow them by @ and atag name of your choice. By default, URL are sent as names. %1sLearn more%2s.', 'fupi'), '<a href="https://fullpictureplugin.com/?p=2061&utm_source=useradmin&utm_medium=settings&utm_campaign=settings_link" target="_blank">','</a>' ),
	),
	array(
		'type'	 			=> 'toggle',
		'label' 			=> esc_html__( 'Track clicks on email and tel. links', 'fupi' ),
		'field_id' 			=> 'tag_email_tel',
		'class'				=> 'fupi_standard',
		'option_arr_id'		=> $option_arr_id,
	),
	array(
		'type'	 			=> 'text',
		'label' 			=> esc_html__( 'Track clicks on file download links', 'fupi' ),
		'placeholder'		=> 'pdf, doc, docx, xls, xlsx, txt',
		'field_id' 			=> 'tag_file_downl',
		'class'				=> 'fupi_standard',
		'option_arr_id'		=> $option_arr_id,
		'label_for' 		=> $option_arr_id . '[tag_file_downl]',
		'under field'		=> esc_html__( 'Enter coma separated list of file formats you want to track', 'fupi'),
	),
	array(
		'type'	 			=> 'toggle',
		'label' 			=> esc_html__( 'Track anchor clicks (links leading to elements on the same page)', 'fupi' ),
		'field_id' 			=> 'tag_anchor_clicks',
		'class'				=> 'fupi_standard',
		'option_arr_id'		=> $option_arr_id,
	),
	array(
		'type'	 			=> 'repeater',
		'label' 			=> esc_html__( 'Track clicks on page elements', 'fupi' ),
		'field_id' 			=> 'tag_elems',
		'class'				=> 'fupi_repeater_section',
		'el_data_field1_txt' => esc_html__( 'CSS selector e.g. #sth img', 'fupi' ),
		'el_data_field1_req' => esc_html__( 'this field is required', 'fupi' ),
		'el_data_field1_err' => esc_html__( 'incorrect selector', 'fupi' ),
		'el_data_field2_txt' => esc_html__( 'element name (required)', 'fupi' ),
		'el_data_field2_req' => esc_html__( 'this field is required', 'fupi' ),
		'el_data_field2_err' => esc_html__( 'only alphanumeric characters, spaces, hyphens, underscores and [ ] symbols', 'fupi' ),
		'option_arr_id'		=> $option_arr_id,
		'label_for' 		=> $option_arr_id . '[tag_elems]',
	),
	array(
		'type'	 			=> 'repeater',
		'label' 			=> esc_html__( 'Track form submissions', 'fupi' ),
		'field_id' 			=> 'tag_forms',
		'class'				=> 'fupi_repeater_section',
		'el_data_field1_txt' => esc_html__( 'CSS selector e.g. #form_id', 'fupi' ),
		'el_data_field1_req' => esc_html__( 'this field is required', 'fupi' ),
		'el_data_field1_err' => esc_html__( 'incorrect selector', 'fupi' ),
		'el_data_field2_txt' => esc_html__( 'form name (required)', 'fupi' ),
		'el_data_field2_req' => esc_html__( 'this field is required', 'fupi' ),
		'el_data_field2_err' => esc_html__( 'only alphanumeric characters, spaces, hyphens, underscores and [ ] symbols', 'fupi' ),
		'option_arr_id'		=> $option_arr_id,
		'label_for' 		=> $option_arr_id . '[tag_forms]',
		'under field'		=> esc_html__( 'Attention! Test this feature after enabling. There are many methods of submitting forms. If this method of tracking fails, track clicks on form submit button instead.', 'fupi'),
	),
	array(
		'type'	 			=> 'repeater',
		'label' 			=> esc_html__( 'Track when these elements become visible', 'fupi' ),
		'field_id' 			=> 'tag_views',
		'class'				=> 'fupi_repeater_section',
		'el_data_field1_txt' => esc_html__( 'CSS selector e.g. .side img', 'fupi' ),
		'el_data_field1_req' => esc_html__( 'this field is required', 'fupi' ),
		'el_data_field1_err' => esc_html__( 'incorrect selector', 'fupi' ),
		'el_data_field2_txt' => esc_html__( 'element name (required)', 'fupi' ),
		'el_data_field2_req' => esc_html__( 'this field is required', 'fupi' ),
		'el_data_field2_err' => esc_html__( 'only alphanumeric characters, spaces, hyphens, underscores and [ ] symbols', 'fupi' ),
		'option_arr_id'		=> $option_arr_id,
		'label_for' 		=> $option_arr_id . '[tag_views]',
		'under field'		=> esc_html__( 'Use this function to track when elements are scrolled into the visible area of the page OR when they become visible (like popups). Elements are counted as "visible" when they are 200px inside the viewport. Each view is counted once per page view.', 'fupi'),
	),
	array(
		'type'	 			=> 'toggle',
		'label' 			=> esc_html__( 'Track visitor\'s login status and user role (if logged in)', 'fupi' ),
		'field_id' 			=> 'tag_user_role',
		'class'				=> 'fupi_standard',
		'option_arr_id'		=> $option_arr_id,
	),
	array(
		'type'	 			=> 'toggle',
		'label' 			=> esc_html__( 'Track page type', 'fupi' ),
		'field_id' 			=> 'tag_pagetype',
		'class'				=> 'fupi_standard',
		'option_arr_id'		=> $option_arr_id,
	),
	array(
		'type'	 			=> 'toggle',
		'label' 			=> esc_html__( 'Track page author', 'fupi' ),
		'field_id' 			=> 'tag_pageauthor',
		'class'				=> 'fupi_standard',
		'option_arr_id'		=> $option_arr_id,
	),
	array(
		'type'	 			=> 'toggle',
		'label' 			=> esc_html__( 'Track referring site', 'fupi' ),
		'field_id' 			=> 'tag_referrer',
		'class'				=> 'fupi_standard',
		'option_arr_id'		=> $option_arr_id,
	),
	array(
		'type'	 			=> 'toggle',
		'label' 			=> esc_html__( 'Track UTM campaign parameters', 'fupi' ),
		'field_id' 			=> 'tag_utm',
		'option_arr_id'		=> $option_arr_id,
	),
);

foreach( $fields as $field ){
	add_settings_field( $field['field_id'], $field['label'], array( $this, 'fupi_field_html' ), $page, $section_id, $field );
}

// FP CUSTOM EVENTS

$section_id = 'fupi_insp_ecomm';
add_settings_section( $section_id, esc_html__( 'E-Commerce tagging (PRO)', 'fupi' ), array( $this, 'fupi_sections_descriptions'), $page );


// USER IDENTIF.

$section_id = 'fupi_insp_user';
add_settings_section( $section_id, esc_html__( 'User identification', 'fupi' ), array( $this, 'fupi_sections_descriptions'), $page );

$fields = array(
	array(
		'type'	 			=> 'toggle',
		'label' 			=> esc_html__( 'Identify logged-in users', 'fupi' ),
		'field_id' 			=> 'identif_users',
		'option_arr_id'		=> $option_arr_id,
		'class'				=> 'fupi_standard',
		'el_class'			=> 'fupi_condition',
		'el_data_target'	=> 'fupi_sub_identif',
		'under field'		=> esc_html__( 'By identifying users, you can group together session recordings from particular users.', 'fupi'),
	),
	array(
		'type'	 			=> 'select',
		'label' 			=> esc_html__( 'Identify logged-in users by:', 'fupi' ),
		'field_id' 			=> 'identif_method',
		'class'				=> 'fupi_sub fupi_sub_identif fupi_disabled fupi_standard',
		'option_arr_id'		=> $option_arr_id,
		'options' 			=> array(
			'encode_user_id'	=> esc_html__( 'Encoded User ID', 'fupi'),
			'user_id'			=> esc_html__( 'User ID', 'fupi'),
			'username'			=> esc_html__( 'Username', 'fupi'),
			'email'				=> esc_html__( 'Email', 'fupi'),
		),
		'default'			=> 'encode_user_id',
		'under field'		=> sprintf ( esc_html__( 'You can choose to send user ID in a personally identifiable form (email, username or user id) or in an encoded form. If you choose the first one you will need to sign %1sData Processing Agreement with Inspectlet%2s. For email or username tracking to work you must enable email and username data in the "Main settings" > "Privacy & security settings".'), '<a href="https://docs.inspectlet.com/hc/en-us/articles/360004212092-Inspectlet-Data-Processing-Agreement-under-GDPR" target="_blank">','</a>' )
	),
);

foreach( $fields as $field ){
	add_settings_field( $field['field_id'], $field['label'], array( $this, 'fupi_field_html' ), $page, $section_id, $field );
}
?>
