<?php

$page = 'fupi_main';

// TRAFFIC EXCLUSION

$section_id = 'fupi_main_no_track';
add_settings_section( $section_id, esc_html__( 'Tracking exclusions', 'fupi' ), array( $this, 'fupi_sections_descriptions'), $page );

$fields = array(
	array(
		'type'	 			=> 'text',
		'label' 			=> esc_html__( 'Change the keyword "tracking" in the URL above to:', 'fupi' ),
		'field_id' 			=> 'magic_keyword',
		'option_arr_id'		=> $option_arr_id,
		'label_for' 		=> $option_arr_id . '[magic_keyword]',
		'placeholder'		=> 'secret_word',
		'under field' 		=> esc_html__('You can only use small letters, numbers, hyphens and underscores. Any other characters will be removed or replaced.', 'fupi'),
	),
	array(
		'type'	 			=> 'roles multi checkbox',
		'label' 			=> esc_html__( 'Do not track logged-in users with these roles:', 'fupi' ),
		'field_id' 			=> 'disable_for_roles',
		'option_arr_id'		=> $option_arr_id,
		'label_for' 		=> $option_arr_id . '[disable_for_roles]',
		'default'			=> 'administrator',
	),
);

foreach( $fields as $field ){
	add_settings_field( $field['field_id'], $field['label'], array( $this, 'fupi_field_html' ), $page, $section_id, $field );
}

// GLOBAL SETTINGS

$section_id = 'fupi_main_global';
add_settings_section( $section_id, esc_html__( 'Global tracking settings', 'fupi' ), array( $this, 'fupi_sections_descriptions'), $page );

$fields = array(
	array(
		'type'	 			=> 'toggle',
		'label' 			=> esc_html__('Track internal broken links', 'fupi'),
		'field_id' 			=> 'track_404',
		'el_class'			=> 'fupi_condition',
		'el_data_target'	=> 'fupi_404_subs',
		'option_arr_id'		=> $option_arr_id,
		'under field' 		=> sprintf(esc_html__('%1$sLearn how it works%2$s.', 'fupi'), '<a href="https://fullpictureplugin.com/?p=2243&utm_source=useradmin&utm_medium=settings&utm_campaign=settings_link" target="_blank">', '</a>'),
	),
		array(
			'type' 				=> 'text',
			'label' 			=> esc_html__( 'Use custom 404 page:', 'fupi' ),
			'field_id' 			=> 'redirect_404',
			'placeholder'		=> 'e.g. https://example.com',
			'class'				=> 'fupi_404_subs fupi_sub fupi_disabled',
			'option_arr_id'		=> $option_arr_id,
			'label_for' 		=> $option_arr_id . '[redirect_404]',
			'under field'		=> sprintf( esc_html__('Paste a link to a page that all internal broken links will be redirected to. This can be a custom 404 page, a homepage or any page you like. Broken internal links will be still tracked as %1$sexplained here%2$s.', 'fupi'), '<a href="https://fullpictureplugin.com/?p=2243&utm_source=useradmin&utm_medium=settings&utm_campaign=settings_link" target="_blank">', '</a>'),
		),
	array(
		'type'	 			=> 'toggle',
		'label' 			=> esc_html__('Enable page labeling', 'fupi'),
		'field_id' 			=> 'label_pages',
		'el_class'			=> 'fupi_condition',
		'el_data_target'	=> 'fupi_label_subs',
		'option_arr_id'		=> $option_arr_id,
		'under field' 		=> sprintf( esc_html__('%1$sLearn more%2$s', 'fupi'), '<a href="https://fullpictureplugin.com/?p=3713&utm_source=useradmin&utm_medium=settings&utm_campaign=settings_link" target="_blank">', '</a>'),
	),
		array(
			'type'	 			=> 'toggle',
			'label' 			=> esc_html__('Treat page labels as page types', 'fupi'),
			'field_id' 			=> 'label_as_page_types',
			'class'				=> 'fupi_label_subs fupi_sub fupi_disabled ' . $disable_for_free_class,
			'option_arr_id'		=> $option_arr_id,
			'under field'		=> esc_html__('Only the first label added to a page will be treated as a page type.', 'fupi'),
		),
	array(
		'type'	 			=> 'number',
		'label' 			=> esc_html__('Prevent tracking multi-clicks', 'fupi'),
		'field_id' 			=> 'notrack_dblclck',
		'option_arr_id'		=> $option_arr_id,
		'label_for' 		=> $option_arr_id . '[notrack_dblclck]',
		'default'			=> '300',
		'after field' 		=> 'miliseconds',
		'under field' 		=> esc_html__('This setting is to prevent tracking unintentional or unnecessary clicks (like double clicks). Enter time between clicks that will be considered a multi click. Only the first click will be tracked. Enter 0 or leave empty to disable. Default is 300ms.', 'fupi'),
	),
	array(
		'type'	 			=> 'number',
		'label' 			=> esc_html__('Do not track form submissions if they happen within:', 'fupi'),
		'field_id' 			=> 'formsubm_trackdelay',
		'option_arr_id'		=> $option_arr_id,
		'label_for' 		=> $option_arr_id . '[formsubm_trackdelay]',
		'default'			=> '3',
		'after field' 		=> 'seconds after the page loads',
		'under field' 		=> esc_html__('This setting prevents tracking forms submitted by bots and accidental clicks. Enter 0 or leave empty to disable. Default is 3 seconds.', 'fupi'),
	),
	array(
		'type'	 			=> 'number',
		'label' 			=> esc_html__('Delay page redirects after clicking links by', 'fupi'),
		'field_id' 			=> 'link_click_delay',
		'class'				=> $disable_for_free_class,
		'option_arr_id'		=> $option_arr_id,
		'label_for' 		=> $option_arr_id . '[link_click_delay]',
		'after field'		=> 'miliseconds',
		'under field' 		=> sprintf(esc_html__('Give tracking scripts extra time to send data before the page redirects. Best set between 50 - 200ms. Enter 0 or leave empty to disable.%1$sAttention! This may cause issues with dynamic page elements like galleries or sliders. Test before using in production.', 'fupi'), '<br><br>'),
	),
	array(
		'type'	 			=> 'toggle',
		'label' 			=> esc_html__('Reset engagement timer after clicks in anchors', 'fupi'),
		'field_id' 			=> 'reset_timer_on_anchor',
		'option_arr_id'		=> $option_arr_id,
		'under field'		=> esc_html__('Enable this option if your website is a single page and you use anchors to navigate between its sections', 'fupi'),
	),
	array(
		'type' 				=> 'toggle',
		'label' 			=> esc_html__( 'Include noscript fallbacks', 'fupi' ),
		'field_id' 			=> 'noscript',
		'option_arr_id'		=> $option_arr_id,
		'under field'		=> esc_html__('Use this feature if your site works with JavaScript disabled AND you want to track ~0.1% of visitors that disable JavaScript. Attention! Only some platforms provide noscript fallbacks and Full Picture provides only basic fallback features. Fallbacks are placed in page footer.', 'fupi'),
	),
);

foreach( $fields as $field ){
	add_settings_field( $field['field_id'], $field['label'], array( $this, 'fupi_field_html' ), $page, $section_id, $field );
}

// PRIVACY & SECURITY SETTINGS

$section_id = 'fupi_main_security';
add_settings_section( $section_id, esc_html__( 'Privacy & security*', 'fupi' ), array( $this, 'fupi_sections_descriptions'), $page );

$fields = array(
	array(
		'type'	 			=> 'toggle',
		'label' 			=> esc_html__('Do not allow tracking IDs of content authors', 'fupi'),
		'field_id' 			=> 'hide_author_id',
		'option_arr_id'		=> $option_arr_id,
	),
	array(
		'type'	 			=> 'taxonomies multi checkbox',
		'label' 			=> esc_html__( 'Do not track terms of these taxonomies:', 'fupi' ),
		'field_id' 			=> 'hidden_taxonomies',
		'option_arr_id'		=> $option_arr_id,
		'label_for' 		=> $option_arr_id . '[hidden_taxonomies]',
		'under field' 		=> esc_html__('Specify which terms (attached to posts, pages, custom post types and attachment pages) should not be tracked by Full Picture.', 'fupi')
	),
	array(
		'type'	 			=> 'toggle',
		'label' 			=> esc_html__('Allow tracking emails of logged-in users', 'fupi'),
		'field_id' 			=> 'allow_tracking_user_emails',
		'option_arr_id'		=> $option_arr_id,
		'under field' 		=> esc_html__('Attention! Do NOT cache pages for logged-in users - it may expose their email address to other logged-in users.', 'fupi'),
	),
	array(
		'type'	 			=> 'toggle',
		'label' 			=> esc_html__('Allow tracking usernames of logged-in users', 'fupi'),
		'field_id' 			=> 'allow_tracking_usernames',
		'option_arr_id'		=> $option_arr_id,
		'under field' 		=> esc_html__('Attention! Do NOT cache pages for logged-in users - it may expose their username to other logged-in users.', 'fupi'),
	),
	array(
		'type'	 			=> 'toggle',
		'label' 			=> esc_html__('Use shortcodes for Full Picture\'s Custom Events', 'fupi'),
		'field_id' 			=> 'enable_shortcodes',
		'option_arr_id'		=> $option_arr_id,
		'under field' 		=> sprintf(esc_html__('When you enable this option users with "post edit" permission will be able to add Full Picture\'s Custom Events for e-commerce tracking. Make sure you trust those users. %1sLearn more about FP Custom Events%2s', 'fupi'), '<a href="https://fullpictureplugin.com/?p=797&utm_source=useradmin&utm_medium=settings&utm_campaign=settings_link" target="_blank">', '</a>'),
	),
);

foreach( $fields as $field ){
	add_settings_field( $field['field_id'], $field['label'], array( $this, 'fupi_field_html' ), $page, $section_id, $field );
}

// USER ACCESS

$section_id = 'fupi_main_roles';
add_settings_section( $section_id, esc_html__( 'User access (PRO)', 'fupi' ), array( $this, 'fupi_sections_descriptions'), $page );

$fields = array(
	array(
		'type' 				=> 'text',
		'label' 			=> esc_html__( 'Let users with this capability view and save Full Picture\'s settings:', 'fupi' ),
		'field_id' 			=> 'user_cap',
		'placeholder'		=> 'manage_options',
		'class'				=> $disable_for_free_class,
		'option_arr_id'		=> $option_arr_id,
		'label_for' 		=> $option_arr_id . '[user_cap]',
		'under field'		=> sprintf(esc_html__( '%1$sList of standard WP capabilities%2$s. Please note that other plugins may add their own capabilities.%3$s Attention. This does not give the user access to cookie custmisation screen in the theme customizer. This field can only be modified by the site\'s administrator.', 'fupi'), '<a href="https://wordpress.org/support/article/roles-and-capabilities/#capability-vs-role-table" target="_blank">', '</a>', '<br><br>'),
	),
);

foreach( $fields as $field ){
	add_settings_field( $field['field_id'], $field['label'], array( $this, 'fupi_field_html' ), $page, $section_id, $field );
}

// PRIVACY POLICY

$section_id = 'fupi_main_privacy_policy';
add_settings_section( $section_id, esc_html__( 'Privacy policy extras', 'fupi' ), array( $this, 'fupi_sections_descriptions'), $page );

// OTHER SETTINGS

$section_id = 'fupi_main_other';
add_settings_section( $section_id, esc_html__( 'Other', 'fupi' ), array( $this, 'fupi_sections_descriptions'), $page );

$fields = array(
	array(
		'type' 				=> 'text',
		'label' 			=> esc_html__( 'Change WP menu item text from "Full Picture" to:', 'fupi' ),
		'field_id' 			=> 'custom_menu_title',
		'option_arr_id'		=> $option_arr_id,
		'label_for' 		=> $option_arr_id . '[custom_menu_title]',
	),
	array(
		'type' 				=> 'toggle',
		'label' 			=> esc_html__( 'Debug mode', 'fupi' ),
		'field_id' 			=> 'debug',
		'option_arr_id'		=> $option_arr_id,
		'after field' 		=> sprintf(esc_html__(' %1$sLearn more%2$s.', 'fupi'), '<a href="https://fullpictureplugin.com/?p=1133&utm_source=useradmin&utm_medium=settings&utm_campaign=settings_link" target="_blank">', '</a>'),
	),
	array(
		'type' 				=> 'toggle',
		'label' 			=> esc_html__( 'Remove all Full Picture\'s settings on deactivation', 'fupi' ),
		'field_id' 			=> 'clean_all',
		'option_arr_id'		=> $option_arr_id,
	),
);

foreach( $fields as $field ){
	add_settings_field( $field['field_id'], $field['label'], array( $this, 'fupi_field_html' ), $page, $section_id, $field );
}

?>
