<?php

$page = 'fupi_pla';

$section_id = 'fupi_pla_main';
add_settings_section( $section_id, esc_html__( 'Basic settings', 'fupi' ), array( $this, 'fupi_sections_descriptions'), $page );

$fields = array(
	array(
		'type'	 			=> 'text',
		'label' 			=> esc_html__( 'Domain name', 'fupi' ),
		'field_id' 			=> 'domain',
		'option_arr_id'		=> $option_arr_id,
		'label_for' 		=> $option_arr_id . '[domain]',
		'placeholder'		=> $_SERVER['HTTP_HOST'],
		'default'			=> $_SERVER['HTTP_HOST'],
		'class'				=> 'fupi_required fupi_easy',
		'under field'		=> sprintf(esc_html__( 'This field was automatically filled with the domain of your site. %1$sRegister it in your Plausible\'s dashboard%2$s to start using Plausible. Change it if it is incorrect for any reason.', 'fupi'), '<a href="https://plausible.io/docs/add-website" target="_blank">', '</a>'),
	),
	array(
		'type'	 			=> 'text',
		'label' 			=> esc_html__( 'Script source domain', 'fupi' ),
		'field_id' 			=> 'custom_domain',
		'option_arr_id'		=> $option_arr_id,
		'label_for' 		=> $option_arr_id . '[custom_domain]',
		'default'			=> 'plausible.io',
		'class'				=> 'fupi_required fupi_easy',
		'under field'		=> sprintf( esc_html__( 'This field should contain the domain where the Plausible script is hosted. It can be: %4$s%5$sPlausible\'s own domain (plausible.io - default)%6$s%5$s%2$syour custom domain for bypassing ad-blockers (advanced)%1$s%6$s%5$s%3$sor the domain of your self-hosted plausible installation (expert)%1$s%6$s%7$sLeave it as is if you are unsure.', 'fupi'),
		'</a>', // 1
		'<a href="https://plausible.io/docs/proxy/introduction" target="_blank">', // 2
		'<a href="https://plausible.io/docs/self-hosting" target="_blank">', // 3
		'<ol>', // 4
		'<li>', // 5
		'</li>', // 6
		'</ol>' // 7
		),
	),
	array(
		'type'	 			=> 'text',
		'label' 			=> esc_html__( 'View your site\'s statistics in WordPress admin', 'fupi' ),
		'field_id' 			=> 'shared_link_url',
		'option_arr_id'		=> $option_arr_id,
		'label_for' 		=> $option_arr_id . '[shared_link_url]',
		'placeholder'		=> 'https://example.com/share/mysite.com?auth=XXXXXXXXXXXXX',
		'class'				=> 'fupi_easy',
		'el_class'			=> 'fupi_condition',
		'el_data_target'	=> 'fupi_shared_link_url',
		'under field'		=> sprintf(esc_html__( 'Enter %1$sshared link\'s URL%2$s from Plausible\'s dashboard, save the field and refresh the page. Your statistics will be visible under "Dashboard" menu item. Attention! If stats don\'t show up do not set a password while generating the link!', 'fupi'), '<a href="https://plausible.io/docs/shared-links" target="_blank">', '</a>'),
	),
		array(
			'type'	 			=> 'text',
			'label' 			=> esc_html__( 'Let users with this capability view the statistics page', 'fupi' ),
			'field_id' 			=> 'stats_page_cap',
			'option_arr_id'		=> $option_arr_id,
			'label_for' 		=> $option_arr_id . '[stats_page_cap]',
			'placeholder'		=> 'manage_options',
			'class'				=> 'fupi_sub fupi_shared_link_url fupi_disabled ' . $disable_for_free_class,
			'under field'		=> sprintf(esc_html__( 'Default is "manage_options" capability available only for site administrators. Enter a different capability to let users with different roles view statistics page. %1$sList of standard capabilities%2$s.', 'fupi'), '<a href="https://wordpress.org/support/article/roles-and-capabilities/#capability-vs-role-table" target="_blank">', '</a>'),
		),
);

foreach( $fields as $field ){
	add_settings_field( $field['field_id'], $field['label'], array( $this, 'fupi_field_html' ), $page, $section_id, $field );
}

// BLIND SPOT TRACKING

$section_id 		= 'fupi_pla_blindspot';
add_settings_section( $section_id, esc_html__( 'Blind spot tracking*', 'fupi' ), array( $this, 'fupi_sections_descriptions'), $page );

$fields = array(
	array(
		'type'	 			=> 'text',
		'label' 			=> esc_html__( 'Track how many people block ads and other tracking tools', 'fupi' ),
		'field_id' 			=> 'detect_adblock_2',
		'placeholder'		=> 'goal name',
		'option_arr_id'		=> $option_arr_id,
		'label_for' 		=> $option_arr_id . '[detect_adblock_2]',
		'el_class'			=> 'fupi_condition',
		'el_data_target'	=> 'fupi_adblock_test_cond',
		'under field'		=> sprintf( esc_html__( 'Enter goal name to enable. %1sLearn how to set up goals%2s When enabled, this will send to Plausible information whenever a visitor uses an ad blocker on their device. Apart from blocking ads, ad blockers also prevent other tracking tools from working. Ad block usage is counted on every page load.', 'fupi'), '<a href="https://plausible.io/docs/custom-event-goals#2-create-a-custom-event-goal-in-your-plausible-analytics-account" target="_blank">', '</a><br><br>'),
	),
	array(
		'type'	 			=> 'toggle',
		'label' 			=> esc_html__( 'Check adblock usage once per session', 'fupi' ),
		'field_id' 			=> 'detect_adblock_per_session',
		'option_arr_id'		=> $option_arr_id,
		'class'				=> 'fupi_sub fupi_adblock_test_cond fupi_disabled',
		'under field'		=> esc_html__( 'Recommended. Enable this option to minimize the number of events sent to Plausible. If you leave this option disabled then ad blockers will be checked on every pageview.', 'fupi'),
	),
	array(
		'type'	 			=> 'text',
		'label' 			=> esc_html__( 'Track how many people decline cookies', 'fupi' ),
		'field_id' 			=> 'track_cookie_decline_2',
		'placeholder'		=> 'goal name',
		'option_arr_id'		=> $option_arr_id,
		'label_for' 		=> $option_arr_id . '[track_cookie_decline_2]',
		'under field'		=> sprintf( esc_html__( 'Enter goal name to enable. %1sLearn how to set up goals%2s Attention. This metric will be collected separately from the ad block usage tracking. In other words, if someone uses an ad blocker and then clicks a "decline cookies" button, they will still be counted in this metric.', 'fupi'), '<a href="https://plausible.io/docs/custom-event-goals#2-create-a-custom-event-goal-in-your-plausible-analytics-account" target="_blank">', '</a><br><br>'),
	),
);

foreach( $fields as $field ){
	add_settings_field( $field['field_id'], $field['label'], array( $this, 'fupi_field_html' ), $page, $section_id, $field );
}

// EVENT TRACKING - NEW

$section_id 		= 'fupi_pla_events_2';
add_settings_section( $section_id, esc_html__( 'Events tracking', 'fupi' ), array( $this, 'fupi_sections_descriptions'), $page );

$fields = array(
	array(
		'type'	 			=> 'text',
		'label' 			=> esc_html__( 'Track clicks in contact links', 'fupi' ),
		'field_id' 			=> 'track_contact_links',
		'placeholder'		=> 'goal name',
		'option_arr_id'		=> $option_arr_id,
		'label_for' 		=> $option_arr_id . '[track_contact_links]',
		'under field'		=> sprintf( esc_html__( 'Enter goal name to enable. %1sLearn how to set up goals%2s', 'fupi'), '<a href="https://plausible.io/docs/custom-event-goals#2-create-a-custom-event-goal-in-your-plausible-analytics-account" target="_blank">', '</a>'),
	),
	array(
		'type'	 			=> 'text',
		'label' 			=> esc_html__( 'Enable tracking affiliate links', 'fupi' ),
		'field_id' 			=> 'track_affiliate_goalname',
		'el_class'			=> 'fupi_condition',
		'el_data_target'	=> 'fupi_affiliate_subs',
		'placeholder'		=> 'goal name',
		'option_arr_id'		=> $option_arr_id,
		'label_for' 		=> $option_arr_id . '[track_affiliate_goalname]',
		'under field'		=> sprintf( esc_html__( 'Enter goal name to enable. %1sLearn how to set up goals%2s', 'fupi'), '<a href="https://plausible.io/docs/custom-event-goals#2-create-a-custom-event-goal-in-your-plausible-analytics-account" target="_blank">', '</a>'),
	),
		array(
			'type'	 			=> 'repeater',
			'label' 			=> esc_html__( 'Track:', 'fupi' ),
			'field_id' 			=> 'track_affiliate_2',
			'class'				=> 'fupi_sub fupi_affiliate_subs fupi_disabled fupi_repeater_section',
			'el_data_field1_txt' => esc_html__( 'link part, e.g. /go/', 'fupi' ),
			'el_data_field1_type' => 'url_part',
			'el_data_field1_req' => esc_html__( 'this field is required', 'fupi' ),
			'el_data_field1_err' => '',
			'el_data_field2_txt' => esc_html__( 'link name (optional)', 'fupi' ),
			'el_data_field2_err' => esc_html__( 'only alphanumeric characters, spaces, hyphens, underscores and [ ] symbols', 'fupi' ),
			'option_arr_id'		=> $option_arr_id,
			'label_for' 		=> $option_arr_id . '[track_affiliate_2]',
			'under field' 		=> esc_html__( 'If you don\'t provide a name, a full link address will be visible in Plausible\'s report.', 'fupi' ),
		),
	array(
		'type'	 			=> 'text',
		'label' 			=> esc_html__( 'Enable tracking clicks on page elements', 'fupi' ),
		'field_id' 			=> 'track_elems_goalname',
		'el_class'			=> 'fupi_condition',
		'el_data_target'	=> 'fupi_elems_subs',
		'placeholder'		=> 'goal name',
		'option_arr_id'		=> $option_arr_id,
		'label_for' 		=> $option_arr_id . '[track_elems_goalname]',
		'under field'		=> sprintf( esc_html__( 'Enter goal name to enable. %1sLearn how to set up goals%2s', 'fupi'), '<a href="https://plausible.io/docs/custom-event-goals#2-create-a-custom-event-goal-in-your-plausible-analytics-account" target="_blank">', '</a>'),
	),
		array(
			'type'	 			=> 'repeater',
			'label' 			=> esc_html__( 'Track:', 'fupi' ),
			'field_id' 			=> 'track_elems_2',
			'class'				=> 'fupi_sub fupi_elems_subs fupi_disabled fupi_repeater_section',
			'el_data_field1_txt' => esc_html__( 'e.g. #wrapper img', 'fupi' ),
			'el_data_field1_req' => esc_html__( 'this field is required', 'fupi' ),
			'el_data_field1_err' => esc_html__( 'incorrect selector', 'fupi' ),
			'el_data_field2_txt' => esc_html__( 'element name (required)', 'fupi' ),
			'el_data_field2_req' => esc_html__( 'this field is required', 'fupi' ),
			'el_data_field2_err' => esc_html__( 'only alphanumeric characters, spaces, hyphens, underscores and [ ] symbols', 'fupi' ),
			'option_arr_id'		=> $option_arr_id,
			'label_for' 		=> $option_arr_id . '[track_elems_2]',
		),
	array(
		'type'	 			=> 'text',
		'label' 			=> esc_html__( 'Enable tracking form submissions', 'fupi' ),
		'field_id' 			=> 'track_forms_goalname',
		'el_class'			=> 'fupi_condition',
		'el_data_target'	=> 'fupi_forms_subs',
		'placeholder'		=> 'goal name',
		'option_arr_id'		=> $option_arr_id,
		'label_for' 		=> $option_arr_id . '[track_forms_goalname]',
		'under field'		=> sprintf( esc_html__( 'Enter goal name to enable. %1$sLearn how to set up goals%2$s Test this feature after enabling. There are many methods of submitting forms. If this method of tracking fails on your form, track clicks on submit button instead.', 'fupi'), '<a href="https://plausible.io/docs/custom-event-goals#2-create-a-custom-event-goal-in-your-plausible-analytics-account" target="_blank">', '</a><br><br>'),
	),
		array(
			'type'	 			=> 'repeater',
			'label' 			=> esc_html__( 'Track:', 'fupi' ),
			'field_id' 			=> 'track_forms_2',
			'class'				=> 'fupi_sub fupi_forms_subs fupi_disabled fupi_repeater_section',
			'el_data_field1_txt' => esc_html__( 'e.g. #form_id', 'fupi' ),
			'el_data_field1_req' => esc_html__( 'this field is required', 'fupi' ),
			'el_data_field1_err' => esc_html__( 'incorrect selector', 'fupi' ),
			'el_data_field2_txt' => esc_html__( 'form name (required)', 'fupi' ),
			'el_data_field2_req' => esc_html__( 'this field is required', 'fupi' ),
			'el_data_field2_err' => esc_html__( 'only alphanumeric characters, spaces, hyphens, underscores and [ ] symbols', 'fupi' ),
			'option_arr_id'		=> $option_arr_id,
			'label_for' 		=> $option_arr_id . '[track_forms_2]',
		),
	array(
		'type'	 			=> 'text',
		'label' 			=> esc_html__( 'Enable tracking clisks in file download links', 'fupi' ),
		'field_id' 			=> 'track_file_downl_goalname',
		'el_class'			=> 'fupi_condition',
		'el_data_target'	=> 'fupi_downl_subs',
		'placeholder'		=> 'goal name',
		'option_arr_id'		=> $option_arr_id,
		'label_for' 		=> $option_arr_id . '[track_forms_goalname]',
		'under field'		=> sprintf( esc_html__( 'Enter goal name to enable. %1$sLearn how to set up goals%2$s Test this feature after enabling.', 'fupi'), '<a href="https://plausible.io/docs/custom-event-goals#2-create-a-custom-event-goal-in-your-plausible-analytics-account" target="_blank">', '</a>'),
	),
		array(
			'type'	 			=> 'text',
			'label' 			=> esc_html__( 'Track clicks on file download links', 'fupi' ),
			'field_id' 			=> 'track_file_downl',
			'placeholder'		=> 'e.g. pdf, doc, docx, xls, xlsx, txt',
			'class'				=> 'fupi_sub fupi_downl_subs fupi_disabled fupi_repeater_section',
			'option_arr_id'		=> $option_arr_id,
			'label_for' 		=> $option_arr_id . '[track_file_downl]',
			'under field'		=> esc_html__( 'Enter coma separated list of file formats (extensions) you want to track', 'fupi'),
		),
);

foreach( $fields as $field ){
	add_settings_field( $field['field_id'], $field['label'], array( $this, 'fupi_field_html' ), $page, $section_id, $field );
}

// WOOCOMMERCE

$section_id 		= 'fupi_pla_ecomm';
add_settings_section( $section_id, esc_html__( 'E-Commerce tracking (PRO)', 'fupi' ), array( $this, 'fupi_sections_descriptions'), $page );

$fields = array(
	array(
		'type'	 			=> 'text',
		'label' 			=> esc_html__( 'Track purchases', 'fupi' ),
		'field_id' 			=> 'track_purchases',
		'placeholder'		=> 'goal name',
		'option_arr_id'		=> $option_arr_id,
		'label_for' 		=> $option_arr_id . '[track_purchases]',
		'class'				=> $disable_for_free_class,
		'el_class'			=> 'fupi_condition',
		'el_data_target'	=> 'fupi_track_woo_purchases',
		'tooltip'			=> esc_html__( 'Tracked values: order\'s value, tax amount and shipping cost.', 'fupi'),
		'under field'		=> sprintf( esc_html__( 'Enter goal name to enable. %1sLearn how to set up goals%2s', 'fupi'), '<a href="https://plausible.io/docs/custom-event-goals#2-create-a-custom-event-goal-in-your-plausible-analytics-account" target="_blank">', '</a>'),
	),
		array(
			'type'	 			=> 'text',
			'label' 			=> esc_html__( 'Track purchased items', 'fupi' ),
			'field_id' 			=> 'track_purchased_items',
			'option_arr_id'		=> $option_arr_id,
			'label_for' 		=> $option_arr_id . '[track_purchased_items]',
			'class'				=> 'fupi_sub fupi_track_woo_purchases fupi_disabled' . $disable_for_free_class,
			'tooltip'			=> esc_html__( 'Tracked values: product id, name, value, category and quantity.', 'fupi'),
			'under field'		=> sprintf( esc_html__( 'Enter goal name to enable. %1sLearn how to set up goals%2s Attention! Each item in the order is tracked with a separate event!', 'fupi'), '<a href="https://plausible.io/docs/custom-event-goals#2-create-a-custom-event-goal-in-your-plausible-analytics-account" target="_blank">', '</a><br><br>'),
		),
	array(
		'type'	 			=> 'text',
		'label' 			=> esc_html__( 'Track when a customer begins checkout', 'fupi' ),
		'field_id' 			=> 'track_checkouts',
		'placeholder'		=> 'goal name',
		'option_arr_id'		=> $option_arr_id,
		'label_for' 		=> $option_arr_id . '[track_checkouts]',
		'class'				=> $disable_for_free_class,
		'el_class'			=> 'fupi_condition',
		'el_data_target'	=> 'fupi_track_woo_checkouts',
		'tooltip'		=> esc_html__( 'Tracked values: cart value.', 'fupi'),
		'under field'		=> sprintf( esc_html__( 'Enter goal name to enable. %1sLearn how to set up goals%2s', 'fupi'), '<a href="https://plausible.io/docs/custom-event-goals#2-create-a-custom-event-goal-in-your-plausible-analytics-account" target="_blank">', '</a>'),
	),
		array(
			'type'	 			=> 'text',
			'label' 			=> esc_html__( 'Track items in cart during checkout', 'fupi' ),
			'field_id' 			=> 'track_checkout_items',
			'option_arr_id'		=> $option_arr_id,
			'label_for' 		=> $option_arr_id . '[track_checkout_items]',
			'class'				=> 'fupi_sub fupi_track_woo_checkouts fupi_disabled ' . $disable_for_free_class,
			'tooltip'			=> esc_html__( 'Tracked values: product id, name, value, category and quantity.', 'fupi'),
			'under field'		=> sprintf( esc_html__( 'Enter goal name to enable. %1sLearn how to set up goals%2s Attention! Each item in cart is tracked with a separate event!', 'fupi'), '<a href="https://plausible.io/docs/custom-event-goals#2-create-a-custom-event-goal-in-your-plausible-analytics-account" target="_blank">', '</a><br><br>'),
		),
	array(
		'type'	 			=> 'text',
		'label' 			=> esc_html__( 'Track products added to cart', 'fupi' ),
		'field_id' 			=> 'track_addtocart',
		'placeholder'		=> 'goal name',
		'option_arr_id'		=> $option_arr_id,
		'label_for' 		=> $option_arr_id . '[track_addtocart]',
		'class'				=> $disable_for_free_class,
		'tooltip'			=> esc_html__( 'Tracked values: product id, name, value, category and quantity.', 'fupi'),
		'under field'		=> sprintf( esc_html__( 'Enter goal name to enable. %1sLearn how to set up goals%2s Attention! If a grouped product is added to cart, each item in the group will be tracked with a separate event!', 'fupi'), '<a href="https://plausible.io/docs/custom-event-goals#2-create-a-custom-event-goal-in-your-plausible-analytics-account" target="_blank">', '</a><br><br>' ),
	),
	array(
		'type'	 			=> 'text',
		'label' 			=> esc_html__( 'Track products added to wishlist', 'fupi' ),
		'field_id' 			=> 'track_addtowishlist',
		'placeholder'		=> 'goal name',
		'option_arr_id'		=> $option_arr_id,
		'label_for' 		=> $option_arr_id . '[track_addtowishlist]',
		'class'				=> $disable_for_free_class,
		'tooltip'			=> esc_html__( 'Tracked values: product id, name, value and category.', 'fupi'),
		'under field'		=> sprintf( esc_html__( 'Enter goal name to enable. %1sLearn how to set up goals%2s', 'fupi'), '<a href="https://plausible.io/docs/custom-event-goals#2-create-a-custom-event-goal-in-your-plausible-analytics-account" target="_blank">', '</a><br><br>' ),
	),
);

foreach( $fields as $field ){
	add_settings_field( $field['field_id'], $field['label'], array( $this, 'fupi_field_html' ), $page, $section_id, $field );
}

// OLD TRACKING

$section_id 		= 'fupi_pla_events';
add_settings_section( $section_id, esc_html__( 'Deprecated**', 'fupi' ), array( $this, 'fupi_sections_descriptions'), $page );

$fields = array(
	array(
		'type'	 			=> 'text',
		'label' 			=> esc_html__( 'Track clicks in email links', 'fupi' ),
		'field_id' 			=> 'track_mail_links',
		'placeholder'		=> 'goal name',
		'option_arr_id'		=> $option_arr_id,
		'label_for' 		=> $option_arr_id . '[track_mail_links]',
		'under field'		=> sprintf( esc_html__( 'Enter goal name to enable. %1sLearn how to set up goals%2s', 'fupi'), '<a href="https://plausible.io/docs/custom-event-goals#2-create-a-custom-event-goal-in-your-plausible-analytics-account" target="_blank">', '</a>'),
	),
	array(
		'type'	 			=> 'text',
		'label' 			=> esc_html__( 'Track clicks in phone links', 'fupi' ),
		'field_id' 			=> 'track_tel_links',
		'placeholder'		=> 'goal name',
		'option_arr_id'		=> $option_arr_id,
		'label_for' 		=> $option_arr_id . '[track_tel_links]',
		'under field'		=> sprintf( esc_html__( 'Enter goal name to enable. %1sLearn how to set up goals%2s', 'fupi'), '<a href="https://plausible.io/docs/custom-event-goals#2-create-a-custom-event-goal-in-your-plausible-analytics-account" target="_blank">', '</a>'),
	),
	array(
		'type'	 			=> 'text',
		'label' 			=> esc_html__( 'Track clicks in cookie-notice button "Agree" (to all cookies)', 'fupi' ),
		'field_id' 			=> 'track_cookie_agree_all',
		'placeholder'		=> 'goal name',
		'option_arr_id'		=> $option_arr_id,
		'label_for' 		=> $option_arr_id . '[track_cookie_agree_all]',
		'under field'		=> sprintf( esc_html__( 'Enter goal name to enable. %1sLearn how to set up goals%2s', 'fupi'), '<a href="https://plausible.io/docs/custom-event-goals#2-create-a-custom-event-goal-in-your-plausible-analytics-account" target="_blank">', '</a>'),
	),
	array(
		'type'	 			=> 'text',
		'label' 			=> esc_html__( 'Track how many people decline cookies', 'fupi' ),
		'field_id' 			=> 'track_cookie_decline',
		'placeholder'		=> 'goal name',
		'option_arr_id'		=> $option_arr_id,
		'label_for' 		=> $option_arr_id . '[track_cookie_decline]',
		'under field'		=> sprintf( esc_html__( 'Enter goal name to enable. %1sLearn how to set up goals%2s', 'fupi'), '<a href="https://plausible.io/docs/custom-event-goals#2-create-a-custom-event-goal-in-your-plausible-analytics-account" target="_blank">', '</a>'),
	),
	array(
		'type'	 			=> 'text',
		'label' 			=> esc_html__( 'Track clicks in cookie-notice button "Agree" (to selected cookies)', 'fupi' ),
		'field_id' 			=> 'track_cookie_agree_some',
		'placeholder'		=> 'goal name',
		'option_arr_id'		=> $option_arr_id,
		'label_for' 		=> $option_arr_id . '[track_cookie_agree_some]',
		'under field'		=> sprintf( esc_html__( 'Enter goal name to enable. %1sLearn how to set up goals%2s', 'fupi'), '<a href="https://plausible.io/docs/custom-event-goals#2-create-a-custom-event-goal-in-your-plausible-analytics-account" target="_blank">', '</a>'),
	),
	array(
		'type'	 			=> 'repeater',
		'label' 			=> esc_html__( 'Track clicks on affiliate links', 'fupi' ),
		'field_id' 			=> 'track_affiliate',
		'class'				=> 'fupi_repeater_section',
		'el_data_field1_txt' => esc_html__( 'url part, e.g. /go/', 'fupi' ),
		'el_data_field1_type' => 'url_part',
		'el_data_field1_req' => esc_html__( 'this field is required', 'fupi' ),
		'el_data_field1_err' => '',
		'el_data_field2_txt' => esc_html__( 'Plausible\'s goal name', 'fupi' ),
		'el_data_field2_req' => esc_html__( 'this field is required', 'fupi' ),
		'el_data_field2_err' => esc_html__( 'only alphanumeric characters, spaces, hyphens, underscores and [ ] symbols', 'fupi' ),
		'option_arr_id'		=> $option_arr_id,
		'label_for' 		=> $option_arr_id . '[track_affiliate]',
		'under field'		=> sprintf( esc_html__( 'Enter goal name to enable. %1sLearn how to set up goals%2s', 'fupi'), '<a href="https://plausible.io/docs/custom-event-goals#2-create-a-custom-event-goal-in-your-plausible-analytics-account" target="_blank">', '</a>'),
	),
	array(
		'type'	 			=> 'repeater',
		'label' 			=> esc_html__( 'Track clicks on page elements', 'fupi' ),
		'field_id' 			=> 'track_elems',
		'class'				=> 'fupi_repeater_section',
		'el_data_field1_txt' => esc_html__( 'CSS selector e.g. #sth img', 'fupi' ),
		'el_data_field1_req' => esc_html__( 'this field is required', 'fupi' ),
		'el_data_field1_err' => esc_html__( 'incorrect selector', 'fupi' ),
		'el_data_field2_txt' => esc_html__( 'Plausible\'s goal name', 'fupi' ),
		'el_data_field2_req' => esc_html__( 'this field is required', 'fupi' ),
		'el_data_field2_err' => esc_html__( 'only alphanumeric characters, spaces, hyphens, underscores and [ ] symbols', 'fupi' ),
		'option_arr_id'		=> $option_arr_id,
		'label_for' 		=> $option_arr_id . '[track_elems]',
		'under field'		=> sprintf( esc_html__( 'Enter goal name to enable. %1sLearn how to set up goals%2s', 'fupi'), '<a href="https://plausible.io/docs/custom-event-goals#2-create-a-custom-event-goal-in-your-plausible-analytics-account" target="_blank">', '</a>'),
	),
	array(
		'type'	 			=> 'repeater',
		'label' 			=> esc_html__( 'Track form submissions', 'fupi' ),
		'field_id' 			=> 'track_forms',
		'class'				=> 'fupi_repeater_section',
		'el_data_field1_txt' => esc_html__( 'CSS selector e.g. #form_id', 'fupi' ),
		'el_data_field1_req' => esc_html__( 'this field is required', 'fupi' ),
		'el_data_field1_err' => esc_html__( 'incorrect selector', 'fupi' ),
		'el_data_field2_txt' => esc_html__( 'Plausible\'s goal name', 'fupi' ),
		'el_data_field2_req' => esc_html__( 'this field is required', 'fupi' ),
		'el_data_field2_err' => esc_html__( 'only alphanumeric characters, spaces, hyphens, underscores and [ ] symbols', 'fupi' ),
		'option_arr_id'		=> $option_arr_id,
		'label_for' 		=> $option_arr_id . '[track_forms]',
		'under field'		=> sprintf( esc_html__( 'Enter goal name to enable. %1sLearn how to set up goals%2s', 'fupi'), '<a href="https://plausible.io/docs/custom-event-goals#2-create-a-custom-event-goal-in-your-plausible-analytics-account" target="_blank">', '</a>'),
	),
		array(
			'type'	 			=> 'text',
			'label' 			=> esc_html__( 'Track how many people use ad blockers', 'fupi' ),
			'field_id' 			=> 'detect_adblock',
			'class'				=> 'fupi_sub fupi_adblock_subs fupi_disabled',
			'placeholder'		=> 'goal name',
			'option_arr_id'		=> $option_arr_id,
			'label_for' 		=> $option_arr_id . '[detect_adblock]',
			'under field'		=> sprintf( esc_html__( 'Enter goal name to enable. %1sLearn how to set up goals%2s', 'fupi'), '<a href="https://plausible.io/docs/custom-event-goals#2-create-a-custom-event-goal-in-your-plausible-analytics-account" target="_blank">', '</a>'),
		),
);

foreach( $fields as $field ){
	add_settings_field( $field['field_id'], $field['label'], array( $this, 'fupi_field_html' ), $page, $section_id, $field );
}

?>
