<?php

$page = 'fupi_tools';

// TOOLS

$section_id = 'fupi_tools_integrations';
add_settings_section( $section_id, esc_html__( 'Integrations', 'fupi' ), array( $this, 'fupi_sections_descriptions'), $page );

$fields = array(

	// GA 4
	array(
		'type' 				=> 'toggle',
		'label' 			=> '<div class="fupi_field_title_wrap"><img class="fupi_label_icon" src="' . FUPI_URL . 'admin/settings/img/analytics_fav.png" aria-hidden="true">Google Analytics 4</div>',
		'field_id' 			=> 'ga41',
		'option_arr_id'		=> $option_arr_id,
		'class'				=> 'fupi_tag fupi_tag_analytics fupi_tag_conversion fupi_uses_cookies fupi_has_no_admin_dash',
		'el_class'			=> 'fupi_condition fupi_module',
		'el_data_target'	=> 'fupi_ga4_subs',
		'el_data_name'		=> 'Google Analytics 4',
		'after field' 		=> esc_html__('The latest version of Google Analytics.', 'fupi'),
		'tooltip'			=> esc_html__('We recommend using GA 4 along with Google Analytics UA for better insights.', 'fupi'),
	),

	// GA 4 #2
	array(
		'type' 				=> 'toggle',
		'label' 			=> '<div class="fupi_field_title_wrap"><img class="fupi_label_icon" src="' . FUPI_URL . 'admin/settings/img/analytics_fav.png" aria-hidden="true">Google Analytics 4 #2</div>',
		'field_id' 			=> 'ga42',
		'option_arr_id'		=> $option_arr_id,
		'class'				=> 'fupi_tag fupi_sub fupi_ga4_subs fupi_disabled fupi_tag_analytics fupi_tag_conversion fupi_uses_cookies fupi_has_no_admin_dash ' . $disable_for_free_class,
		'el_class'			=> 'fupi_module',
		'el_data_name'		=> 'Google Analytics 4 #2',
		'after field' 		=> esc_html__('Track data with an additional Google Analytics 4 account.', 'fupi'),
		'tooltip'			=> esc_html__('We recommend using GA 4 along with Google Analytics UA for better insights.', 'fupi'),
	),

	// GA UA #1
	array(
		'type' 				=> 'toggle',
		'label' 			=> '<div class="fupi_field_title_wrap"><img class="fupi_label_icon" src="' . FUPI_URL . 'admin/settings/img/analytics_fav.png" aria-hidden="true">Google Analytics UA</div>',
		'field_id' 			=> 'ga1',
		'option_arr_id'		=> $option_arr_id,
		'class'				=> 'fupi_tag fupi_tag_analytics fupi_tag_conversion fupi_uses_cookies fupi_has_no_admin_dash',
		'el_class'			=> 'fupi_condition fupi_module',
		'el_data_target'	=> 'fupi_ga_subs',
		'el_data_name'		=> 'Google Analytics UA',
		'after field' 		=> esc_html__('Previous version of Google Analytics (Universal Analytics).', 'fupi'),
	),

	// GA UA #2
	array(
		'type' 				=> 'toggle',
		'label' 			=> '<div class="fupi_field_title_wrap"><img class="fupi_label_icon" src="' . FUPI_URL . 'admin/settings/img/analytics_fav.png" aria-hidden="true">Google Analytics UA #2</div>',
		'field_id' 			=> 'ga2',
		'option_arr_id'		=> $option_arr_id,
		'class'				=> 'fupi_tag fupi_sub fupi_ga_subs fupi_disabled fupi_tag_analytics fupi_tag_conversion fupi_uses_cookies fupi_has_no_admin_dash ' . $disable_for_free_class,
		'el_class'			=> 'fupi_module',
		'el_data_name'		=> 'Google Analytics UA #2',
		'after field' 		=> esc_html__('Send data to an additional Google Analytics Universal Analytics account.', 'fupi'),
	),

	// Google Optimize
	array(
		'type' 				=> 'toggle',
		'label' 			=> '<div class="fupi_field_title_wrap"><img class="fupi_label_icon" src="' . FUPI_URL . 'admin/settings/img/goptimize_fav.png" aria-hidden="true">Google Optimize</div>',
		'field_id' 			=> 'gopt',
		'option_arr_id'		=> $option_arr_id,
		'class'				=> 'fupi_tag fupi_tag_testing fupi_uses_cookies fupi_has_no_admin_dash',
		'el_class'			=> 'fupi_module',
		'el_data_name'		=> 'Google Optimize',
		'after field' 		=> esc_html__('Test what content works best and personalise your site for your visitors.', 'fupi'),
		'tooltip' 			=> sprintf( esc_html__('%1$sAttention.%2$s A/B tests are recommended for sites with large traffic (required to reach accurate test results).', 'fupi'), '<strong>', '</strong>' ),
	),

	// Google Ads
	array(
		'type' 				=> 'toggle',
		'label' 			=> '<div class="fupi_field_title_wrap"><img class="fupi_label_icon" src="' . FUPI_URL . 'admin/settings/img/gads_fav.png" aria-hidden="true">Google Ads</div>',
		'field_id' 			=> 'gads',
		'option_arr_id'		=> $option_arr_id,
		'class'				=> 'fupi_tag fupi_tag_conversion fupi_uses_cookies fupi_has_no_admin_dash ' . $disable_for_free_class,
		'el_class'			=> 'fupi_module',
		'el_data_name'		=> 'Google Ads',
		'after field' 		=> esc_html__('Track conversions from your Google Ads advertisements.', 'fupi'),
	),

	// FB Pixel #1
	array(
		'type' 				=> 'toggle',
		'label' 			=> '<div class="fupi_field_title_wrap"><img class="fupi_label_icon" src="' . FUPI_URL . 'admin/settings/img/facebook_fav.png" aria-hidden="true">Facebook Pixel</div>',
		'field_id' 			=> 'fbp1',
		'option_arr_id'		=> $option_arr_id,
		'class'				=> 'fupi_tag fupi_tag_conversion fupi_uses_cookies fupi_has_no_admin_dash',
		'el_class'			=> 'fupi_condition fupi_module',
		'el_data_target'	=> 'fupi_fbp_subs',
		'el_data_name'		=> 'Facebook Pixel',
		'after field' 		=> esc_html__('Create remarketing list for Facebook ads.', 'fupi'),
	),

	// FB Pixel #2
	array(
		'type' 				=> 'toggle',
		'label' 			=> '<div class="fupi_field_title_wrap"><img class="fupi_label_icon" src="' . FUPI_URL . 'admin/settings/img/facebook_fav.png" aria-hidden="true">Facebook Pixel #2</div>',
		'field_id' 			=> 'fbp2',
		'option_arr_id'		=> $option_arr_id,
		'class'				=> 'fupi_tag fupi_tag_conversion fupi_sub fupi_fbp_subs fupi_disabled fupi_uses_cookies fupi_has_no_admin_dash ' . $disable_for_free_class,
		'el_class'			=> 'fupi_module',
		'el_data_name'		=> 'Facebook Pixel #2',
		'after field' 		=> esc_html__('Send data to an additional Facebook Pixel.', 'fupi'),
	),

	// Plausible
	array(
		'type' 				=> 'toggle',
		'label' 			=> '<div class="fupi_field_title_wrap"><img class="fupi_label_icon" src="' . FUPI_URL . 'admin/settings/img/plausible_fav.png" aria-hidden="true">Plausible</div>',
		'field_id' 			=> 'pla',
		'option_arr_id'		=> $option_arr_id,
		'class'				=> 'fupi_tag fupi_tag_analytics',
		'el_class'			=> 'fupi_module',
		'el_data_name'		=> 'Plausible',
		'after field' 		=> esc_html__('Simple statistics that don\'t require cookie notice.', 'fupi'),
	),

	// Microsoft Advertising
	array(
		'type' 				=> 'toggle',
		'label' 			=> '<div class="fupi_field_title_wrap"><img class="fupi_label_icon" src="' . FUPI_URL . 'admin/settings/img/microsoft_fav.png" aria-hidden="true">Microsoft Advertising</div>',
		'field_id' 			=> 'mads',
		'option_arr_id'		=> $option_arr_id,
		'class'				=> 'fupi_tag fupi_tag_conversion fupi_uses_cookies fupi_has_no_admin_dash ' . $disable_for_free_class,
		'el_class'			=> 'fupi_module',
		'el_data_name'		=> 'MS Ads',
		'after field' 		=> esc_html__('Track conversions from your Microsoft Ads advertisements.', 'fupi'),
	),

	// MS Clarity
	array(
		'type' 				=> 'toggle',
		'label' 			=> '<div class="fupi_field_title_wrap"><img class="fupi_label_icon" src="' . FUPI_URL . 'admin/settings/img/microsoft_fav.png" aria-hidden="true">Microsoft Clarity</div>',
		'field_id' 			=> 'clar',
		'option_arr_id'		=> $option_arr_id,
		'class'				=> 'fupi_tag fupi_tag_recording fupi_uses_cookies fupi_has_no_admin_dash',
		'el_class'			=> 'fupi_module',
		'el_data_name'		=> 'MS Clarity',
		'after field' 		=> esc_html__('Record user sessions, view click and scroll heatmaps for free.', 'fupi'),
		'tooltip' 			=> sprintf( esc_html__('%1$sAttention!%2$s Due to occasionally missing recordings we recommend this tool for non-professional use cases only.).', 'fupi'), '<strong>', '</strong>' ),
	),

	// GTM
	array(
		'type' 				=> 'toggle',
		'label' 			=> '<div class="fupi_field_title_wrap"><img class="fupi_label_icon" src="' . FUPI_URL . 'admin/settings/img/gtm_fav.png" aria-hidden="true">Google Tag Manager</div>',
		'field_id' 			=> 'gtm',
		'option_arr_id'		=> $option_arr_id,
		'class'				=> 'fupi_tag fupi_tag_tagmanager fupi_has_no_admin_dash',
		'el_class'			=> 'fupi_module',
		'el_data_name'		=> 'GTM',
		'after field' 		=> esc_html__('Connect your site to even more platforms and apps.', 'fupi'),
	),

	// Twitter
	array(
		'type' 				=> 'toggle',
		'label' 			=> '<div class="fupi_field_title_wrap"><img class="fupi_label_icon" src="' . FUPI_URL . 'admin/settings/img/twitter-fav.png" aria-hidden="true">Twitter Ads</div>',
		'field_id' 			=> 'twit',
		'option_arr_id'		=> $option_arr_id,
		'class'				=> 'fupi_tag fupi_tag_conversion fupi_uses_cookies fupi_has_no_admin_dash '  . $disable_for_free_class,
		'el_class'			=> 'fupi_module',
		'el_data_name'		=> 'Twitter Ads',
		'after field' 		=> esc_html__('Track conversions originating from Twitter.', 'fupi'),
	),

	// Pinterest
	array(
		'type' 				=> 'toggle',
		'label' 			=> '<div class="fupi_field_title_wrap"><img class="fupi_label_icon" src="' . FUPI_URL . 'admin/settings/img/pinterest_fav.png" aria-hidden="true">Pinterest Conversion Tag</div>',
		'field_id' 			=> 'pin',
		'option_arr_id'		=> $option_arr_id,
		'class'				=> 'fupi_tag fupi_tag_conversion fupi_uses_cookies fupi_has_no_admin_dash ' . $disable_for_free_class,
		'el_class'			=> 'fupi_module',
		'el_data_name'		=> 'Pinterest',
		'after field' 		=> esc_html__('Track conversions originating from Pinterest.', 'fupi'),
	),

	// Hotjar
	array(
		'type' 				=> 'toggle',
		'label' 			=> '<div class="fupi_field_title_wrap"><img class="fupi_label_icon" src="' . FUPI_URL . 'admin/settings/img/hotjar_fav.png" aria-hidden="true">Hotjar</div>',
		'field_id' 			=> 'hotj',
		'option_arr_id'		=> $option_arr_id,
		'class'				=> 'fupi_tag fupi_tag_recording fupi_tag_surveys fupi_uses_cookies fupi_has_no_admin_dash',
		'el_class'			=> 'fupi_module',
		'el_data_name'		=> 'Hotjar',
		'after field' 		=> esc_html__('Record user sessions, view click and scroll heatmaps and conduct surveys.', 'fupi'),
	),

	// LinkedIn
	array(
		'type' 				=> 'toggle',
		'label' 			=> '<div class="fupi_field_title_wrap"><img class="fupi_label_icon" src="' . FUPI_URL . 'admin/settings/img/linkedin-fav.png" aria-hidden="true">Linked In Insight</div>',
		'field_id' 			=> 'linkd',
		'option_arr_id'		=> $option_arr_id,
		'class'				=> 'fupi_tag fupi_tag_conversion fupi_uses_cookies fupi_has_no_admin_dash ',
		'el_class'			=> 'fupi_module',
		'el_data_name'		=> 'Linked In',
		'after field' 		=> esc_html__('Track conversions originating from Linked In via Linked In Insight Tag.', 'fupi'),
	),

	// Crazy Egg
	array(
		'type' 				=> 'toggle',
		'label' 			=> '<div class="fupi_field_title_wrap"><img class="fupi_label_icon" src="' . FUPI_URL . 'admin/settings/img/crazyegg_fav.png" aria-hidden="true">Crazy Egg</div>',
		'field_id' 			=> 'cegg',
		'option_arr_id'		=> $option_arr_id,
		'class'				=> 'fupi_tag fupi_tag_testing fupi_tag_recording fupi_uses_cookies fupi_has_no_admin_dash',
		'el_class'			=> 'fupi_module',
		'el_data_name'		=> 'Crazy Egg',
		'after field' 		=> esc_html__('Record user sessions, view click and scroll heatmaps and optimize your site with A/B tests.', 'fupi'),
		'tooltip' 			=> sprintf( esc_html__('%1$sAttention%2$s. A/B tests are recommended for sites with large traffic (required for accurate test results).', 'fupi'), '<strong>', '</strong>' ),
	),

	// Inspectlet
	array(
		'type' 				=> 'toggle',
		'label' 			=> '<div class="fupi_field_title_wrap"><img class="fupi_label_icon" src="' . FUPI_URL . 'admin/settings/img/inspectlet_fav.png" aria-hidden="true">Inspectlet</div>',
		'field_id' 			=> 'insp',
		'option_arr_id'		=> $option_arr_id,
		'class'				=> 'fupi_tag fupi_tag_recording fupi_tag_testing fupi_uses_cookies fupi_has_no_admin_dash',
		'el_class'			=> 'fupi_module',
		'el_data_name'		=> 'Inspectlet',
		'after field' 		=> esc_html__('Record user sessions, view click and scroll heatmaps and optimize your site with A/B tests.', 'fupi'),
		'tooltip' 			=> sprintf( esc_html__('%1$sAttention%2$s. A/B tests are recommended for sites with large traffic (required for accurate test results).', 'fupi'), '<strong>', '</strong>' ),
	),

	// Splitbee
	array(
		'type' 				=> 'toggle',
		'label' 			=> '<div class="fupi_field_title_wrap"><img class="fupi_label_icon" src="' . FUPI_URL . 'admin/settings/img/splitbee_fav.png" aria-hidden="true">Splitbee</div>',
		'field_id' 			=> 'sbee',
		'option_arr_id'		=> $option_arr_id,
		'class'				=> 'fupi_tag fupi_tag_analytics fupi_tag_testing fupi_has_no_admin_dash',
		'el_class'			=> 'fupi_module',
		'el_data_name'		=> 'Splitbee',
		'after field' 		=> esc_html__('View simple traffic traffic statistics and conduct basic A/B tests.', 'fupi'),
		'tooltip' 			=> sprintf( esc_html__('%1$sAttention%2$s. A/B tests are recommended for sites with large traffic (required for accurate test results).', 'fupi'), '<strong>', '</strong>' ),
	),
);

foreach( $fields as $field ){
	add_settings_field( $field['field_id'], $field['label'], array( $this, 'fupi_field_html' ), $page, $section_id, $field );
}

// DATA SOURCES

$section_id = 'fupi_tools_sources';
add_settings_section( $section_id, esc_html__( 'Data sources', 'fupi' ), array( $this, 'fupi_sections_descriptions'), $page );

$fields = array(
	array(
		'type' 				=> 'toggle',
		'label' 			=> '<div class="fupi_field_title_wrap"><img class="fupi_label_icon" src="' . FUPI_URL . 'admin/settings/img/woo_fav.png" aria-hidden="true">' . esc_html__('WooCommerce','fupi') . '</div>',
		'field_id' 			=> 'woo',
		'option_arr_id'		=> $option_arr_id,
		'class'				=> $disable_for_free_class,
		'after field'		=> esc_html__('Track E-Commerce events in your store. Supports WooCommerce 3.7 and newer.','fupi'),
	),
);

foreach( $fields as $field ){
	add_settings_field( $field['field_id'], $field['label'], array( $this, 'fupi_field_html' ), $page, $section_id, $field );
}

// COOKIE NOTICE

$section_id = 'fupi_tools_other';
add_settings_section( $section_id, esc_html__( 'Cookie notice', 'fupi' ), array( $this, 'fupi_sections_descriptions'), $page );

$fields = array(
	array(
		'type'	 			=> 'toggle',
		'label' 			=> esc_html__( 'Cookie notice', 'fupi' ),
		'field_id' 			=> 'cook',
		'option_arr_id'		=> $option_arr_id,
		'el_class'			=> 'fupi_module fupi_condition',
		'el_data_target'	=> 'fupi_cookies_rules',
		'el_data_name'		=> esc_html__( 'Cookie notice', 'fupi' ),
		'after field'		=> esc_html__( 'Highly customizable, translatable and powerful cookie notice', 'fupi' ),
	),
	array(
		'type'				=> 'hidden',
		'field_id' 			=> 'fupi_db_ver', // database version
		'value'				=> '2.0.0',
		'label'				=> '', // not used but required in foreach below
	)
);

foreach( $fields as $field ){
	add_settings_field( $field['field_id'], $field['label'], array( $this, 'fupi_field_html' ), $page, $section_id, $field );
}

?>
