<?php

class Fupi_Public
{
    private  $plugin_name ;
    private  $version ;
    public function __construct( $plugin_name, $version )
    {
        $this->plugin_name = $plugin_name;
        $this->version = $version;
        // tools & main opts
        $this->main = get_option( 'fupi_main' );
        $this->tools = get_option( 'fupi_tools' );
        if ( empty($this->tools) ) {
            $this->tools = $this->main;
        }
        if ( empty($this->tools) ) {
            return;
        }
        // cookie notice opts
        $this->cook = get_option( 'fupi_cook' );
        if ( empty($this->cook) ) {
            $this->cook = $this->main;
        }
        // other opts
        $this->woo = get_option( 'fupi_woo' );
        // Cookie notice
        $this->cookie_notice_enabled = isset( $this->tools['cookie_notice'] ) || isset( $this->tools['cook'] );
        // Integrations
        $this->ga41_enabled = isset( $this->tools['ga41'] );
        $this->ga42_enabled = isset( $this->tools['ga42'] );
        $this->ga1_enabled = isset( $this->tools['ga1'] );
        $this->ga2_enabled = isset( $this->tools['ga2'] );
        $this->goptimize_enabled = isset( $this->tools['gopt'] );
        $this->gads_enabled = isset( $this->tools['gads'] );
        $this->mads_enabled = isset( $this->tools['mads'] );
        $this->fbp1_enabled = isset( $this->tools['fbp1'] );
        $this->fbp2_enabled = isset( $this->tools['fbp2'] );
        $this->gtm_enabled = isset( $this->tools['gtm'] );
        $this->twit_enabled = isset( $this->tools['twit'] );
        $this->pin_enabled = isset( $this->tools['pin'] );
        $this->clar_enabled = isset( $this->tools['clar'] );
        $this->linkd_enabled = isset( $this->tools['linkd'] );
        $this->hotj_enabled = isset( $this->tools['hotj'] );
        $this->pla_enabled = isset( $this->tools['pla'] );
        $this->sbee_enabled = isset( $this->tools['sbee'] );
        $this->inspectlet_enabled = isset( $this->tools['insp'] );
        $this->crazyegg_enabled = isset( $this->tools['cegg'] );
        // Settings
        $this->noscript_support = isset( $this->main['noscript'] );
        $this->is_debug = isset( $this->main['debug'] );
        $this->enable_shortcodes = isset( $this->main['enable_shortcodes'] );
        // Other
        $this->gtag_id = false;
        
        if ( $this->ga1_enabled ) {
            $ga1_opts = get_option( 'fupi_ga1' );
            $this->gtag_id = ( isset( $ga1_opts['tracking_id'] ) ? esc_attr( $ga1_opts['tracking_id'] ) : false );
        } else {
            
            if ( $this->ga41_enabled ) {
                $ga41_opts = get_option( 'fupi_ga41' );
                $this->gtag_id = ( isset( $ga41_opts['id'] ) ? esc_attr( $ga41_opts['id'] ) : false );
            }
        
        }
    
    }
    
    public function fupi_get_data()
    {
        if ( empty($this->tools) ) {
            return;
        }
        global  $wp ;
        global  $post ;
        $this->is_customizer = is_customize_preview();
        $this->user_is_logged_in = is_user_logged_in();
        $output = '<script id=\'fp_data_js\' type="text/javascript">';
        $data = [];
        // data added to this array is printed as the main JS data object for the frontend
        include_once dirname( __FILE__ ) . '/modules/in_head/data-main.php';
        include_once dirname( __FILE__ ) . '/modules/in_head/data-wp.php';
        if ( !empty($this->woo_enabled) ) {
            include_once dirname( __FILE__ ) . '/modules/in_head/data-woo__premium_only.php';
        }
        include_once dirname( __FILE__ ) . '/modules/in_head/data-tools.php';
        // print data object
        $output .= "fp.data = " . json_encode( $data ) . ";\n";
        // ADD OTHER SCRIPTS
        include_once dirname( __FILE__ ) . '/modules/in_head/head-js.php';
        $output .= '</script>';
        echo  $output ;
    }
    
    public function fupi_enqueue_public_scripts()
    {
        if ( empty($this->tools) ) {
            return;
        }
        // JS HELPERS
        /* ^ */
        wp_enqueue_script(
            'fupi-helpers-js',
            plugin_dir_url( __FILE__ ) . 'helpers/fupi-helpers.js',
            array(),
            $this->version,
            false
        );
        // also sets fp.cookies!
        /* _ */
        wp_enqueue_script(
            'fupi-helpers-footer-js',
            plugin_dir_url( __FILE__ ) . 'helpers/fupi-helpers-footer.js',
            array( 'fupi-helpers-js' ),
            $this->version,
            true
        );
        // COOKIE NOTICE
        
        if ( $this->cookie_notice_enabled ) {
            if ( $this->is_customizer || $this->track_current_user && !$this->is_customizer ) {
                /* ^ */
                wp_enqueue_style(
                    'fupi-cookie-notice',
                    plugin_dir_url( __FILE__ ) . 'cookie-notice/css/fupi-cookie-notice.min.css',
                    array(),
                    $this->version,
                    'all'
                );
            }
            
            if ( $this->is_customizer ) {
                /* _ */
                wp_enqueue_script(
                    'fupi-customizer-cookie-notice-js',
                    plugin_dir_url( __FILE__ ) . 'cookie-notice/js/fupi-customizer-cookie-notice.js',
                    array( 'fupi-helpers-js', 'jquery' ),
                    $this->version,
                    true
                );
            } else {
                if ( $this->track_current_user ) {
                    /* _ */
                    wp_enqueue_script(
                        'fupi-cookie-notice-js',
                        plugin_dir_url( __FILE__ ) . 'cookie-notice/js/fupi-cookie-notice.js',
                        array( 'fupi-helpers-js', 'fupi-helpers-footer-js' ),
                        $this->version,
                        true
                    );
                }
            }
        
        }
        
        // GTM
        
        if ( $this->gtm_enabled && $this->track_current_user && !$this->is_customizer ) {
            /* ^ */
            wp_enqueue_script(
                'fupi-gtm-head-js',
                plugin_dir_url( __FILE__ ) . 'modules/js/fupi-gtm.js',
                array( 'fupi-helpers-js' ),
                $this->version,
                false
            );
            /* _ */
            wp_enqueue_script(
                'fupi-gtm-footer-js',
                plugin_dir_url( __FILE__ ) . 'modules/js/fupi-gtm-footer.js',
                array( 'fupi-helpers-js', 'fupi-helpers-footer-js', 'fupi-gtm-head-js' ),
                $this->version,
                true
            );
        }
        
        // Google Optimize (loaded with optimize.js)
        
        if ( $this->track_current_user && !$this->is_customizer && $this->goptimize_enabled ) {
            $this->gopts = get_option( 'fupi_gopts' );
            if ( !isset( $this->gopts['main_load_method'] ) || $this->gopts['main_load_method'] != 'gtag' ) {
                // the "isset" part is for backwards compatibility with FP 1.2 that had no GTAG integration
                /* ^ */
                wp_enqueue_script(
                    'fupi-gopt-head-js',
                    plugin_dir_url( __FILE__ ) . 'modules/js/fupi-goptimize.js',
                    array( 'fupi-helpers-js' ),
                    $this->version,
                    false
                );
            }
        }
        
        // GTAG / GOOGLE ANALYTICS / GOOGLE ADS
        
        if ( $this->track_current_user && !$this->is_customizer && ($this->ga1_enabled || $this->ga41_enabled || $this->gads_enabled) ) {
            $reqs = array( 'fupi-helpers-js' );
            // GOOGLE ANALYTICS (UA)
            
            if ( $this->ga1_enabled ) {
                /* ^ */
                wp_enqueue_script(
                    'fupi-ga-head-js',
                    plugin_dir_url( __FILE__ ) . 'modules/js/fupi-ga.js',
                    array( 'fupi-helpers-js' ),
                    $this->version,
                    false
                );
                /* _ */
                wp_enqueue_script(
                    'fupi-ga-footer-js',
                    plugin_dir_url( __FILE__ ) . 'modules/js/fupi-ga-footer.js',
                    array( 'fupi-ga-head-js', 'fupi-helpers-footer-js' ),
                    $this->version,
                    true
                );
                array_push( $reqs, 'fupi-ga-head-js' );
            }
            
            // GOOGLE ANALYTICS 4
            
            if ( $this->ga41_enabled ) {
                /* ^ */
                wp_enqueue_script(
                    'fupi-ga4-head-js',
                    plugin_dir_url( __FILE__ ) . 'modules/js/fupi-ga4.js',
                    array( 'fupi-helpers-js' ),
                    $this->version,
                    false
                );
                /* _ */
                wp_enqueue_script(
                    'fupi-ga4-footer-js',
                    plugin_dir_url( __FILE__ ) . 'modules/js/fupi-ga4-footer.js',
                    array( 'fupi-ga4-head-js', 'fupi-helpers-footer-js' ),
                    $this->version,
                    true
                );
                array_push( $reqs, 'fupi-ga4-head-js' );
            }
            
            // GTAG
            /* ^ */
            wp_enqueue_script(
                'fupi-gtag-head-js',
                plugin_dir_url( __FILE__ ) . 'modules/js/fupi-gtag.js',
                $reqs,
                $this->version,
                false
            );
        }
        
        // FB PIXEL
        
        if ( $this->fbp1_enabled && $this->track_current_user && !$this->is_customizer ) {
            /* ^ */
            wp_enqueue_script(
                'fupi-fbp-head-js',
                plugin_dir_url( __FILE__ ) . 'modules/js/fupi-fbp.js',
                array( 'fupi-helpers-js' ),
                $this->version,
                false
            );
            /* _ */
            wp_enqueue_script(
                'fupi-fbp-footer-js',
                plugin_dir_url( __FILE__ ) . 'modules/js/fupi-fbp-footer.js',
                array( 'fupi-fbp-head-js', 'fupi-helpers-footer-js' ),
                $this->version,
                true
            );
        }
        
        // TWITTER
        if ( $this->twit_enabled && $this->track_current_user && !$this->is_customizer ) {
            /* ^ */
            wp_enqueue_script(
                'fupi-twit-head-js',
                plugin_dir_url( __FILE__ ) . 'modules/js/fupi-twit__premium_only.js',
                array( 'fupi-helpers-js' ),
                $this->version,
                false
            );
        }
        // LINKEDIN
        if ( $this->linkd_enabled && $this->track_current_user && !$this->is_customizer ) {
            /* _ */
            wp_enqueue_script(
                'fupi-linkd-footer-js',
                plugin_dir_url( __FILE__ ) . 'modules/js/fupi-linkd-footer.js',
                array( 'fupi-helpers-footer-js' ),
                $this->version,
                true
            );
        }
        // CLARITY
        
        if ( $this->clar_enabled && $this->track_current_user && !$this->is_customizer ) {
            /* ^ */
            wp_enqueue_script(
                'fupi-clar-head-js',
                plugin_dir_url( __FILE__ ) . 'modules/js/fupi-clar.js',
                array( 'fupi-helpers-js' ),
                $this->version,
                false
            );
            /* _ */
            wp_enqueue_script(
                'fupi-clar-footer-js',
                plugin_dir_url( __FILE__ ) . 'modules/js/fupi-clar-footer.js',
                array( 'fupi-clar-head-js', 'fupi-helpers-footer-js' ),
                $this->version,
                true
            );
        }
        
        // HOTJAR
        
        if ( $this->hotj_enabled && $this->track_current_user && !$this->is_customizer ) {
            /* ^ */
            wp_enqueue_script(
                'fupi-hotj-head-js',
                plugin_dir_url( __FILE__ ) . 'modules/js/fupi-hotj.js',
                array( 'fupi-helpers-js' ),
                $this->version,
                false
            );
            /* _ */
            wp_enqueue_script(
                'fupi-hotj-footer-js',
                plugin_dir_url( __FILE__ ) . 'modules/js/fupi-hotj-footer.js',
                array( 'fupi-hotj-head-js', 'fupi-helpers-footer-js' ),
                $this->version,
                true
            );
        }
        
        // INSPECTLET
        
        if ( $this->inspectlet_enabled && $this->track_current_user && !$this->is_customizer ) {
            /* ^ */
            wp_enqueue_script(
                'fupi-insp-head-js',
                plugin_dir_url( __FILE__ ) . 'modules/js/fupi-insp.js',
                array( 'fupi-helpers-js' ),
                $this->version,
                false
            );
            /* _ */
            wp_enqueue_script(
                'fupi-insp-footer-js',
                plugin_dir_url( __FILE__ ) . 'modules/js/fupi-insp-footer.js',
                array( 'fupi-insp-head-js', 'fupi-helpers-footer-js' ),
                $this->version,
                true
            );
        }
        
        // CRAZYEGG
        
        if ( $this->crazyegg_enabled && $this->track_current_user && !$this->is_customizer ) {
            /* ^ */
            wp_enqueue_script(
                'fupi-cegg-head-js',
                plugin_dir_url( __FILE__ ) . 'modules/js/fupi-cegg.js',
                array( 'fupi-helpers-js' ),
                $this->version,
                false
            );
            /* _ */
            wp_enqueue_script(
                'fupi-cegg-footer-js',
                plugin_dir_url( __FILE__ ) . 'modules/js/fupi-cegg-footer.js',
                array( 'fupi-cegg-head-js', 'fupi-helpers-footer-js' ),
                $this->version,
                true
            );
        }
        
        // PLAUSIBLE
        
        if ( $this->pla_enabled && $this->track_current_user && !$this->is_customizer ) {
            /* ^ */
            wp_enqueue_script(
                'fupi-pla-head-js',
                plugin_dir_url( __FILE__ ) . 'modules/js/fupi-pla.js',
                array( 'fupi-helpers-js' ),
                $this->version,
                false
            );
            /* _ */
            wp_enqueue_script(
                'fupi-pla-footer-js',
                plugin_dir_url( __FILE__ ) . 'modules/js/fupi-pla-footer.js',
                array( 'fupi-pla-head-js', 'fupi-helpers-footer-js' ),
                $this->version,
                true
            );
        }
        
        // SPLITBEE
        
        if ( $this->sbee_enabled && $this->track_current_user && !$this->is_customizer ) {
            /* ^ */
            wp_enqueue_script(
                'fupi-sbee-head-js',
                plugin_dir_url( __FILE__ ) . 'modules/js/fupi-sbee.js',
                array( 'fupi-helpers-js' ),
                $this->version,
                false
            );
            /* _ */
            wp_enqueue_script(
                'fupi-sbee-footer-js',
                plugin_dir_url( __FILE__ ) . 'modules/js/fupi-sbee-footer.js',
                array( 'fupi-sbee-head-js', 'fupi-helpers-footer-js' ),
                $this->version,
                true
            );
        }
    
    }
    
    //
    // OUTPUT IN FOOTER with PHP
    //
    public function fupi_output_in_footer()
    {
        if ( empty($this->tools) ) {
            return;
        }
        // COOKIE NOTICE HTML
        if ( $this->cookie_notice_enabled ) {
            if ( $this->is_customizer || $this->track_current_user && !$this->is_customizer ) {
                include_once dirname( __FILE__ ) . '/cookie-notice/fupi-display-cookie-notice.php';
            }
        }
        // NOSCRIPT TAGS
        if ( $this->noscript_support && $this->track_current_user && !$this->is_customizer ) {
            include_once dirname( __FILE__ ) . '/modules/in_footer/noscript-fallbacks.php';
        }
    }
    
    //
    // SHORTCODES
    //
    public function fupi_add_shortcodes()
    {
        if ( empty($this->tools) ) {
            return;
        }
        add_shortcode( 'fp_info', array( $this, 'fupi_info' ) );
        
        if ( $this->enable_shortcodes ) {
            add_shortcode( 'fp_set', array( $this, 'fupi_set' ) );
            add_shortcode( 'fp_track', array( $this, 'fupi_track' ) );
        } else {
            add_shortcode( 'fp_set', array( $this, 'fupi_set_blank' ) );
            add_shortcode( 'fp_track', array( $this, 'fupi_track_blank' ) );
        }
    
    }
    
    public function fupi_set( $atts, $content = null )
    {
        $a = shortcode_atts( array(
            'name'      => '',
            'overwrite' => '',
        ), $atts );
        
        if ( !empty($a['name']) ) {
            $name_e = esc_attr( $a['name'] );
            $overwrite_e = ( !empty($a['overwrite']) ? esc_attr( $a['overwrite'] ) : '' );
            $safe_content = strip_tags( stripslashes( $content ) );
            $lines = preg_split( "/\r\n|\n|\r/", $safe_content );
            $max = count( $lines );
            $i = 0;
            $data = '';
            // BUILD DATA OBJ
            for (;  $i < $max ;  $i++ ) {
                
                if ( strpos( $lines[$i], ':' ) !== false ) {
                    $line_a = explode( ':', $lines[$i], 2 );
                    $limit = 2;
                    $key = str_replace(
                        '^',
                        "'",
                        trim( $line_a[0] ),
                        $limit
                    );
                    // @ 2.0 - added limit to 2 replacements for security
                    $value = str_replace(
                        '^',
                        "'",
                        trim( $line_a[1] ),
                        $limit
                    );
                    // @ 2.0 - added limit to 2 replacements for security
                    $data .= $key . ' : ' . $value . ',';
                }
            
            }
            return "<script>FP.set('{$name_e}', {{$data}}, '{$overwrite_e}')</script>";
        }
    
    }
    
    public function fupi_track( $atts, $content = null )
    {
        $a = shortcode_atts( array(
            'data'       => '',
            'event'      => '',
            'trigger'    => '',
            'condition'  => '',
            'passed_val' => '',
        ), $atts );
        
        if ( !empty($a['event']) && !empty($a['trigger']) ) {
            $data_e = esc_attr( $a['data'] );
            $event_e = esc_attr( $a['event'] );
            $trigger_e = esc_attr( $a['trigger'] );
            $cond_e = esc_attr( $a['condition'] );
            $passed_val_e = esc_attr( $a['passed_val'] );
            return "<script>FP.track( '{$data_e}', '{$event_e}', '{$trigger_e}', '{$cond_e}', '{$passed_val_e}' );</script>";
        }
    
    }
    
    public function fupi_info( $atts, $content = null )
    {
        $a = shortcode_atts( array(
            'display' => 'list',
        ), $atts );
        $output = '<ol class="fupi_privacy fupi_display_as_' . esc_attr( $a['display'] ) . '">';
        if ( $this->ga41_enabled || $this->ga1_enabled ) {
            $output .= '<li>Google Analytics</li>';
        }
        if ( $this->fbp1_enabled ) {
            $output .= '<li>Facebook</li>';
        }
        if ( $this->goptimize_enabled ) {
            $output .= '<li>Google Optimize</li>';
        }
        if ( $this->twit_enabled ) {
            $output .= '<li>Twitter</li>';
        }
        if ( $this->gads_enabled ) {
            $output .= '<li>Google Ads</li>';
        }
        if ( $this->clar_enabled ) {
            $output .= '<li>Microsoft Clarity</li>';
        }
        if ( $this->hotj_enabled ) {
            $output .= '<li>Hotjar</li>';
        }
        if ( $this->crazyegg_enabled ) {
            $output .= '<li>Crazy Egg</li>';
        }
        if ( $this->pla_enabled ) {
            $output .= '<li>Plausible Analytics</li>';
        }
        if ( $this->sbee_enabled ) {
            $output .= '<li>Splitbee</li>';
        }
        if ( $this->inspectlet_enabled ) {
            $output .= '<li>Inspectlet</li>';
        }
        $output .= '</ol>';
        return $output;
    }
    
    // these functions hide shortcodes from the output
    public function fupi_set_blank()
    {
        return '';
    }
    
    public function fupi_track_blank()
    {
        return '';
    }
    
    //
    // CUSTOM TAXONOMY
    //
    public function fupi_page_labels()
    {
        $labels = array(
            'name'                       => _x( 'Labels', 'Taxonomy General Name', 'fupi' ),
            'singular_name'              => _x( 'Label', 'Taxonomy Singular Name', 'fupi' ),
            'menu_name'                  => __( 'Labels', 'fupi' ),
            'all_items'                  => __( 'All labels', 'fupi' ),
            'parent_item'                => __( 'Parent label', 'fupi' ),
            'parent_item_colon'          => __( 'Parent Item:', 'fupi' ),
            'new_item_name'              => __( 'New Label Name', 'fupi' ),
            'add_new_item'               => __( 'Add New Label', 'fupi' ),
            'edit_item'                  => __( 'Edit Label', 'fupi' ),
            'update_item'                => __( 'Update Label', 'fupi' ),
            'view_item'                  => __( 'View Label', 'fupi' ),
            'separate_items_with_commas' => __( 'Separate labels with commas', 'fupi' ),
            'add_or_remove_items'        => __( 'Add or remove labels', 'fupi' ),
            'choose_from_most_used'      => __( 'Choose from the most used', 'fupi' ),
            'popular_items'              => __( 'Popular labels', 'fupi' ),
            'search_items'               => __( 'Search labels', 'fupi' ),
            'not_found'                  => __( 'Not Found', 'fupi' ),
            'no_terms'                   => __( 'No labels', 'fupi' ),
            'items_list'                 => __( 'Labels list', 'fupi' ),
            'items_list_navigation'      => __( 'Labels list navigation', 'fupi' ),
        );
        $args = array(
            'labels'            => $labels,
            'hierarchical'      => false,
            'public'            => true,
            'show_ui'           => true,
            'show_admin_column' => true,
            'show_in_nav_menus' => false,
            'show_tagcloud'     => false,
            'show_in_rest'      => true,
        );
        register_taxonomy( 'fupi_page_labels', array( 'page' ), $args );
    }

}