<?php

// these vars will be used in other files too
$enable_scripts_after = ( !empty($this->cook['enable_scripts_after']) ? esc_attr( $this->cook['enable_scripts_after'] ) : 'consent' );
// check if current user role should be tracked
$this->track_current_user = true;
$disable_for_roles = ( !empty($this->main) && isset( $this->main['disable_for_roles'] ) ? $this->main['disable_for_roles'] : [ 'administrator' ] );
$user = wp_get_current_user();
if ( !empty($user) ) {
    foreach ( $user->roles as $role ) {
        if ( in_array( $role, $disable_for_roles ) ) {
            $this->track_current_user = false;
        }
    }
}
$data['vars'] = [
    'url'                   => FUPI_URL,
    'admin_url'             => admin_url( 'admin-ajax.php' ),
    'is_customizer'         => $this->is_customizer,
    'debug'                 => $this->is_debug,
    'track_current_user'    => $this->track_current_user,
    'dblclck_time'          => ( !empty($this->main['notrack_dblclck']) ? esc_attr( $this->main['notrack_dblclck'] ) : 300 ),
    'link_click_delay'      => ( !empty($this->main['link_click_delay']) ? esc_attr( $this->main['link_click_delay'] ) : false ),
    'formsubm_trackdelay'   => ( !empty($this->main['formsubm_trackdelay']) ? esc_attr( $this->main['formsubm_trackdelay'] ) : 3 ),
    'magic_keyword'         => ( !empty($this->main['magic_keyword']) ? esc_attr( $this->main['magic_keyword'] ) : 'tracking' ),
    'reset_timer_on_anchor' => isset( $this->main['reset_timer_on_anchor'] ),
];

if ( $this->cookie_notice_enabled ) {
    $notice_data = get_option( 'fupi_cookie_notice' );
    // this data is set in customizer
    $cookie_notice_data = [
        'enabled'              => true,
        'enable_scripts_after' => $enable_scripts_after,
        'blur_page'            => ( !empty($notice_data) && !empty($notice_data['blur_page']) ? true : false ),
    ];
} else {
    $cookie_notice_data = [
        'enabled' => false,
    ];
}

$output .= 'var fp_premium = ' . json_encode( fupi_fs()->can_use_premium_code() ) . ',
	FP = {};
	fp = {};

fp.loaded = [];
fp.queue = [];
fp.data = {};
FP.fns = {};

fp.notice = ' . json_encode( $cookie_notice_data ) . ";\n\n";