<?php

$countries_to_show_notice_to = ( !empty($this->cook['show_to_countries']) ? esc_attr( $this->cook['show_to_countries'] ) : false );
$magic_keyword = ( !empty($this->main['magic_keyword']) ? esc_attr( $this->main['magic_keyword'] ) : 'tracking' );
// COOKIE SCRIPTS
$output .= '(function (FP) {

	\'use strict\';

	var _this = this;
	var d = document,
	w = window;

	FP.getUrlParamByName = function (name) {
		var match = RegExp(\'[?&]\' + name + \'=([^&]*)\').exec(window.location.search);
		return match && decodeURIComponent(match[1].replace(/\\+/g, \' \'));
	};

	FP.setCookie = function (name, value, days) {
		if (days > 1) {
			var date = new Date();
			date.setTime(date.getTime() + days * 24 * 60 * 60 * 1000);
			var expires = "; expires=" + date.toGMTString();
		} else {var expires = "";}
		d.cookie = name + "=" + value + expires + "; path=/; sameSite=strict";
	};

	FP.readCookie = function (name) {
		var nameEQ = name + "=";
		var ca = d.cookie.split(\';\');
		for (var i = 0; i < ca.length; i++) {
			var c = ca[i];
			while (c.charAt(0) == \' \') {c = c.substring(1, c.length);}
			if (c.indexOf(nameEQ) == 0) return c.substring(nameEQ.length, c.length);
		};
		return null;
	};

	FP.deleteCookie = function (name) { FP.setCookie(name, "", -1); };

	FP.getScript = function (src, func, attrs) {

		attrs = attrs || false;

		var s = d.createElement(\'script\');
		s.src = src;

		if (attrs) {
			for (var key in attrs) {
				s.setAttribute(key, attrs[key]);
			}
		}

		if (func) { s.onload = func; }

		d.getElementsByTagName("head")[0].appendChild(s);
	};

	// save important cookies in fp obj

	if ( FP.getUrlParamByName("' . $magic_keyword . '") ){
		var updated_cookies = { \'stats\' : false, \'personalisation\' : false, \'marketing\' : false, \'disabled\' : true, \'test\' : false, };
		FP.setCookie(\'fp_cookie\', JSON.stringify(updated_cookies), 7300);
		fp.cookies = updated_cookies;
	} else {
		var cookies = FP.readCookie(\'fp_cookie\');
		fp.cookies = cookies ? JSON.parse(cookies) : false;
	}

	if ( FP.readCookie(\'fp_session\') ) {
		fp.data.vars.new_session = false;
	} else {
		fp.data.vars.new_session = true;
		FP.setCookie(\'fp_session\', \'new\', 0);
	};

	var last_url = FP.readCookie(\'fupi_cur_url\');
	fp.data.vars.is_refresh = last_url == window.location.href ? true : false;

	FP.setCookie( \'fupi_cur_url\', window.location.href, 0 );

	// blur background

	if ( ! fp.data.vars.is_customizer && fp.notice.enabled && ! fp.cookies && fp.notice.blur_page ) {
		document.getElementsByTagName( \'html\' )[0].classList.add(\'fupi_blur\');
	}
';
// BROKEN LINK TRACKING + REDIRECT TO A CUSTOM 404 PAGE

if ( !empty($this->main['track_404']) && is_404() ) {
    $output .= "\nif( ! FP.getUrlParamByName('broken_link_location') ){\n";
    $redirect_404 = ( !empty($this->main['redirect_404']) ? esc_url( $this->main['redirect_404'] ) : false );
    
    if ( $redirect_404 && filter_var( $redirect_404, FILTER_VALIDATE_URL ) !== FALSE ) {
        $output .= "var target_URL_string = '{$redirect_404}',\n\r\n\t\t\t\t\t\t\ttarget_URL = new URL( target_URL_string );\n";
    } else {
        $output .= "var target_URL = window.location\n";
    }
    
    $output .= "window.location = target_URL + ( target_URL.search ? '&' : '?' ) + 'broken_link_location=' + ( document.referrer || 'direct_traffic_or_unknown' ) + '&broken_link=' + window.location;\n\r\n\t};\n";
}

// ADD IE CLASS TO HTML
$output .= "\n\n " . 'if ( window.navigator.userAgent.indexOf(\'Trident\') != -1 ) {
	document.getElementsByTagName( \'html\' )[0].classList.add(\'fupi_IE\');
}' . "\n\n";
// END FP CLOSURE
$output .= '})(FP);';