;(function(window){

	function cegg_user_var( var_no, type ) {

		// SEND USER ROLE
		if ( type == 'status_n_role' && fp.data.wp.user_role ) {
			window.CE2.set( var_no, fp.data.wp.user_role );
			if ( fp.data.vars.debug ) console.log('CEGG event: sent user role', fp.data.wp.user_role);
		}
	}

	FP.fns.load_cegg_footer = function() {

		// SEND USER VARIABLE 1 DATA
		if ( window.CE2 && fp.cegg.uservar_1 ) cegg_user_var('1', fp.cegg.uservar_1);

		// TAG WITH PAGE TYPE

		if ( fp.cegg.tag_pagetype && fp.data.wp.page_type ) {
			window.CE2.addTag( 'Page type: ' + fp.data.wp.page_type );
		};

		// TAG OUTBOUND LINKS

		var tag_outbound = function ( e, link ) {
			window.CE2.addTag( 'set', 'Outbound click: ' + link.href );
			if ( fp.data.vars.debug ) console.log('CEGG tag: outbound click', link.href);
		};

		if ( fp.cegg.tag_outbound ) FP.registerAction( ['on_click', 'on_middle_click'], 'outbound', [tag_outbound] );

		// TAG AFFILIATE LINKS

		var tag_affiliate_links = function ( e, link, name ) {
			window.CE2.addTag( 'Affiliate click: ' + name );
			if ( fp.data.vars.debug ) console.log('CEGG tag: affiliate click', name);
		};

		if ( fp.cegg.tag_affiliate ) {
			FP.splitTextarea( 'cegg', 'tag_affiliate' );
			FP.registerAction( ['on_click', 'on_middle_click'], 'affiliate', [tag_affiliate_links, fp.cegg.tag_affiliate] );
		};

		// TAG CLICKS ON EMAIL & TEL LINKS

		var tag_email_tel = function ( e, return_val ) {
			window.CE2.addTag( 'Contact click: ' + return_val[0].href );
			if ( fp.data.vars.debug ) console.log('CEGG tag: contact click', return_val[0].href);
		};

		if ( fp.cegg.tag_email_tel ) FP.registerAction( ['on_click', 'on_middle_click'], 'email_tel', [tag_email_tel] );

		// TAG FILE DOWNLOADS

		var tag_downloads = function ( e, filename ) {
			window.CE2.addTag( 'File download: ' + filename );
			if ( fp.data.vars.debug ) console.log('CEGG tag: download', filename);
		};

		if ( fp.cegg.tag_file_downl ) FP.registerAction( ['on_click', 'on_middle_click'], 'downl', [tag_downloads, fp.cegg.tag_file_downl] );

		// TAG CLICKS IN SPECIFIC ELEMENTS

		var tag_elems = function ( e, el, name ) {
			window.CE2.addTag( 'Element click: ' + name );
			if ( fp.data.vars.debug ) console.log('CEGG tag: element click', name);
		};

		if ( fp.cegg.tag_elems ) {
			FP.splitTextarea( 'cegg', 'tag_elems' );
			FP.registerAction( ['on_click', 'on_middle_click'], 'elem', [tag_elems, fp.cegg.tag_elems] );
		};

		// TAG FORM SUBMITS

		var tag_forms = function ( e, title ) {
			var name = title || location.host + location.pathname;
			window.CE2.addTag( 'Form submit: ' + name );
			if ( fp.data.vars.debug ) console.log('CEGG tag: form submit', name);
		};

		if ( fp.cegg.tag_forms ) {
			FP.splitTextarea( 'cegg', 'tag_forms' );
			FP.registerAction( 'on_form_submit', false, [ tag_forms, fp.cegg.tag_forms ] );
		}

		// TRACK VIEWS OF ELEMENTS

		var send_el_view_evt = function ( el ) {
			var name = el.dataset['fp_clar_name'] || 'name not provided';
			window.CE2.addTag( 'Element view: ' + name );
			if ( fp.data.vars.debug ) console.log('CEGG tag: element view', name);
		};

		if ( fp.cegg.tag_views ) {
			FP.splitTextarea( 'cegg', 'tag_views' );
			var selectors_a = FP.prepareElsForIntersObserver( fp.cegg.tag_views, 'fp_clar_name' );

			if ( selectors_a.length > 0 ) {
				var selectors_s = selectors_a.join(',');
				FP.intersectionObserver('clar_views', selectors_s, { rootMargin: '-200px 0px -200px 0px' }, send_el_view_evt, true);
			}
		}

		// TAG CLICKS IN ANCHORS

		var tag_anchor_clicks = function ( e, link ) {
			var href = link.getAttribute('href');
			window.CE2.addTag( 'Anchor click: ' + href );
			if ( fp.data.vars.debug ) console.log('CEGG tag: anchor click', href);
		};

		if ( fp.cegg.tag_anchor_clicks) FP.registerAction( 'on_click', 'anchors', [tag_anchor_clicks] );

		// MARK AS LOADED
		fp.loaded.push( 'cegg-footer' );
	}

	// INIT FOOTER SCRIPTS

	if ( fp.loaded.indexOf('cegg') != -1 ) FP.fns.load_cegg_footer();

})(window);
