;(function(window){

	FP.fns.load_clar_footer = function() {

		// TAG WITH PAGE TYPE

		if ( fp.clar.tag_pagetype && fp.data.wp.page_type ) {
			clarity( 'set', 'Page type', fp.data.wp.page_type );
		};

		// TAG OUTBOUND LINKS

		var tag_outbound = function ( e, link ) {
			clarity( 'set', 'Outbound link click', link.href );
			if ( fp.data.vars.debug ) console.log('MS Clarity tag: outbound click', link.href);
		};

		if ( fp.clar.tag_outbound ) FP.registerAction( ['on_click', 'on_middle_click'], 'outbound', [tag_outbound] );

		// TAG AFFILIATE LINKS

		var tag_affiliate_links = function ( e, link, name ) {
			clarity( 'set', 'Affiliate link click', name );
			if ( fp.data.vars.debug ) console.log('MS Clarity tag: affiliate click', name);
		};

		if ( fp.clar.tag_affiliate ) {
			FP.splitTextarea( 'clar', 'tag_affiliate' );
			FP.registerAction( ['on_click', 'on_middle_click'], 'affiliate', [tag_affiliate_links, fp.clar.tag_affiliate] );
		};

		// TAG CLICKS ON EMAIL & TEL LINKS

		var tag_email_tel = function ( e, return_val ) {
			clarity( 'set', 'Contact link click', return_val[0].href );
			if ( fp.data.vars.debug ) console.log('MS Clarity tag: contact click', return_val[0].href);
		};

		if ( fp.clar.tag_email_tel ) FP.registerAction( ['on_click', 'on_middle_click'], 'email_tel', [tag_email_tel] );

		// TAG FILE DOWNLOADS

		var tag_downloads = function ( e, filename ) {
			clarity( 'set', 'File download', filename );
			if ( fp.data.vars.debug ) console.log('MS Clarity tag: download', filename);
		};

		if ( fp.clar.tag_file_downl ) FP.registerAction( ['on_click', 'on_middle_click'], 'downl', [tag_downloads, fp.clar.tag_file_downl] );

		// TAG SPECIFIC ELEMENTS

		var tag_elems = function ( e, el, name ) {
			clarity( 'set', 'Page element click', name );
			if ( fp.data.vars.debug ) console.log('MS Clarity tag: element click', name);
		};

		if ( fp.clar.tag_elems ) {
			FP.splitTextarea( 'clar', 'tag_elems' );
			FP.registerAction( ['on_click', 'on_middle_click'], 'elem', [tag_elems, fp.clar.tag_elems] );
		};

		// TAG FORM SUBMITS

		var tag_forms = function ( e, title ) {
			var name = title || location.host + location.pathname;
			clarity( 'set', 'Form submit', name );
			if ( fp.data.vars.debug ) console.log('MS Clarity tag: form submit', name);
		};

		if ( fp.clar.tag_forms ) {
			FP.splitTextarea( 'clar', 'tag_forms' );
			FP.registerAction( 'on_form_submit', false, [ tag_forms, fp.clar.tag_forms ] );
		}

		// TRACK VIEWS OF ELEMENTS

		var send_el_view_evt = function ( el ) {
			var name = el.dataset['fp_clar_name'] || 'name not provided';
			clarity( 'set', 'Element view', name );
			if ( fp.data.vars.debug ) console.log('MS Clarity tag: element view', name);
		};

		if ( fp.clar.tag_views ) {
			FP.splitTextarea( 'clar', 'tag_views' );
			var selectors_a = FP.prepareElsForIntersObserver( fp.clar.tag_views, 'fp_clar_name' );

			if ( selectors_a.length > 0 ) {
				var selectors_s = selectors_a.join(',');
				FP.intersectionObserver('clar_views', selectors_s, { rootMargin: '-200px 0px -200px 0px' }, send_el_view_evt, true);
			}
		}

		// TAG CLICKS IN ANCHORS

		var tag_anchor_clicks = function ( e, link ) {
			var href = link.getAttribute('href');
			clarity( 'set', 'Anchor link click', href );
			if ( fp.data.vars.debug ) console.log('MS Clarity tag: anchor click', href);
		};

		if ( fp.clar.tag_anchor_clicks) FP.registerAction( 'on_click', 'anchors', [tag_anchor_clicks] );

		// TAG WITH UTM PARAMETERS

		if ( fp.clar.tag_utm && document.location.href.indexOf( 'utm_source' ) != -1 ) {

			var utm_string = '',
			utm_vals = [ 'utm_source', 'utm_medium', 'utm_campaign', 'utm_term', 'utm_content' ];

			utm_vals.forEach( function (utm_name) {
				var utm_val = FP.getUrlParamByName( utm_name );
				if ( utm_val && utm_val.length > 1 ) utm_string += utm_name + ': ' + decodeURI( utm_val ) + ', ';
			} )

			if ( utm_string.length > 0 ) {
				clarity( 'set', 'UTM Parameters', utm_string );
				if ( fp.data.vars.debug ) console.log('MS Clarity tag: UTM tags', utm_string);
			}
		};

		// TAG PAGEVIEWS WITH ADBLOCK ENABLED

		if ( fp.clar.detect_adblock ) {
			FP.runAdblockTest();
			setTimeout( function () {
				if ( FP.isAdblockEnabled() ) {
					clarity( 'set', 'AdBlock', 'enabled' );
					if ( fp.data.vars.debug ) console.log( 'MS Clarity tag: Adblock enabled' );
				} else {
					clarity( 'set', 'AdBlock', 'not detected' );
					if ( fp.data.vars.debug ) console.log( 'MS Clarity tag: Adblock not detected' );
				}
			}, 1000)
		};

		// MARK AS LOADED
		fp.loaded.push( 'clar-footer' );
	}

	// INIT FOOTER SCRIPTS
	if ( fp.loaded.indexOf('clar') != -1 ) FP.fns.load_clar_footer();

})(window);
