;(function(window){

	FP.fns.load_fbp_footer = function(nr) {

		var _fbp = fp['fbp' + nr];

		// TRACK OUTBOUND LINKS

		var track_outbound = function ( e, link, nr ) {

			var data = {
				'url' : link.href,
				'page' : location.href,
				'time on page' : FP.v.timeOnPage || 0,
			};

			fbq( 'trackSingleCustom', fp['fbp' + nr].pixel_id, 'outbound', data );
			if ( fp.data.vars.debug ) console.log('FB' + nr + ' event: outbound click', data);
		};

		if ( _fbp.track_outbound ) FP.registerAction( ['on_click', 'on_middle_click'], 'outbound', [track_outbound, nr] );

		// TRACK CLICKS ON EMAIL & TEL LINKS

		var track_email_tel = function ( e, return_val, nr ) {

			var data = {
				'target' : return_val[0].href,
				'type' : return_val[1],
				'page' : location.href,
				'time on page' : FP.v.timeOnPage || 0,
			};

			fbq( 'trackSingle', fp['fbp' + nr].pixel_id, 'Contact', data );
			if ( fp.data.vars.debug ) console.log('FB' + nr + ' event: contact click', data);
		};
		if ( _fbp.track_email_tel ) FP.registerAction( ['on_click', 'on_middle_click'], 'email_tel', [track_email_tel, nr] );

		// TRACK AFFILIATE LINKS

		var track_affiliate_links = function ( e, link, name, nr ) {

			var data = {
				'target' : name,
				'page' : location.href,
				'time on page' : FP.v.timeOnPage || 0,
			};

			fbq( 'trackSingleCustom', fp['fbp' + nr].pixel_id, 'affiliate', data );
			if ( fp.data.vars.debug ) console.log('FB' + nr + ' event: affiliate click', data);
		};

		if ( _fbp.track_affiliate ) {
			FP.splitTextarea( 'fbp' + nr, 'track_affiliate' );
			FP.registerAction( ['on_click', 'on_middle_click'], 'affiliate', [track_affiliate_links, _fbp.track_affiliate, nr] );
		};

		// TRACK FILE DOWNLOADS

		var track_downloads = function ( e, filename, nr ) {

			var data = {
				'file' : filename,
				'page' : location.href,
				'time on page' : FP.v.timeOnPage || 0,
			};

			fbq( 'trackSingleCustom', fp['fbp' + nr].pixel_id, 'file download', data );
			if ( fp.data.vars.debug ) console.log('FB' + nr + ' event: download', data);
		};
		if ( _fbp.track_file_downl ) FP.registerAction( ['on_click', 'on_middle_click'], 'downl', [track_downloads, _fbp.track_file_downl, nr] );

		// TRACK SPECIFIC ELEMENTS

		var track_elems = function ( e, el, name, nr ) {

			var data = {
				'name' : name,
				'page' : location.href,
				'time on page' : FP.v.timeOnPage || 0,
			};

			fbq( 'trackSingleCustom', fp['fbp' + nr].pixel_id, 'click on element', data );
			if ( fp.data.vars.debug ) console.log('FB' + nr + ' event: element click', data);
		};

		if ( _fbp.track_elems ) {
			FP.splitTextarea( 'fbp' + nr, 'track_elems' );
			FP.registerAction( ['on_click', 'on_middle_click'], 'elem', [track_elems, _fbp.track_elems, nr] );
		};

		// TRACK FORMS

		var track_forms = function ( e, title, nr ) {

			var data = {
				'form' : title || location.host + location.pathname,
				'page' : location.href,
				'time on page' : FP.v.timeOnPage || 0,
			};

			fbq( 'trackSingleCustom', 'form submit', data );
			if ( fp.data.vars.debug ) console.log('FB' + nr + ' event: form submit', data);
		};

		if ( _fbp.track_forms ) {
			FP.splitTextarea( 'fbp' + nr, 'track_forms' );
			FP.registerAction( 'on_form_submit', false, [ track_forms, _fbp.track_forms, nr ] );
		}

		// TRACK SCROLLS

		var track_scroll = function ( scroll_point, nr ) {

			var data = {
				'scroll height' : scroll_point,
				'page' : location.href,
				'time on page' : FP.v.timeOnPage || 0,
			};

			fbq( 'trackSingleCustom', fp['fbp' + nr].pixel_id, 'scroll', data );
			if ( fp.data.vars.debug ) console.log('FB' + nr + ' event: scroll', data);
		};

		var hookScrollEvent = function () {
			_fbp.track_scroll = _fbp.track_scroll.split(",").map( function (val) { return val.replace('%','').trim() } );
			var min_scroll = _fbp.track_scroll_min || 200;
			FP.registerAction( 'on_scroll', false, [ track_scroll, _fbp.track_scroll, min_scroll, nr ] );
		}

		if ( _fbp.track_scroll ) {
			if ( _fbp.track_scroll_time ) {
				setTimeout( function () {
					hookScrollEvent();
					window.scrollBy(0, 1); // scroll by 1px to trigger scroll event
					window.scrollBy(0, -1); // scroll back
				 },
				 _fbp.track_scroll_time * 1000 );
		 	} else { hookScrollEvent(); }
		}

		// TRACK VIEWS OF ELEMENTS

		var track_views = function (el, nr ) {

			var data = {
				'el' : el.dataset['fp_fbp_name'],
				'page' : location.href,
				'time on page' : FP.v.timeOnPage || 0,
			};

			fbq( 'trackSingleCustom', fp['fbp' + nr].pixel_id, 'user viewed', data );
			if ( fp.data.vars.debug ) console.log('FB' + nr + ' event: element view', data);
		};

		if ( _fbp.track_views ) {

			FP.splitTextarea( 'fbp' + nr, 'track_views' );
			var selectors_a = FP.prepareElsForIntersObserver( _fbp.track_views, 'fp_fbp_name' );

			if ( selectors_a.length > 0 ) {
				var selectors_s = selectors_a.join(',');
				FP.intersectionObserver( 'fbp_views', selectors_s, { rootMargin: '-200px 0px -200px 0px' }, track_views, true, nr );
			}
		}

		// TRACK USER ENGAGEMENT TIME

		var track_engagement = function (nr) {

			var data = {
				'seconds' : FP.v.timeOnPage,
				'page' : location.href
			};

			fbq( 'trackSingleCustom', fp['fbp' + nr].pixel_id, 'user engagement time', data );
			if ( fp.data.vars.debug ) console.log('FB' + nr + ' event: engagement time', data);
		};

		if ( _fbp.track_engagement ) FP.registerAction( 'on_close', false, [track_engagement, nr] );

		// MARK AS LOADED
		fp.loaded.push( 'fbp-footer' );
	}

	// INIT FOOTER SCRIPTS
	if ( fp.loaded.indexOf('fbp1') != -1 ) FP.fns.load_fbp_footer(1);
	if ( fp.loaded.indexOf('fbp2') != -1 ) FP.fns.load_fbp_footer(2);

} )(window);
