;(function(window){

	function send_virtual_pageview(nr) {
		setTimeout( function () {
			var page_path = { 'page_path' : location.pathname + location.search + location.hash };
			gtag( 'config', fp['ga' + nr].tracking_id, page_path );
		}, 30);
	}

	FP.fns.load_ga_footer = function(nr) {

		var _ga = fp['ga' + nr];

		// TRACK ANCHOR LINKS

		var send_anchor_click_evt = function ( e, link, nr ) {
			if ( fp['ga' + nr].track_anchor_clicks == 'pageview' ) {
				send_virtual_pageview(nr);
			} else {

				var data = {
					'event_category': 'anchors',
					'event_label': link.getAttribute('href'),
					'send_to': fp['ga' + nr].tracking_id,
					'non_interaction': fp['ga' + nr].track_anchor_clicks == 'nonint_evt'
				};

				gtag( 'event', 'anchor click', data);
				if ( fp.data.vars.debug ) console.log('GA' + nr + ' event: anchor click', data);
			}
		}

		if ( _ga.track_anchor_clicks) FP.registerAction( 'on_click', 'anchors', [send_anchor_click_evt, nr] );

		// TRACK DYNAMIC URL CHANGES (history.state != null)

		var send_url_change_evt = function (e, nr ) {
			if ( fp['ga' + nr].track_dynamic_urls == 'pageview' ) {
				send_virtual_pageview(nr);
			} else {

				var data = {
					'event_category': 'dynamic content load',
					'event_label': location.host + location.pathname,
					'send_to': fp['ga' + nr].tracking_id,
					'non_interaction' : fp['ga' + nr].track_dynamic_urls == 'nonint_evt',
				};

				gtag( 'event', 'dynamic url change', data);
				if ( fp.data.vars.debug ) console.log('GA' + nr + ' event: URL change', data);
			}
		};

		if ( _ga.track_dynamic_urls ) FP.registerAction( 'on_url_state', false, [send_url_change_evt, nr] );

		// TRACK SCROLL

		var send_scroll_evt = function ( scroll_point, nr ) {

			var data = {
				'event_category': 'scrolled',
				'event_label': scroll_point,
				'send_to': fp['ga' + nr].tracking_id,
				'non_interaction' : !fp['ga' + nr].track_scroll_intr,
			};

			gtag( 'event', 'scroll', data);
			if ( fp.data.vars.debug ) console.log('GA' + nr + ' event: scroll', data);
		}

		var hookScrollEvent = function () {
			_ga.track_scroll = _ga.track_scroll.split(",").map( function (val) { return val.replace('%','').trim(); } );
			var min_scroll = _ga.track_scroll_min || 200;
			FP.registerAction( 'on_scroll', false, [ send_scroll_evt, _ga.track_scroll, min_scroll, nr ] );
		}

		if ( _ga.track_scroll ) {
			if ( _ga.track_scroll_time ) {
				setTimeout( function () {
					hookScrollEvent();
					window.scrollBy(0, 1); // scroll by 1px to trigger scroll event
					window.scrollBy(0, -1); // scroll back
				 },
				 _ga.track_scroll_time * 1000 );
		 	} else { hookScrollEvent(); }
		}

		// TRACK VIEWS OF ELEMENTS

		var send_el_view_evt = function ( el, nr ) {

			var data = {
				'event_category': 'viewed',
				'event_label': el.dataset['fp_ga' + nr + '_name'],
				'send_to': fp['ga' + nr].tracking_id,
				'non_interaction' : !fp['ga' + nr].track_views_intr,
			};

			gtag( 'event', 'element view', data);
			if ( fp.data.vars.debug ) console.log('GA' + nr + ' event: element view', data);
		};

		if ( _ga.track_views ) {
			FP.splitTextarea( 'ga' + nr, 'track_views' );
			var selectors_a = FP.prepareElsForIntersObserver( _ga.track_views, 'fp_ga' + nr + '_name' );

			if ( selectors_a.length > 0 ) {
				var selectors_s = selectors_a.join(',');
				FP.intersectionObserver('ga_views', selectors_s, { rootMargin: '-200px 0px -200px 0px' }, send_el_view_evt, true, nr);
			}
		}

		// TRACK ENGAGEMENT

		var send_engagement_time = function (nr) {

			var data = {
				'send_to': fp['ga' + nr].tracking_id,
				'non_interaction' : true,
			};
			data['Engagement time ' + nr] = FP.v.timeOnPage;

			gtag( 'event', 'engagement time', data);
			if ( fp.data.vars.debug ) console.log('GA' + nr + ' event: engagement time', data);
		}

		var send_eng_time_after_anchor = function ( e, link, nr ) { send_engagement_time(nr); }

		if ( _ga.track_engagement ) {
			FP.registerAction( 'on_close', false, [send_engagement_time , nr] );
			if ( _ga.track_anchor_clicks && _ga.track_anchor_clicks == 'pageview' ) {
				// track how long the anchored page was viewed for
				FP.registerAction( 'on_click', 'anchors', [send_eng_time_after_anchor, nr] );
			}
		}

		// DETECT ADBLOCK

		if ( _ga.detect_adblock ) {
			if ( ! _ga.adblock_session || ( _ga.adblock_session && fp.data.vars.new_session ) ) {
				FP.runAdblockTest();

				setTimeout( function() {
					if ( FP.isAdblockEnabled() ) {
						var data = {'non_interaction' : true};
						data['Adblock ' + nr] = 'detected';

						gtag( 'event', 'adblock detected', data );
						if ( fp.data.vars.debug ) console.log('GA' + nr + ' event: adblock detected', data);
					}
				}, 1000)
			}
		};

		// TRACK AFFILIATE LINKS

		var send_affiliate_click_evt = function ( e, link, name, nr ) {

			var data = {
				'event_category': 'affiliate',
				'event_label': name,
				'send_to': fp['ga' + nr].tracking_id,
				'non_interaction' : !fp['ga' + nr].track_affil_intr,
			};

			gtag( 'event', 'affiliate link click', data);
			if ( fp.data.vars.debug ) console.log('GA' + nr + ' event: affiliate click', data);
		};

		if ( _ga.track_affiliate ) {
			FP.splitTextarea( 'ga' + nr, 'track_affiliate' );
			FP.registerAction( ['on_click', 'on_middle_click'], 'affiliate', [send_affiliate_click_evt, _ga.track_affiliate, nr ] );
		}

		// TRACK OUTBOUND LINKS

		var send_outbound_click_evt = function ( e, link, nr ) {

			var data = {
				'event_category': 'outbound',
				'event_label': link.href,
				'send_to': fp['ga' + nr].tracking_id,
				'non_interaction' : true,
			};

			gtag( 'event', 'outbound link click', data );
			if ( fp.data.vars.debug ) console.log('GA' + nr + ' event: outbound click', data);
		};

		if ( _ga.track_outbound ) FP.registerAction( ['on_click', 'on_middle_click'], 'outbound', [send_outbound_click_evt, nr] );

		// TRACK CLICKS ON EMAIL AND TEL LINKS

		var send_contact_click_evt = function ( e, return_val, nr ) {

			var data = {
				'event_category': 'contact',
				'event_label': return_val[0].href,
				'send_to': fp['ga' + nr].tracking_id,
				'non_interaction' : !fp['ga' + nr].track_email_tel_intr,
			};

			gtag( 'event', return_val[1] + ' link click', data );
			if ( fp.data.vars.debug ) console.log('GA' + nr + ' event: contact click', data);
		};

		if ( _ga.track_email_tel ) FP.registerAction( ['on_click', 'on_middle_click'], 'email_tel', [send_contact_click_evt, nr] );

		// TRACK FILE DOWNLOADS

		var send_download_evt = function ( e, filename, nr ) {

			var data = {
				'event_category': 'file download',
				'event_label': filename,
				'send_to': fp['ga' + nr].tracking_id,
				'non_interaction' : !fp['ga' + nr].track_downl_intr,
			};

			gtag( 'event', 'file download link click', data);
			if ( fp.data.vars.debug ) console.log('GA' + nr + ' event: download', data);
		};

		if ( _ga.track_file_downl ) FP.registerAction( ['on_click', 'on_middle_click'], 'downl', [send_download_evt, _ga.track_file_downl, nr] );

		// TRACK CLICKS ON PAGE ELEMENTS

		var send_click_elem_evt = function ( e, el, el_name, nr ) {

			var data = {
				'event_category': 'clicks on elements',
				'event_label': el_name,
				'send_to': fp['ga' + nr].tracking_id,
				'non_interaction' : !fp['ga' + nr].track_elems_intr,
			};

			gtag( 'event', 'click', data);
			if ( fp.data.vars.debug ) console.log('GA' + nr + ' event: element click', data);
		};

		if ( _ga.track_elems ) {
			FP.splitTextarea( 'ga' + nr, 'track_elems' );
			FP.registerAction( ['on_click', 'on_middle_click'], 'elem', [send_click_elem_evt, _ga.track_elems, nr] );
		}

		// TRACK FORM SUBMITS

		var send_form_subm_evt = function ( e, title, nr ) {
			var data = {
				'event_category': 'forms',
				'event_label': title || location.host + location.pathname,
				'send_to': fp['ga' + nr].tracking_id,
				'non_interaction' : !fp['ga' + nr].track_formsubm_intr,
			};

			gtag( 'event', 'form submit', data);
			if ( fp.data.vars.debug ) console.log('GA' + nr + ' event: form submit', data);
		};

		if ( _ga.track_forms ) {
			FP.splitTextarea( 'ga' + nr, 'track_forms' );
			FP.registerAction( 'on_form_submit', false, [ send_form_subm_evt, _ga.track_forms, nr] );
		}

		// MARK AS LOADED
		fp.loaded.push( 'ga-footer' );
	}

	// INIT FOOTER SCRIPTS

	if ( fp.loaded.indexOf('ga1') != -1 ) FP.fns.load_ga_footer(1);
	if ( fp.loaded.indexOf('ga2') != -1 ) FP.fns.load_ga_footer(2);

})(window);
