;(function(window){

	

	FP.load_ga = function (nr) {

		var _ga = fp[ 'ga' + nr ];

		params = {};

		// force transport by beacon everywhere except IE
		if ( typeof navigator.sendBeacon == 'function ') params = {'transport_type': 'beacon'};

		if ( nr == '1' ) {

			// CHANGE COOKIE PREFIX
			if ( _ga.cookie_prefix ) params.cookie_prefix = '_fp' + nr;

			// LOAD GOOGLE OPTIMIZE
			// https://support.google.com/optimize/answer/9183119?hl=en
			if ( fp.gopt && fp.gopt.container_id && fp.gopt.main_load_method == 'gtag') params.optimize_id = fp.gopt.container_id;
		}

		

		// SET "USER ID" (ENCODED)
		if ( _ga.set_user_id && fp.data.wp.user_id ) {
			params.user_id = window.btoa(fp.data.wp.user_id).split('=').join('');
		}

		// SEND CLEAN "PAGE TITLE"
		if ( _ga.clean_page_title && fp.data.wp.page_title && fp.data.wp.page_title.length > 0 ) {
			params.page_title = fp.data.wp.page_title;

			// "SEO TITLE" CUSTOM DIMENSION
			if ( _ga.seo_title_dimens ) {
				params['dimension' + _ga.seo_title_dimens] = document.title;
			}
		}

		// "PAGE LANGUAGE" CUSTOM DIMENSION
		if ( _ga.page_lang_dimens ) {
			params['dimension' + _ga.page_lang_dimens] = document.documentElement.lang || 'undefined';
		}

		// "USER ROLE" CUSTOM DIMENSION
		if ( _ga.user_role_dimens ) {
			if ( fp.data.wp.user_role && fp.data.wp.user_role.length > 0 ) {
				params['dimension' + _ga.user_role_dimens] = fp.data.wp.user_role;
			}
		}

		// ANCHORS IN URL
		if ( _ga.track_anchor_pageviews ) {
			var page_path = location.pathname + location.search + location.hash;
			params.page_path = page_path;
		}

		// USER ENGAGEMENT
		if ( _ga.track_engagement )  {
			params.custom_map = params.custom_map || {};
			params.custom_map['metric' + _ga.track_engagement] = 'Engagement time ' + nr;
		}

		// ADBLOCK TRACKING
		if ( _ga.detect_adblock )  {
			params.custom_map = params.custom_map || {};
			params.custom_map['dimension' + _ga.detect_adblock] = 'Adblock ' + nr;
		}

		// Anonymize IPs
		if ( _ga.anonimize ) params.anonymize_ip = true;

		// "PAGE TYPE" CONTENT GROUPING
		if ( _ga.page_type_grouping && fp.data.wp.page_type && fp.data.wp.page_type.length > 1 ) {
			params['content_group' + _ga.page_type_grouping] = fp.data.wp.page_type;
		}

		// "PAGE ID" CUSTOM DIMENSION
		if ( _ga.page_id_dimens && fp.data.wp.page_id && fp.data.wp.page_id > 0 ) {
			params['dimension' + _ga.page_id_dimens] = '' + fp.data.wp.page_id;
		}

		// "PAGE NUMBER" CUSTOM DIMENSION
		if ( _ga.page_number_dimens && fp.data.wp.page_number > 0 ) {
			params['dimension' + _ga.page_number_dimens] = '' + fp.data.wp.page_number;
		}

		// "AUTHOR DISPLAY NAME" CUSTOM DIMENSION
		if ( _ga.author_dimens && fp.data.wp.author_name && fp.data.wp.author_name.length > 0 ) {
			params['dimension' + _ga.author_dimens] = fp.data.wp.author_name;
		}

		// "AUTHOR ID" CUSTOM DIMENSION
		if ( _ga.author_id_dimens && fp.data.wp.author_id > 0 ) {
			params['dimension' + _ga.author_id_dimens] = '' + fp.data.wp.author_id;
		}

		// "PUBLISHED DATE" CUSTOM DIMENSION
		if ( _ga.post_date_dimens && fp.data.wp.published && fp.data.wp.published.length > 0 ) {
			params['dimension' + _ga.post_date_dimens] = fp.data.wp.published;
		}

		// "TAXONOMY TERMS" CUSTOM DIMENSION
		if ( _ga.tax_terms_dimens && fp.data.wp.terms && fp.data.wp.terms.length > 0 ) {

			var term_arr = fp.data.wp.terms.map( function (term_data) {
				var term = _ga.send_tax_terms_titles ? term_data.name : term_data.slug;
				term += _ga.add_tax_term_cat ? ' (' + term_data.taxonomy + ')' : '';
				return term;
			} );

			params['dimension' + _ga.tax_terms_dimens] = term_arr.join(', ');
		}

		// "SEARCH RESULTS" CUSTOM METRIC
		if ( _ga.search_results_metr && _ga.search_results_metr.length > 0 && fp.data.wp.search_results && fp.data.wp.search_results > 0 ) {
			params['metric' + _ga.search_results_metr] = parseInt(fp.data.wp.search_results);
		}

		window.gtag('config', _ga.tracking_id, params);

		


		// MARK GA AS LOADED
		fp.loaded.push('ga' + nr);

		// TRACK JS ERRORS
		// THX: https://medium.com/@Esakkimuthu/track-javascript-errors-and-how-to-fix-the-errors-60e160851296
		if ( _ga.js_err_dimens ) {
			window.onerror = function( msg, src, lineno, colno, err) {
				var err_details = err ? err.stack : ('Script: '+ src + ', Line:'+ lineno + ', Column: '+ colno ),
					data = {
						'event_category': 'JS errors',
						'event_action': msg,
						'event_label': err_details,
						'send_to': fp['ga' + nr].tracking_id,
						'non_interaction' : true
					};

				gtag('event', 'js error', data);
				if ( fp.data.vars.debug ) console.log('GA' + nr + ' event: JS error', data);
			}
		}

		// LOAD FOOTER
		if ( FP.fns.load_ga_footer ) FP.fns.load_ga_footer(nr);
	};

})(window);
