;(function(window){

	FP.fns.load_ga4_footer = function(nr) {

		var _ga = fp['ga4' + nr];

		// TRACK SCROLL

		var send_scroll_evt = function ( scroll_point, nr ) {

			var data = {
				'percent_scrolled': scroll_point,
				'send_to': fp['ga4' + nr].id,
			};

			gtag( 'event', 'scroll', data);
			if ( fp.data.vars.debug ) console.log('GA4 #' + nr + ' event: scroll', data);
		}

		var hookScrollEvent = function () {
			_ga.track_scroll = _ga.track_scroll.split(",").map( function (val) { return val.replace('%','').trim(); } );
			var min_scroll = _ga.track_scroll_min || 200;
			FP.registerAction( 'on_scroll', false, [ send_scroll_evt, _ga.track_scroll, min_scroll, nr ] );
		}

		if ( _ga.track_scroll ) {
			if ( _ga.track_scroll_time ) {
				setTimeout( function () {
					hookScrollEvent();
					window.scrollBy(0, 1); // scroll by 1px to trigger scroll event
					window.scrollBy(0, -1); // scroll back
				 },
				 _ga.track_scroll_time * 1000 );
		 	} else { hookScrollEvent(); }
		}

		// TRACK VIEWS OF ELEMENTS

		var send_el_view_evt = function ( el, nr ) {

			var data = {
				'viewed_element': el.dataset['fp_ga' + nr + '_name'],
				'send_to': fp['ga4' + nr].id,
			};

			gtag( 'event', 'element_view', data);
			if ( fp.data.vars.debug ) console.log('GA4 #' + nr + ' event: element_view', data);
		};

		if ( _ga.track_views ) {
			FP.splitTextarea( 'ga4' + nr, 'track_views' );
			var selectors_a = FP.prepareElsForIntersObserver( _ga.track_views, 'fp_ga' + nr + '_name' );

			if ( selectors_a.length > 0 ) {
				var selectors_s = selectors_a.join(',');
				FP.intersectionObserver('ga4_views', selectors_s, { rootMargin: '-200px 0px -200px 0px' }, send_el_view_evt, true, nr);
			}
		}

		// TRACK ENGAGEMENT

		var send_engagement_time = function (nr) {

			var data = {
				'send_to': fp['ga4' + nr].id,
				'user_engagement_time' : FP.v.timeOnPage,
			};

			gtag( 'event', 'user_engagement_time', data);
			if ( fp.data.vars.debug ) console.log('GA4 #' + nr + ' event: user_engagement_time', data);
		}

		if ( _ga.track_engagement ) {
			FP.registerAction( 'on_close', false, [send_engagement_time , nr] );
		}

		// DETECT ADBLOCK

		if ( _ga.detect_adblock ) {

			FP.runAdblockTest();

			setTimeout( function() {
				if ( FP.isAdblockEnabled() ) {
					var data = {
						'adblock' : 'detected',
						'send_to': fp['ga4' + nr].id,
					};

					gtag( 'event', 'adblock_detected', data );
					if ( fp.data.vars.debug ) console.log('GA4 #' + nr + ' event: adblock_detected', data);
				}
			}, 1000)
		};

		// TRACK AFFILIATE LINKS

		var send_affiliate_click_evt = function ( e, link, name, nr ) {

			var data = {
				'affiliate_link_click': name,
				'send_to': fp['ga4' + nr].id,
			};

			gtag( 'event', 'affiliate_link_click', data);
			if ( fp.data.vars.debug ) console.log('GA4 #' + nr + ' event: affiliate_link_click', data);
		};

		if ( _ga.track_affiliate ) {
			FP.splitTextarea( 'ga4' + nr, 'track_affiliate' );
			FP.registerAction( ['on_click', 'on_middle_click'], 'affiliate', [send_affiliate_click_evt, _ga.track_affiliate, nr ] );
		}

		// TRACK CLICKS ON EMAIL AND TEL LINKS

		var send_contact_click_evt = function ( e, return_val, nr ) {

			var data = {
				'contact_click': return_val[0].href,
				'send_to': fp['ga4' + nr].id,
			};

			gtag( 'event', return_val[1] + '_link click', data );
			if ( fp.data.vars.debug ) console.log('GA4 #' + nr + ' event: contact_click', data);
		};

		if ( _ga.track_email_tel ) FP.registerAction( ['on_click', 'on_middle_click'], 'email_tel', [send_contact_click_evt, nr] );

		// TRACK FILE DOWNLOADS

		var send_download_evt = function ( e, filename, nr ) {

			var data = {
				'file_name': filename,
				'send_to': fp['ga4' + nr].id,
			};

			gtag( 'event', 'file_download', data);
			if ( fp.data.vars.debug ) console.log('GA4 #' + nr + ' event: file_download', data);
		};

		if ( _ga.track_file_downl ) FP.registerAction( ['on_click', 'on_middle_click'], 'downl', [send_download_evt, _ga.track_file_downl, nr] );

		// TRACK CLICKS ON PAGE ELEMENTS

		var send_click_elem_evt = function ( e, el, el_name, nr ) {

			var data = {
				'element_click': el_name,
				'send_to': fp['ga4' + nr].id,
			};

			gtag( 'event', 'element_click', data);
			if ( fp.data.vars.debug ) console.log('GA4 #' + nr + ' event: element_click', data);
		};

		if ( _ga.track_elems ) {
			FP.splitTextarea( 'ga4' + nr, 'track_elems' );
			FP.registerAction( ['on_click', 'on_middle_click'], 'elem', [send_click_elem_evt, _ga.track_elems, nr] );
		}

		// TRACK FORM SUBMITS

		var send_form_subm_evt = function ( e, title, nr ) {
			var data = {
				'submitted_form': title || location.host + location.pathname,
				'send_to': fp['ga4' + nr].id,
			};

			gtag( 'event', 'form_submit', data);
			if ( fp.data.vars.debug ) console.log('GA4 #' + nr + ' event: form_submit', data);
		};

		if ( _ga.track_forms ) {
			FP.splitTextarea( 'ga4' + nr, 'track_forms' );
			FP.registerAction( 'on_form_submit', false, [ send_form_subm_evt, _ga.track_forms, nr] );
		}

		// MARK AS LOADED

		fp.loaded.push( 'ga4-footer' );
	}

	if ( fp.loaded.indexOf('ga41') != -1 ) FP.fns.load_ga4_footer(1);
	if ( fp.loaded.indexOf('ga42') != -1 ) FP.fns.load_ga4_footer(2);

})(window);
