;(function(window){

	FP.load_ga4 = function (nr) {

		var _ga = fp[ 'ga4' + nr ],
			params = {};

		// CHANGE COOKIE PREFIX
		// optional for the tracking ID #1
		if ( _ga.cookie_prefix && nr == '1' ) params.cookie_prefix = '_fp4' + nr;

		

		// SET "USER ID" (ENCODED)
		if ( _ga.set_user_id && fp.data.wp.user_id ) {
			params.user_id = window.btoa(fp.data.wp.user_id).split('=').join('');
		}

		// enable GA's debug mode
		// @ https://support.google.com/analytics/answer/7201382?hl=en
		if ( _ga.debug_ga ) params.debug_mode = true;

		// SEND CLEAN "PAGE TITLE"
		if ( _ga.clean_page_title && fp.data.wp.page_title && fp.data.wp.page_title.length > 0 ) {
			params.page_title = fp.data.wp.page_title;

			// "SEO TITLE" CUSTOM DIMENSION
			if ( _ga.seo_title ) {
				params.seo_title = document.title;
			}
		}

		// "PAGE LANGUAGE" CUSTOM DIMENSION
		if ( _ga.page_lang ) {
			params['page_lang'] = document.documentElement.lang || 'undefined';
		}

		// "USER ROLE" USER PROPERTY
		if ( _ga.user_role ) {
			if ( fp.data.wp.user_role && fp.data.wp.user_role.length > 0 ) {
				params['user_role'] = fp.data.wp.user_role;
			}
		}

		// // ADBLOCK TRACKING
		if ( _ga.detect_adblock )  {
			params.custom_map = params.custom_map || {};
			params.custom_map['adblock'] = 'adblock';
		}

		// "PAGE TYPE" CONTENT GROUPING
		if ( _ga.page_type && fp.data.wp.page_type && fp.data.wp.page_type.length > 1 ) {
			params['page_type'] = fp.data.wp.page_type;
		}

		// "PAGE ID" CUSTOM DIMENSION
		if ( _ga.page_id && fp.data.wp.page_id && fp.data.wp.page_id > 0 ) {
			params['page_id'] = '' + fp.data.wp.page_id;
		}

		// "PAGE NUMBER" CUSTOM DIMENSION
		if ( _ga.page_number && fp.data.wp.page_number > 0 ) {
			params['page_number'] = '' + fp.data.wp.page_number;
		}

		// "AUTHOR DISPLAY NAME" CUSTOM DIMENSION
		if ( _ga.post_author && fp.data.wp.author_name && fp.data.wp.author_name.length > 0 ) {
			params['post_author'] = fp.data.wp.author_name;
		}

		// "AUTHOR ID" CUSTOM DIMENSION
		if ( _ga.author_id && fp.data.wp.author_id > 0 ) {
			params['author_id'] = '' + fp.data.wp.author_id;
		}

		// "PUBLISHED DATE" CUSTOM DIMENSION
		if ( _ga.post_date && fp.data.wp.published && fp.data.wp.published.length > 0 ) {
			params['post_date'] = fp.data.wp.published;
		}

		// "TAXONOMY TERMS" CUSTOM DIMENSION
		if ( _ga.tax_terms && fp.data.wp.terms && fp.data.wp.terms.length > 0 ) {

			var term_arr = fp.data.wp.terms.map( function (term_data) {
				var term = _ga.send_tax_terms_titles ? term_data.name : term_data.slug;
				term += _ga.add_tax_term_cat ? ' (' + term_data.taxonomy + ')' : '';
				return term;
			} );

			params['taxonomy_terms'] = term_arr.join(', ');
		}

		// "SEARCH RESULTS" CUSTOM METRIC

		if ( _ga.search_results_nr && _ga.search_results_nr.length > 0 && fp.data.wp.search_results && fp.data.wp.search_results > 0 ) {
			params['search_results_nr'] = parseInt(fp.data.wp.search_results);
		}

		window.gtag( 'config', _ga.id, params );

		// TRACK JS ERRORS
		// THX: https://medium.com/@Esakkimuthu/track-javascript-errors-and-how-to-fix-the-errors-60e160851296
		if ( _ga.js_err_dimens ) {
			window.onerror = function( msg, src, lineno, colno, err) {
				var err_details = err ? err.stack : ('Script: '+ src + ', Line: '+ lineno + ', Column: '+ colno ),
					err_txt = err_details.length > 100 ? err_details.substring(0,99) : err_details,
					data = {
						'js_error_details': err_txt,
						'send_to': fp['ga4' + nr].id,
					};

				gtag('event', 'js error', data);
				if ( fp.data.vars.debug ) console.log('GA4' + nr + ' event: JS error', data);
			}
		}

		fp.loaded.push('ga4' + nr);
		if( FP.fns.load_ga4_footer ) FP.fns.load_ga4_footer(nr);

		

	};

})(window);
