;(function(window){

	function can_enable_ga() 	{ return FP.isAllowedToLoad( 'ga', ['stats'], ['tracking_id'], 1 ); }
	function can_enable_ga4() 	{ return FP.isAllowedToLoad( 'ga4', ['stats'], ['id'], 1 ); }
	function can_enable_gads() 	{ return FP.isAllowedToLoad( 'gads', ['stats','marketing'], ['id'] ); }

	load_gtag( can_enable_ga(), can_enable_ga4(), can_enable_gads() );

	// Load on event
	document.addEventListener('fp_load_scripts', function (e) {
		switch (e.detail[0]) {
			case 'all':
			case 'gads':
			case 'ga41':
			case 'ga1':
				load_gtag( can_enable_ga(), can_enable_ga4(), can_enable_gads() );
			break;
		}
	});

	function load_gtag( enable_ga, enable_ga4, enable_gads ) {

		let script_id = enable_ga ? fp.ga1.tracking_id :
						enable_ga4 ? fp.ga41.id :
						enable_gads ? fp.gads.id :
						false;

		if ( script_id ) {

			window.dataLayer = window.dataLayer || [];
			window.gtag = function(){window.dataLayer.push(arguments);}

			FP.getScript(
				'https://www.googletagmanager.com/gtag/js?id=' + script_id,
				function () { enable_tags( enable_ga, enable_ga4, enable_gads ) } ,
				{'async' : 'async'}
			);
		}
	}

	function enable_tags( enable_ga, enable_ga4, enable_gads ){

		window.gtag('js', new Date());

		if ( enable_ga4 || enable_ga ) {

			var set_params = {};

			if ( fp.cookies && ! fp.cookies.marketing ) set_params['allow_google_signals'] = false;
			if ( fp.cookies && ! fp.cookies.personalisation ) set_params['allow_ad_personalization_signals'] = false;

			window.gtag( 'set', set_params );
		}

		if ( enable_ga4 ) {
			FP.load_ga4(1);
			
		}

		if ( enable_ga ) {
			FP.load_ga(1);
			
		};

		
	}

})(window);
