;(function(window){

	FP.fns.load_gtm_footer = function(){

		// TRACK OUTBOUND LINKS

		var track_outbound = function ( e, link ) {
			window[fp.gtm.datalayer].push( {
				'event' : 'outbound link click',
				'outbound url' : link.href,
				'time on page' : FP.v.timeOnPage || 0,
			} )
		};
		if ( fp.gtm.track_outbound ) FP.registerAction( ['on_click', 'on_middle_click'], 'outbound', [track_outbound] );

		// TRACK AFFILIATE LINKS

		var track_affiliate_links = function ( e, link, name ) {
			window[fp.gtm.datalayer].push( {
				'event' : 'affiliate link click',
				'affiliate link' : name,
				'time on page' : FP.v.timeOnPage || 0,
			} ) };

		if ( fp.gtm.track_affiliate ) {
			FP.splitTextarea( 'gtm', 'track_affiliate' );
			FP.registerAction( ['on_click', 'on_middle_click'], 'affiliate', [track_affiliate_links, fp.gtm.track_affiliate] );
		};

		// TRACK CLICKS ON EMAIL & TEL LINKS

		var track_email_tel = function ( e, return_val ) {
			window[fp.gtm.datalayer].push( {
				'event' : 'contact link click',
				'contact link' :  return_val[0].href,
				'contact link type' : return_val[1] + ' click',
				'time on page' : FP.v.timeOnPage || 0,
			} )
		};
		if ( fp.gtm.track_email_tel ) FP.registerAction( ['on_click', 'on_middle_click'], 'email_tel', [track_email_tel] );

		// TRACK FILE DOWNLOADS

		var track_downloads = function ( e, filename ) {
			window[fp.gtm.datalayer].push( {
				'event' : 'file download',
				'downloaded file' : filename,
				'time on page' : FP.v.timeOnPage || 0,
			} )
		};
		if ( fp.gtm.track_file_downl ) FP.registerAction( ['on_click', 'on_middle_click'], 'downl', [track_downloads, fp.gtm.track_file_downl] );

		// TRACK CLICKS IN ANCHORS

		var track_anchor_clicks = function ( e, link ) {
			window[fp.gtm.datalayer].push( {
				'event' : 'anchor click',
				'clicked anchor' :  link.getAttribute('href'),
				'time on page' : FP.v.timeOnPage || 0,
			} )
		};
		if ( fp.gtm.track_anchor_clicks) FP.registerAction( 'on_click', 'anchors', [track_anchor_clicks] );

		// TRACK SCROLLS

		var track_scroll = function ( scroll_point ) {
			window[fp.gtm.datalayer].push( {
				'event' : 'scroll',
				'scroll depth' : scroll_point,
				'time on page' : FP.v.timeOnPage || 0,
			} )
		};

		var hookScrollEvent = function () {
			fp.gtm.track_scroll = fp.gtm.track_scroll.split(",").map( function (val) { return val.replace('%','').trim(); } );
			var min_scroll = fp.gtm.track_scroll_min || 200;
			FP.registerAction( 'on_scroll', false, [ track_scroll, fp.gtm.track_scroll, min_scroll ] );
		}

		if ( fp.gtm.track_scroll ) {
			if ( fp.gtm.track_scroll_time ) {
				setTimeout( function () {
					hookScrollEvent();
					window.scrollBy(0, 1); // scroll by 1px to trigger scroll event
					window.scrollBy(0, -1); // scroll back
				 },
				 fp.gtm.track_scroll_time * 1000 );
		 	} else { hookScrollEvent(); }
		}

		// TRACK VIEWS OF ELEMENTS

		var track_views = function ( el ) {
			window[fp.gtm.datalayer].push( {
				'event' : 'element view',
				'viewed element' : el.dataset['fp_gtm_name'],
			 	'time on page' : FP.v.timeOnPage || 0,
			} )
		};

		if ( fp.gtm.track_views ) {

			FP.splitTextarea( 'gtm', 'track_views' );
			var selectors_a = FP.prepareElsForIntersObserver( fp.gtm.track_views, 'fp_gtm_name' );

			if ( selectors_a.length > 0 ) {
				var selectors_s = selectors_a.join(',');
				FP.intersectionObserver('fp_gtm_views', selectors_s, { rootMargin: '-200px 0px -200px 0px' }, track_views, true );
			}
		}

		// TRACK USER ENGAGEMENT TIME

		var track_engagement = function () {
			window[fp.gtm.datalayer].push( {
				'event' : 'user engagement time',
				'final engagement time' : FP.v.timeOnPage || 0,
			} )
		};

		if ( fp.gtm.track_engagement ) FP.registerAction( 'on_close', false, [track_engagement] );

		// TRACK DYNAMIC URL CHANGES (history.state != null)

		var track_url_changes = function (e) {
			window[fp.gtm.datalayer].push( {
				'event' : 'virtual pageview',
				'virtual pageview url' : location.host + location.pathname,
			 	'time on page' : FP.v.timeOnPage || 0,
			} )
		};

		if ( fp.gtm.track_dynamic_urls ) FP.registerAction( 'on_url_state', false, [track_url_changes] );

		// DETECT ADBLOCK (PREMIUM)

		if ( fp.gtm.detect_adblock ) {

			FP.runAdblockTest();

			setTimeout( function() {
				if ( FP.isAdblockEnabled() ) {
					window[fp.gtm.datalayer].push( {
						'event' : 'adblock detection',
						'adblock detected' : true,
					} );
				} else {
					window[fp.gtm.datalayer].push( {
						'event' : 'adblock detection',
						'adblock detected' : false,
					} );
				}
			}, 1000)
		};

		// TRACK SPECIFIC ELEMENTS

		var track_elems = function ( e, el, name ) {
			window[fp.gtm.datalayer].push( {
				'event' : 'element click',
				'clicked element' : name,
				'time on page' : FP.v.timeOnPage || 0,
			} )
		};

		if ( fp.gtm.track_elems ) {
			FP.splitTextarea( 'gtm', 'track_elems' );
			FP.registerAction( ['on_click', 'on_middle_click'], 'elem', [track_elems, fp.gtm.track_elems] );
		};

		// TRACK FORMS

		var track_forms = function ( e, title ) {
			var name = title || location.host + location.pathname;
			window[fp.gtm.datalayer].push( {
				'event' : 'form submit',
				'submitted form' : name,
				'time on page' : FP.v.timeOnPage || 0,
			} );
		};

		if ( fp.gtm.track_forms ) {
			FP.splitTextarea( 'gtm', 'track_forms' );
			FP.registerAction( 'on_form_submit', false, [ track_forms, fp.gtm.track_forms ] );
		}

		// TRACK CLICKS IN COOKIE NOTICE BUTTONS

		var track_cookie_notice_clicks = function ( e, el, name ) {
			window[fp.gtm.datalayer].push( {
				'event' : 'cookie notice button click',
				'clicked cookie notice button' : name,
				'time on page' : FP.v.timeOnPage || 0,
			} );
		}

		if ( fp.gtm.pass_cookies ) {
			var cookie_btns = [
				['#fp_agree_to_all_cookies_btn', 'agreed to all'],
				['#fp_agree_to_selected_cookies_btn', 'agreed to some'],
				['#fp_decline_cookies_btn', 'declined']
			];
			FP.registerAction( 'on_click', 'elem', [track_cookie_notice_clicks, cookie_btns] );
		}

		// TRACK WHEN THE TAB IS IN FOCUS AND LOOSES FOCUS

		if ( fp.gtm.track_focus ) {

			document.addEventListener('visibilitychange', function () {
		        if ( document.hidden ) {

					window[fp.gtm.datalayer].push( {
						'event' : 'window visibility change',
						'window visibility state' : 'not in focus',
						'time on page' : FP.v.timeOnPage || 0,
					} );

		        } else {

					window[fp.gtm.datalayer].push( {
						'event' : 'window visibility change',
						'window visibility state' : 'in focus',
						'time on page' : FP.v.timeOnPage || 0,
					} );
				}
		    }, false);
		}

		// MARK AS LOADED
		fp.loaded.push( 'gtm-footer' );
	}

	// INIT FOOTER SCRIPTS
	if ( fp.loaded.indexOf('gtm') != -1 ) FP.fns.load_gtm_footer();

} )(window);
