;(function(window){

	// load on pageload
	if ( fp.gtm.id ) load_gtm();

	function load_gtm() {

		// CREATE DATALAYER AND FILL IT WITH ALL BASIC DATA

		fp.gtm.datalayer = fp.gtm.datalayer == 'default' ? 'dataLayer' : 'fupi_dataLayer';

		window[fp.gtm.datalayer] = window[fp.gtm.datalayer] || [];

		var data_o = {};

		// PAGE TYPE
		if ( fp.gtm.page_type && fp.data.wp.page_type && fp.data.wp.page_type.length > 1 )
			data_o['page type'] = fp.data.wp.page_type;

		// USER ID
		if ( fp.gtm.user_id && fp.data.wp.user_id )
			data_o['user id'] = window.btoa(fp.data.wp.user_id).split('=').join('');

		// PAGE LANGUAGE
		if ( fp.gtm.page_lang )
			data_o['page lang'] = document.documentElement.lang || 'undefined';

		// USER BROWSER LANGUAGE
		if ( fp.gtm.browser_lang )
			data_o['browser lang'] = navigator.language;

		// USER ROLE
		if ( fp.gtm.user_role && fp.data.wp.user_role && fp.data.wp.user_role.length > 0)
			data_o['user role'] = fp.data.wp.user_role;

		// PAGE TITLE
		if ( fp.gtm.page_title ) {
			if ( fp.data.wp.page_title ) data_o['page title'] = fp.data.wp.page_title;
			data_o['seo title'] && document.title;
		}

		// PAGE ID
		if ( fp.gtm.page_id && fp.data.wp.page_id && fp.data.wp.page_id > 0 )
			data_o['page id'] = fp.data.wp.page_id;

		// PAGE NUMBER
		if ( fp.gtm.page_num && fp.data.wp.page_number > 0 )
			data_o['page number'] = fp.data.wp.page_number;

		// AUTHOR DISPLAY NAME
		if ( fp.gtm.author && fp.data.wp.author_name && fp.data.wp.author_name.length > 0 )
			data_o['author name'] = fp.data.wp.author_name;

		// AUTHOR ID
		if ( fp.gtm.author_id && fp.data.wp.author_id > 0 )
			data_o['author id'] = fp.data.wp.author_id;

		// PUBLISHED DATE
		if ( fp.gtm.post_date && fp.data.wp.published && fp.data.wp.published.length > 0 )
			data_o['publish date'] = fp.data.wp.published;

		// TAXONOMY TERMS
		if ( fp.gtm.terms && fp.data.wp.terms && fp.data.wp.terms.length > 0 ) {
			var term_a = fp.data.wp.terms.map( function (term_data) { return term_data.slug + ' (' + term_data.taxonomy + ')'; } );
			data_o['post terms'] = term_a.join(', ');
		}

		// SEARCH TERMS
		if ( fp.gtm.search_terms && fp.data.wp.search_query && fp.data.wp.search_query.length > 0 )
			data_o['search term'] = fp.data.wp.search_query;

		// NO OF SEARCH RESULTS
		if ( fp.gtm.search_results && fp.data.wp.search_results && fp.data.wp.search_results > 0 )
			data_o['search results'] = fp.data.wp.search_results;

		// PASS COOKIE INFO

		if ( fp.gtm.pass_cookies ) {

			data_o['cookie notice enabled'] = fp.gtm.pass_cookies && fp.notice && fp.notice.enabled ? true : false;

			if ( fp.cookies ) {
				for ( key in fp.cookies ) {
					data_o['cookies ' + key] = fp.cookies[key];
				}
			} else {
				data_o['cookies'] = false;
			}
		}

		window[fp.gtm.datalayer].push(data_o);

		// LOAD GTM

		(function(w,d,s,l,i){w[l]=w[l]||[];w[l].push({'gtm.start':
		new Date().getTime(),event:'gtm.js'});var f=d.getElementsByTagName(s)[0],
		j=d.createElement(s),dl=l!='dataLayer'?'&l='+l:'';j.async=true;j.src=
		'https://www.googletagmanager.com/gtm.js?id='+i+dl;f.parentNode.insertBefore(j,f);
		})(window,document,'script',fp.gtm.datalayer,fp.gtm.id);

		// LOAD FOOTER SCRIPTS
		fp.loaded.push('gtm');
		if( FP.fns.load_gtm_footer ) FP.fns.load_gtm_footer();

		
	}

})(window);
