;(function(window){

	FP.fns.load_hotj_footer = function() {

		// TAG WITH PAGE TYPE

		if ( fp.hotj.tag_pagetype ) {
			if ( fp.data['_hotjar'] && fp.data['_hotjar']['page type'] ) {
				hj( 'tagRecording', [ 'page type ' + fp.data['_hotjar']['page type'] ] );
			} else if ( fp.data.wp.page_type ) {
				hj( 'tagRecording', [ 'page type ' + fp.data.wp.page_type ] );
			};
		};

		// TAG OUTBOUND LINKS

		var tag_outbound = function ( e, link ) {
			hj( 'tagRecording', [ 'outbound link click', 'outbound ' +  link.href ] );
			if ( fp.data.vars.debug ) console.log('HJ tag: outbound click', link.href);
		};

		if ( fp.hotj.tag_outbound ) FP.registerAction( ['on_click', 'on_middle_click'], 'outbound', [tag_outbound] );

		// TAG AFFILIATE LINKS

		var tag_affiliate_links = function ( e, link, name ) {
			hj( 'tagRecording', [ 'affiliate link click', 'affiliate ' + name ] );
			if ( fp.data.vars.debug ) console.log('HJ tag: affiliate click', name);
		};

		if ( fp.hotj.tag_affiliate ) {
			FP.splitTextarea( 'hotj', 'tag_affiliate' );
			FP.registerAction( ['on_click', 'on_middle_click'], 'affiliate', [tag_affiliate_links, fp.hotj.tag_affiliate] );
		};

		// TAG CLICKS ON EMAIL & TEL LINKS

		var tag_email_tel = function ( e, return_val ) {
			hj( 'tagRecording', [ 'contact link click', 'contact ' + return_val[0].href ] );
			if ( fp.data.vars.debug ) console.log('HJ tag: contact click', return_val[0].href);
		};

		if ( fp.hotj.tag_email_tel ) FP.registerAction( ['on_click', 'on_middle_click'], 'email_tel', [tag_email_tel] );

		// TAG FILE DOWNLOADS

		var tag_downloads = function ( e, filename ) {
			hj( 'tagRecording', [ 'file download', 'download ' +  filename] );
			if ( fp.data.vars.debug ) console.log('HJ tag: download', filename);
		};

		if ( fp.hotj.tag_file_downl ) FP.registerAction( ['on_click', 'on_middle_click'], 'downl', [tag_downloads, fp.hotj.tag_file_downl] );

		// TAG SPECIFIC ELEMENTS

		var tag_elems = function ( e, el, name ) {
			hj( 'tagRecording', [ 'page element click ' + name ] );
			if ( fp.data.vars.debug ) console.log('HJ tag: element click', name);
		};

		if ( fp.hotj.tag_elems ) {
			FP.splitTextarea( 'hotj', 'tag_elems' );
			FP.registerAction( ['on_click', 'on_middle_click'], 'elem', [tag_elems, fp.hotj.tag_elems] );
		};

		// TAG FORM SUBMITS

		var tag_forms = function ( e, title ) {
			var name = title || location.host + location.pathname;
			hj( 'tagRecording', [ 'form submit', 'form ' + name ] );
			if ( fp.data.vars.debug ) console.log('HJ tag: form submit', name);
		};

		if ( fp.hotj.tag_forms ) {
			FP.splitTextarea( 'hotj', 'tag_forms' );
			FP.registerAction( 'on_form_submit', false, [ tag_forms, fp.hotj.tag_forms ] );
		}

		// TRACK VIEWS OF ELEMENTS

		var send_el_view_evt = function ( el ) {
			var name = el.dataset['fp_hotj_name'] || 'name not provided';
			hj( 'tagRecording', [ 'element view', name + ' viewed' ] );
			if ( fp.data.vars.debug ) console.log('HJ tag: element view', name);
		};

		if ( fp.hotj.tag_views ) {
			FP.splitTextarea( 'hotj', 'tag_views' );
			var selectors_a = FP.prepareElsForIntersObserver( fp.hotj.tag_views, 'fp_hotj_name' );

			if ( selectors_a.length > 0 ) {
				var selectors_s = selectors_a.join(',');
				FP.intersectionObserver('hotj_views', selectors_s, { rootMargin: '-200px 0px -200px 0px' }, send_el_view_evt, true);
			}
		}

		// TAG CLICKS IN ANCHORS

		var tag_anchor_clicks = function ( e, link ) {
			var href = link.getAttribute('href');
			hj( 'tagRecording', [ 'anchor link click', 'anchor ' + href ] );
			if ( fp.data.vars.debug ) console.log('HJ tag: anchor click', href);
		};

		if ( fp.hotj.tag_anchor_clicks) FP.registerAction( 'on_click', 'anchors', [tag_anchor_clicks] );

		// TAG WITH UTM PARAMETERS
		if ( fp.hotj.tag_utm && document.location.href.indexOf( 'utm_source' ) != -1 ) {

			var utm_tags = [],
			utm_vals = [ 'utm_source', 'utm_medium', 'utm_campaign', 'utm_term', 'utm_content' ];

			utm_vals.forEach( function (utm_name) {
				var utm_val = FP.getUrlParamByName( utm_name );
				if ( utm_val && utm_val.length > 1 ) utm_tags.push( utm_name + ' ' + decodeURI( utm_val ) );
			} )

			if ( utm_tags.length > 0 ) {
				hj( 'tagRecording', utm_tags );
				if ( fp.data.vars.debug ) console.log('HJ tag: UTM tags', utm_tags);
			}
		};

		// MARK AS LOADED
		fp.loaded.push( 'hotj-footer' );
	}

	// INIT FOOTER SCRIPTS
	if ( fp.loaded.indexOf('hotj') != -1 ) FP.fns.load_hotj_footer();

})(window);
