;(function(window){

	// load on pageload
	if ( allow_loading() ) load_hotj();

	// Load on event
	document.addEventListener('fp_load_scripts', function (e) {
		switch (e.detail[0]) {
			case 'all':
			case 'hotj':
				if ( allow_loading() ) load_hotj();
			break;
		}
	});

	// FUNCTIONS

	function allow_loading(){
		 var isAllowedToLoad = FP.isAllowedToLoad( 'hotj', ['stats'], ['id'] ); // module id in fp.XX, required cookie permission, setting name with required data (like in fp.gtm.setting_name)
		 return isAllowedToLoad;
	}

	function load_hotj() {

		window.hj=window.hj||function(){(hj.q=hj.q||[]).push(arguments)};

		// LOAD HOTJAR

	    (function(h,o,t,j,a,r){
	        h.hj=h.hj||function(){(h.hj.q=h.hj.q||[]).push(arguments)};
	        h._hjSettings={hjid:fp.hotj.id,hjsv:6};
	        a=o.getElementsByTagName('head')[0];
	        r=o.createElement('script');r.async=1;
	        r.src=t+h._hjSettings.hjid+j+h._hjSettings.hjsv;
	        a.appendChild(r);
	    })(window,document,'https://static.hotjar.com/c/hotjar-','.js?sv=');

		// TAG WITH PAGE AUTHOR

		if ( fp.hotj.tag_pageauthor && fp.data.wp.author_name ) {
			hj( 'tagRecording', [ 'page author ' + fp.data.wp.author_name ] );
		};

		// TAG WITH USER ROLE AND STATUS

		if ( fp.hotj.tag_user_role && fp.data.wp.user_role ) {
			hj( 'tagRecording', [ 'user role ' + fp.data.wp.user_role ] );
		};

		// TAG WITH JS ERRORS
		// THX: https://medium.com/@Esakkimuthu/track-javascript-errors-and-how-to-fix-the-errors-60e160851296
		if ( fp.hotj.tag_js_err ) {
			window.onerror = function( msg, src, lineno, colno, err) {
				var errDetails = err ? err.stack : ('Script: '+ src + ', Line:'+ lineno + ', Column: '+ colno );
				hj( 'tagRecording', ['JS error', errDetails ] );
				if ( fp.data.vars.debug ) console.log('HJ tag: js error', errDetails);
			}
		}

		// SEND USER ATTRIBUTES TO HOTJAR
		if ( fp.hotj.identif_users ) {

			// identify user
			var params = {},
				userID = fp.data.wp.user_id ? window.btoa(fp.data.wp.user_id).split('=').join('') : null;

			// decide what attributes to send
			if ( fp.hotj.user_attr && Array.isArray(fp.hotj.user_attr) ) {
				fp.hotj.user_attr.forEach( function(attr) {
					switch (attr) {
						case 'role':
							if ( fp.data.wp.user_role ) {
								params.role = fp.data.wp.user_role;
							};
						break;
						case 'email':
							if ( fp.data.wp.user_email ) {
								params.email = fp.data.wp.user_email;
							};
						break;
					}
				})
			}

			// send data
			hj( 'identify', userID, params );
		}

		// LOAD FOOTER SCRIPTS
		fp.loaded.push('hotj');
		if( FP.fns.load_hotj_footer ) FP.fns.load_hotj_footer();

		

	}

})(window);
