;(function(window){

	FP.fns.load_insp_footer = function() {

		// TAG WITH PAGE TYPE

		if ( fp.insp.tag_pagetype ) {
			if ( fp.data['_inspectlet'] && fp.data['_inspectlet']['page type'] ) {
				__insp.push( [ 'tagSession', 'page type: ' + fp.data['_inspectlet']['page type'] ] );
			} else if ( fp.data.wp.page_type ) {
				__insp.push( [ 'tagSession', 'page type: ' + fp.data.wp.page_type ] );
			};
		};

		// TAG OUTBOUND LINKS

		var tag_outbound = function ( e, link ) {
			__insp.push( [ 'tagSession', 'outbound link click: ' + link.href ] );
			if ( fp.data.vars.debug ) console.log('INSP tag: outbound click', link.href);
		};
		if ( fp.insp.tag_outbound ) FP.registerAction( ['on_click', 'on_middle_click'], 'outbound', [tag_outbound] );

		// TAG AFFILIATE LINKS

		var tag_affiliate_links = function ( e, link, name ) {
			__insp.push( [ 'tagSession', 'affiliate link click: ' + name ] );
			if ( fp.data.vars.debug ) console.log('INSP tag: affiliate click', name);
	 	};

		if ( fp.insp.tag_affiliate ) {
			FP.splitTextarea( 'insp', 'tag_affiliate' );
			FP.registerAction( ['on_click', 'on_middle_click'], 'affiliate', [tag_affiliate_links, fp.insp.tag_affiliate] );
		};

		// TAG CLICKS ON EMAIL & TEL LINKS

		var tag_email_tel = function ( e, return_val ) {
			__insp.push( [ 'tagSession', 'contact link click: ' + return_val[0].href ] );
			if ( fp.data.vars.debug ) console.log('INSP tag: contact click', return_val[0].href);
	 	};
		if ( fp.insp.tag_email_tel ) FP.registerAction( ['on_click', 'on_middle_click'], 'email_tel', [tag_email_tel] );

		// TAG FILE DOWNLOADS

		var tag_downloads = function ( e, filename ) {
			__insp.push( [ 'tagSession', 'file download: ' + filename] );
			if ( fp.data.vars.debug ) console.log('INSP tag: download', filename);
		};
		if ( fp.insp.tag_file_downl ) FP.registerAction( ['on_click', 'on_middle_click'], 'downl', [tag_downloads, fp.insp.tag_file_downl] );

		// TAG SPECIFIC ELEMENTS

		var tag_elems = function ( e, el, name ) {
			__insp.push( [ 'tagSession', 'page element click: ' + name ] );
			if ( fp.data.vars.debug ) console.log('INSP tag: element click', name);
		 };

		if ( fp.insp.tag_elems ) {
			FP.splitTextarea( 'insp', 'tag_elems' );
			FP.registerAction( ['on_click', 'on_middle_click'], 'elem', [tag_elems, fp.insp.tag_elems] );
		};

		// TAG FORM SUBMITS

		var tag_forms = function ( e, title ) {
			var name = title || location.host + location.pathname;
			__insp.push( [ 'tagSession', 'form submit: ' + name ] );
			if ( fp.data.vars.debug ) console.log('INSP tag: form submit', name);
		};

		if ( fp.insp.tag_forms ) {
			FP.splitTextarea( 'insp', 'tag_forms' );
			FP.registerAction( 'on_form_submit', false, [ tag_forms, fp.insp.tag_forms ] );
		};

		// TRACK VIEWS OF ELEMENTS

		var send_el_view_evt = function ( el ) {
			var name = el.dataset['fp_insp_name'] || 'name not provided';
			__insp.push( [ 'tagSession', 'element view: ' + name ] );
			if ( fp.data.vars.debug ) console.log('INSP tag: element view', name);
		};

		if ( fp.insp.tag_views ) {
			FP.splitTextarea( 'insp', 'tag_views' );
			var selectors_a = FP.prepareElsForIntersObserver( fp.insp.tag_views, 'fp_insp_name' );

			if ( selectors_a.length > 0 ) {
				var selectors_s = selectors_a.join(',');
				FP.intersectionObserver('insp_views', selectors_s, { rootMargin: '-200px 0px -200px 0px' }, send_el_view_evt, true);
			}
		}

		// TAG CLICKS IN ANCHORS

		var tag_anchor_clicks = function ( e, link ) {
			__insp.push( [ 'tagSession', 'anchor click: ' + link.textContent ] );
			if ( fp.data.vars.debug ) console.log('INSP tag: anchor click', link.textContent);
		};
		if ( fp.insp.tag_anchor_clicks) FP.registerAction( 'on_click', 'anchors', [tag_anchor_clicks] );

		// TAG WITH REFERRING SITE

		if ( fp.insp.tag_referrer && document.referrer.length > 0 && document.referrer.indexOf( document.location.origin ) == -1 ) {
			__insp.push( [ 'tagSession', 'referrer ' + document.referrer ] );
			if ( fp.data.vars.debug ) console.log('INSP tag: referrer', document.referrer);
		};

		// TAG WITH UTM PARAMETERS

		if ( fp.insp.tag_utm && document.location.href.indexOf( 'utm_source' ) != -1 ) {

			var utm_tags = [],
			utm_vals = [ 'utm_source', 'utm_medium', 'utm_campaign', 'utm_term', 'utm_content' ];

			utm_vals.forEach( function (utm_name) {
				var utm_val = FP.getUrlParamByName( utm_name );
				if ( utm_val && utm_val.length > 1 ) utm_tags.push( utm_name + ' ' + decodeURI( utm_val ) );
			} )

			if ( utm_tags.length > 0 ) {
				__insp.push( [ 'tagSession', utm_tags.join(', ') ] );
				if ( fp.data.vars.debug ) console.log('INSP tag: UTM tags', utm_tags);
			}
		};

		// MARK AS LOADED

		fp.loaded.push( 'insp-footer' );
	}

	// INIT FOOTER SCRIPTS
	if ( fp.loaded.indexOf('insp') != -1 ) FP.fns.load_insp_footer();

})(window);
