;(function(window){

	FP.fns.load_pla_footer = function() {

		// NEW TRACKING - BLIND SPOT TRACKING - TRACK CLIKS IN "DECLINE COOKIES" BUTTON 2

		var track_declinecookies_btn = function ( e, el, name ) { {
			plausible( name );
			if ( fp.data.vars.debug ) console.log('PLA event:', name);
		} };

		if ( fp.pla.track_cookie_decline_2 ) {
			var decline_btn_selector = fp.notice.use_custom_notice && fp.notice.custom_decline_cookies_class ? fp.notice.custom_decline_cookies_class : '#fupi_decline_cookies_btn';
			FP.registerAction( 'on_click', 'elem', [ track_declinecookies_btn, [ [ decline_btn_selector, fp.pla.track_cookie_decline_2 ] ] ] );
		};

		// NEW TRACKING - BLIND SPOT TRACKING - DETECT ADBLOCK 2

		if ( fp.pla.detect_adblock_2 ) {
			if ( ! fp.pla.detect_adblock_per_session || ( fp.pla.detect_adblock_per_session && fp.data.vars.new_session ) ) {
				FP.runAdblockTest();
				setTimeout(
					function () {
						if ( FP.isAdblockEnabled() ) {
							plausible( fp.pla.detect_adblock_2 );
							if ( fp.data.vars.debug ) console.log( 'PLA event: adblock detected');
						}
					}, 1000
				)
			}
		};

		// NEW TRACKING - TRACK CLICKS ON EMAIL & TEL LINKS

		var track_contact_links = function ( e, return_val ) {

			var props = {
				'target' : return_val[0].href,
				'type' : return_val[1],
			};

			plausible( fp.pla.track_contact_links, {'props': props} );
			if ( fp.data.vars.debug ) console.log( 'PLA event: contact click: ', props );
		};

		if ( fp.pla.track_contact_links ) FP.registerAction( ['on_click', 'on_middle_click'], 'email_tel', [track_contact_links] );

		// NEW TRACKING - AFFILIATE TRACKING

		var track_affiliate_links_2 = function ( e, link, name ) {
			plausible( fp.pla.track_affiliate_goalname, {'props': { 'link' : name }} );
			if ( fp.data.vars.debug ) console.log('PLA event: affiliate link click: ', name );
		};

		if ( fp.pla.track_affiliate_goalname && fp.pla.track_affiliate_2 ) {
			FP.splitTextarea( 'pla', 'track_affiliate_2' );
			FP.registerAction( ['on_click', 'on_middle_click'], 'affiliate', [track_affiliate_links_2, fp.pla.track_affiliate_2] );
		};

		// NEW TRACKING - PAGE ELEMENT TRACKING

		var track_elems_2 = function ( e, link, name ) {
			plausible( fp.pla.track_elems_goalname, {'props': { 'page element' : name }} );
			if ( fp.data.vars.debug ) console.log('PLA event: page element click: ', name );
		};

		if ( fp.pla.track_elems_goalname && fp.pla.track_elems_2 ) {
			FP.splitTextarea( 'pla', 'track_elems_2' );
			FP.registerAction( ['on_click', 'on_middle_click'], 'elem', [track_elems_2, fp.pla.track_elems_2] );
		};

		// NEW TRACKING - FORM SUBMISSIONS

		var track_forms_2 = function ( e, name ) {
			plausible( fp.pla.track_forms_goalname, {'props': { 'form' : name }} );
			if ( fp.data.vars.debug ) console.log('PLA event: form submission: ', name );
		};

		if ( fp.pla.track_forms_goalname && fp.pla.track_forms_2 ) {
			FP.splitTextarea( 'pla', 'track_forms_2' );
			FP.registerAction( 'on_form_submit', false, [track_forms_2, fp.pla.track_forms_2] );
		};

		// NEW TRACKING - FILE DOWNLOADS

		var track_downloads = function ( e, filename ) {
			plausible( fp.pla.track_file_downl_goalname, {'props': { 'file' : filename } } );
			if ( fp.data.vars.debug ) console.log('PLA event: file download: ', filename );
		};

		if ( fp.pla.track_file_downl_goalname && fp.pla.track_file_downl ) FP.registerAction( ['on_click', 'on_middle_click'], 'downl', [track_downloads, fp.pla.track_file_downl] );

		// OLD TRACKING - TRACK SPECIFIC ELEMENTS

		var track_elems = function ( e, el, name ) {
			if ( name ) {
				plausible( name );
				if ( fp.data.vars.debug ) console.log('PLA event:', name);
			}
		};

		if ( fp.pla.track_elems ) {
			FP.splitTextarea( 'pla', 'track_elems' );
			FP.registerAction( ['on_click', 'on_middle_click'], 'elem', [track_elems, fp.pla.track_elems] );
		};

		// OLD TRACKING - TRACK FORMS

		var track_forms = function ( e, name ) { if ( name ) {
			plausible( name );
			if ( fp.data.vars.debug ) console.log('PLA event:', name);
		}};

		if ( fp.pla.track_forms ) {
			FP.splitTextarea( 'pla', 'track_forms' );
			FP.registerAction( 'on_form_submit', false, [ track_forms, fp.pla.track_forms ] );
		};

		// OLD TRACKING - TRACK AFFILIATE LINKS

		var track_affiliate_links = function ( e, link, name ) { if ( name ) {
			plausible( name );
			if ( fp.data.vars.debug ) console.log('PLA event:', name);
		}};

		if ( fp.pla.track_affiliate ) {
			FP.splitTextarea( 'pla', 'track_affiliate' );
			FP.registerAction( ['on_click', 'on_middle_click'], 'affiliate', [track_affiliate_links, fp.pla.track_affiliate] );
		};

		// OLD TRACKING - TRACK CLICKS ON EMAIL & TEL LINKS

		var track_email_tel = function ( e, ret_val ) {

			if ( fp.pla.track_tel_links && ret_val[1] == 'tel' ) {
				plausible( fp.pla.track_tel_links );
				if ( fp.data.vars.debug ) console.log('PLA event:', name);
			};

			if ( fp.pla.track_mail_links && ret_val[1] == 'mail' ) {
				plausible( fp.pla.track_mail_links );
				if ( fp.data.vars.debug ) console.log('PLA event:', name);
			};
		};

		if ( fp.pla.track_tel_links || fp.pla.track_mail_links) FP.registerAction( ['on_click', 'on_middle_click'], 'email_tel', [track_email_tel] );

		// OLD TRACKING - TRACK CLICKS IN COOKIE NOTICE BUTTONS

		var track_cookie_btns = function ( e, el, name ) { {
			plausible( name );
			if ( fp.data.vars.debug ) console.log('PLA event:', name);
		} };

		if ( fp.pla.track_cookie_agree_all || fp.pla.track_cookie_agree_some || fp.pla.track_cookie_decline ) {
			var cookie_btns = [];
			if ( fp.pla.track_cookie_agree_all ) cookie_btns.push( ['#fp_agree_to_all_cookies_btn', fp.pla.track_cookie_agree_all] );
			if ( fp.pla.track_cookie_agree_some ) cookie_btns.push( ['#fp_agree_to_selected_cookies_btn', fp.pla.track_cookie_agree_some] );
			if ( fp.pla.track_cookie_decline ) cookie_btns.push( ['#fp_decline_cookies_btn', fp.pla.track_cookie_decline] );
			if ( cookie_btns.length > 0 ) FP.registerAction( 'on_click', 'elem', [track_cookie_btns, cookie_btns] );
		};

		// OLD TRACKING - DETECT ADBLOCK

		if ( fp.pla.detect_adblock ) {
			FP.runAdblockTest();
			setTimeout(
				function () {
					if ( FP.isAdblockEnabled() ) {
						var name = fp.pla.detect_adblock;
						plausible( name );
						if ( fp.data.vars.debug ) console.log( 'PLA event:', name );
					}
				}, 1000
			)
		};

		// MARK AS LOADED

		fp.loaded.push( 'pla-footer' );
	}

	// INIT FOOTER SCRIPTS
	if ( fp.loaded.indexOf('pla') != -1 ) FP.fns.load_pla_footer();

} )(window);
