;(function(window){

	FP.fns.load_sbee_footer = function () {

		// TRACK AFFILIATE LINKS

		var track_affiliate_links = function ( e, link, name ) {
			splitbee.track( 'Affiliate: ' + name );
			if ( fp.data.vars.debug ) console.log('SBEE event: Affiliate: ' + name);
		};

		if ( fp.sbee.track_affiliate ) {
			FP.splitTextarea( 'sbee', 'track_affiliate' );
			FP.registerAction( ['on_click', 'on_middle_click'], 'affiliate', [track_affiliate_links, fp.sbee.track_affiliate] );
		};

		// TRACK CLICKS ON EMAIL & TEL LINKS

		var track_email_tel = function ( e, return_val ) {
			splitbee.track( return_val[1] + ' link click: ' +  return_val[0].href )
			if ( fp.data.vars.debug ) console.log('SBEE event: ' +  return_val[1] + ' link click: ' +  return_val[0].href);
		};

		if ( fp.sbee.track_email_tel ) FP.registerAction( ['on_click', 'on_middle_click'], 'email_tel', [track_email_tel] );

		// TRACK FILE DOWNLOADS

		var track_downloads = function ( e, filename ) {
			splitbee.track( 'Downloaded ' + filename );
			if ( fp.data.vars.debug ) console.log('SBEE event: Download', filename);
		}

		if ( fp.sbee.track_file_downl ) FP.registerAction( ['on_click', 'on_middle_click'], 'downl', [track_downloads, fp.sbee.track_file_downl] );

		// TRACK CLICKS ON SPECIFIC ELEMENTS

		var track_elems = function ( e, el, name ) {
			splitbee.track( 'Page click: ' +   name );
			if ( fp.data.vars.debug ) console.log('SBEE event: Page click: ' + name);
		};

		if ( fp.sbee.track_elems ) {
			FP.splitTextarea( 'sbee', 'track_elems' );
			FP.registerAction( ['on_click', 'on_middle_click'], 'elem', [track_elems, fp.sbee.track_elems] );
		};

		// TRACK CLICKS ON SPECIFIC ELEMENTS

		var track_cookies_btns = function ( e, el, name ) {
			splitbee.track( name );
			if ( fp.data.vars.debug ) console.log('SBEE event: ' + name);
		};

		if ( fp.sbee.track_c_notice_btns ) {
			var settings = [],
				decline_sel = fp.notice.use_custom_notice && fp.notice.custom_decline_cookies_class ? fp.notice.custom_decline_cookies_class : '#fupi_decline_cookies_btn',
				agree_sel = fp.notice.use_custom_notice && fp.notice.custom_agree_cookies_class ? fp.notice.custom_agree_cookies_class : '#fupi_agree_to_all_cookies_btn';

			settings.push( [ decline_sel, 'Decline cookies btn click' ] );
			settings.push( [ agree_sel, 'Agree to all cookies btn click' ] );
			settings.push( [ '#fupi_agree_to_selected_cookies_btn', 'Agree to some cookies btn click' ] );

			FP.registerAction( 'on_click', 'elem', [ track_cookies_btns, settings ] );
		};

		// TRACK FORMS

		var track_forms = function ( e, title ) {
			var name = title || location.host + location.pathname;
			splitbee.track( 'Form submit: ' + name );
			if ( fp.data.vars.debug ) console.log('SBEE event: Form submit: ' + name);
		};

		if ( fp.sbee.track_forms ) {
			FP.splitTextarea( 'sbee', 'track_forms' );
			FP.registerAction( 'on_form_submit', false, [ track_forms, fp.sbee.track_forms ] );
		}

		// MARK AS LOADED
		fp.loaded.push( 'sbee-footer' );
	}

	// INIT FOOTER SCRIPTS
	if ( fp.loaded.indexOf('sbee') != -1 ) FP.fns.load_sbee_footer();

} )(window);
