;(function(window){

	// load on pageload
	if ( allow_loading() ) load_sbee();

	// Load on event
	document.addEventListener('fp_load_scripts', function (e) {
		switch (e.detail[0]) {
			case 'all':
			case 'sbee':
				if ( allow_loading() ) load_sbee();
			break;
		}
	});

	// FUNCTIONS

	function allow_loading(){
		if ( fp.sbee.no_cookies ) {
			return FP.isAllowedToLoad( 'sbee', [], [] );
		} else {
			return FP.isAllowedToLoad( 'sbee', ['stats', 'personalisation'], [] ); // module id in fp.XX, required cookie permission, setting name with required data (like in fp.gtm.setting_name)
		}
	}

	function after_sbee_loads(){

		// TRACK LOGIN STATUS & USER ROLE
		if ( fp.sbee.track_user_role && fp.data.wp.user_role && fp.data.wp.user_role.length > 0 ) {
			splitbee.user.set( { 'role': fp.data.wp.user_role } );
		}

		// TRACK USER EMAIL
		if ( fp.sbee.track_user_email && fp.data.wp.user_email && fp.data.wp.user_email.length > 5 ) {
			splitbee.user.set( { 'email': fp.data.wp.user_email } );
		}

		// LOAD FOOTER SCRIPTS
		fp.loaded.push('sbee');
		if( FP.fns.load_sbee_footer ) FP.fns.load_sbee_footer();

		
	}

	function load_sbee() {

		var script_name = 'sb',
			async = 'async',
			no_cookies = false;

		if ( fp.sbee.enable_ab_tests ){
			script_name = 'sb-ab';
			if ( fp.sbee.no_async ) async = false; // prevents flash of original content
		}

		if ( fp.sbee.no_cookies ) no_cookies = true;

	    FP.getScript('https://cdn.splitbee.io/' + script_name + '.js', after_sbee_loads, { 'async' : async, 'data-no-cookie' : no_cookies });

	}

})(window);
